#if defined(__ANDROID__)

// Allow use of stuff in <time.h>
#define FORBIDDEN_SYMBOL_EXCEPTION_time_h

// Disable printf override in common/forbidden.h to avoid
// clashes with log.h from the Android SDK.
// That header file uses
//   __attribute__ ((format(printf, 3, 4)))
// which gets messed up by our override mechanism; this could
// be avoided by either changing the Android SDK to use the equally
// legal and valid
//   __attribute__ ((format(printf, 3, 4)))
// or by refining our printf override to use a varadic macro
// (which then wouldn't be portable, though).
// Anyway, for now we just disable the printf override globally
// for the Android port
#define FORBIDDEN_SYMBOL_EXCEPTION_printf

#include "backends/platform/android/android.h"
#include "gob/goblin.h"
#include "gob/hotspots.h"
#include "gob/vector.h"
#include "engines/engine.h"
#include "backends/platform/android/jni.h"

#include "backends/platform/android/button.h"
#include "backends/platform/android/textbutton.h"
#include "backends/platform/android/android_common.h"






//Gob 1 image

const char* filenameButtonHotspot1="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/buttonhotspot.png";
const char* filenameButtonAction1="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/buttonact.png";
const char* filenameButtonGob1="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/buttongob.png";
const char* filenameButtonMenu1="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/buttonmenu.png";
const char* filenameSkip="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/flechedroite.png";
const char* filenameMenu="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/fondmenu.png";
const char* filenamePopup="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/popup_fond.png";
const char* filenameBG1="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/bg_ingame.png";
const char* filenameBorder1="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/border_ingame.png";

const char* filenameGameoverbuttonok="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/popup_ok.bmp";
const char* filenameGameover="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/gameover.png";
const char* filenameEndlvlbuttonok="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/popup_okbig.bmp";
const char* filenameHotspot="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/point_exclamation_bleu.bmp";
const char* filenameButton1="/sdcard/Android/data/com.dotemu.gobliiins/files/gob/Gob1/button.png";
const char* filenameButtonSmall1="/sdcard/Android/data/com.dotemu.gobliiins/files/gob/Gob1/button_small.png";

//Gob 2 image 

const char* filenameButtonHotspot2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/buttonhotspot.png";
const char* filenameButtonAction2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/buttonact.png";
const char* filenameButtonGob2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/buttongob.png";
const char* filenameButtonMenu2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/buttonmenu.png";
const char*  filenameMenu2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/fondmenu2.png";
const char* filenameMenuExtra2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/fondmenuextra2.png";
const char* filenameBG2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/bg_ingame.png";
const char* filenameBorder2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/border_ingame.png";


//gob3 image 

const char* filenameButtonHotspot3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/buttonhotspot.png";
const char* filenameButtonAction3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/buttonact.png";
const char* filenameButtonGob3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/buttongob.png";
const char* filenameButtonMenu3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/buttonmenu.png";
const char*  filenameMenu3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/fondmenu3.png";
const char* filenameJournal="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/journal.bmp";
const char* filenameBG3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/bg_ingame.png";
const char* filenameBorder3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/border_ingame.png";
const char* filenameMenuExtra3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/fondmenuextra3.png";
//EN
//Gob 1 image with text


char*  EfilenameLoading="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/image_with_text/en/loading.png";

char*  EfilenameGameoverbuttoncancel="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/image_with_text/en/popup_cancel.bmp";


//Gob2 image with text


char*  EfilenameLoading2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/image_with_text/en/loading2.png";
char*  EfilenameSaving2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/image_with_text/en/saving2.png";


//gob3 image with text


char*  EfilenameLoading3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/image_with_text/en/loading3.png";
char*  EfilenameSaving3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/image_with_text/en/saving3.png";


 
//fr
//Gob 1 image with text


char*  FfilenameLoading="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/image_with_text/fr/loading.png";

char*  FfilenameGameoverbuttoncancel="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/image_with_text/fr/popup_cancel.bmp";

//Gob2 image with text

char*  FfilenameLoading2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/image_with_text/fr/loading2.png";
char*  FfilenameSaving2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/image_with_text/fr/saving2.png";

//gob3 image with text

char*  FfilenameLoading3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/image_with_text/fr/loading3.png";
char*  FfilenameSaving3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/image_with_text/fr/saving3.png";

//Localized text

char* stringOK="OK";

//EN
char* EstringRestart="Restart";
char* EstringResume="Resume";
char* EstringSettings="Settings";
char* EstringQuit="Quit";
char* EstringSave="Save";
char* EstringLoad="Load";
char* EstringExtras="Extras";
char* EstringBack="Back";
char* EstringHint="Hints";
char* EstringMoveTo="Move To";
char* EstringGoal="Objective";
char* EstringNews="Newspaper";
char* EstringTooClose="Your gobliins are too close! Use the cursor or move one of them!";
char* EstringTitleGameOver="GameOver!";
char* EstringTextGameOver="Game Over! Try again!";
char* EstringTitleEndLvl="Level Cleared";
char* EstringCongratulation="Congratulations!";
char* EstringTextEndLvl="Next level is this way!";
char* EstringYES="YES";
char* EstringNO="NO";

//FR
char* FstringRestart="Recommencer";
char* FstringResume="Continuer";
char* FstringSettings="Options";
char* FstringQuit="Quitter";
char* FstringSave="Sauvegarder";
char* FstringLoad="Charger";
char* FstringExtras="Extras";
char* FstringBack="Retour";
char* FstringHint="Astuces";
char* FstringMoveTo="Voyager";
char* FstringGoal="Objectif";
char* FstringNews="Journal";
char* FstringTooClose="Vos Gobliins sont trop proches. Utilisez le curseur ou s\351parez-les!"; // \351 ( octal ) = 233 ( décimal ) = é
char* FstringTitleGameOver="Fin du jeu!";
char* FstringTextGameOver="C'est perdu! Recommencez!";
char* FstringTitleEndLvl="Niveau Termin\351";
char* FstringCongratulation="F\351licitations!";
char* FstringTextEndLvl="Le niveau suivant, c'est par ici!";
char* FstringYES="OUI";
char* FstringNO="NON";

//RU
char* RUstringRestart="Заново";
char* RUstringResume="Продолжить";
char* RUstringSettings="Settings";
char* RUstringQuit="Выход";
char* RUstringSave="Сохранить";
char* RUstringLoad="Загрузить";
char* RUstringExtras="Дополнительно";
char* RUstringBack="Назад";
char* RUstringHint="Подсказки";
char* RUstringMoveTo="Перейти";
char* RUstringGoal="Цель";
char* RUstringNews="Газета";
char* RUstringTooClose="Гоблины слишком близко! Используйте указатель или переместите одного из них!"; // \351 ( octal ) = 233 ( décimal ) = é
char* RUstringTitleGameOver="Игра окончена!";
char* RUstringTextGameOver="Игра окончена! Попробуйте еще раз!";
char* RUstringTitleEndLvl="Уровень пройден!";
char* RUstringCongratulation="Поздравляем!";
char* RUstringTextEndLvl="Вас ждет следующий уровень!";
char* RUstringYES="ДА";
char* RUstringNO="НЕТ";

//PL
char* PLstringRestart="Restartuj";
char* PLstringResume="Wznów";
char* PLstringSettings="Settings";
char* PLstringQuit="Wyjście";
char* PLstringSave="Zapisz";
char* PLstringLoad="Wczytaj";
char* PLstringExtras="Dodatki";
char* PLstringBack="Wstecz";
char* PLstringHint="Wskazówki";
char* PLstringMoveTo="Przejdź do";
char* PLstringGoal="Cel";
char* PLstringNews="Gazeta";
char* PLstringTooClose="Twoje gobliny są zbyt blisko! Użyj kursora lub przesuń jednego z nich!"; // \351 ( octal ) = 233 ( décimal ) = é
char* PLstringTitleGameOver="Koniec gry!";
char* PLstringTextGameOver="Koniec gry! Spróbuj ponownie!";
char* PLstringTitleEndLvl="Poziom pokonany";
char* PLstringCongratulation="Gratulacje!";
char* PLstringTextEndLvl="Oto droga do następnego poziomu!";
char* PLstringYES="TAK";
char* PLstringNO="NIE";

TextButton back;
Button onOff;
Button menuButton;
Button action;
Button skip;
Button gameovercancel;
Button gameoverok;
Button switchgob;
TextButton leave;
TextButton resume;
TextButton restart;
TextButton save;
TextButton load;
Button endlvlok;
TextButton moveTo;
TextButton hint;
TextButton settings;
TextButton extras;
TextButton journal;
SaveLoadView saveLoadView;
bool bLoadingIntro=true;
extern bool bSaving;

extern bool WarningMessage;
extern dotemuBmpFont _bmpFont_black;
extern dotemuBmpFont _bmpFont_white;
extern Common::Rect game_screen;
//HintView hintView;

extern bool bMoveTo;

Common::Point oldPos;

bool Top=false;
extern bool SimuMoveTo;
extern bool SimuJournal;
unsigned int numSlot;
extern bool bSimu;
extern bool bPause;
extern bool bExtras;
extern bool bShowSkipButton;
extern bool bInGame;
extern bool bGoHotspot;
extern bool next;
extern int numberGobliin;

extern bool bSave;
extern int scrollValue;
extern int scrollY;

extern bool bNoUpdateHotspot;
extern bool bNoUpdateClic;
extern Vector< Gob::Hotspots::Hotspot* > _HotspotObj_temp;

extern int idLvlToLoad;
extern bool bGameOverOn;
extern bool bExit;


extern bool showHotspot;
extern bool sendEvent;
extern Vector< Gob::Goblin::Gob_Object* > _HotspotObj;
extern Vector< Gob::Hotspots::Hotspot > _HotspotObj_2;

uint16 secondCharactTop=0;
uint16 secondCharactLeft=0;
uint16 secondCharactRight=0;
uint16 secondCharactBottom=0;
bool secondCharactEnable=false;
uint16 firstCharactTop=0;
uint16 firstCharactLeft=0;
uint16 firstCharactRight=0;
uint16 firstCharactBottom=0;
bool firstCharactEnable=false;


extern int numGobliiin;
extern int gobAction;
extern bool bPause;

extern bool bSimulation;
extern int currentGame;
extern bool bLoading;
extern bool bBagOn;
extern bool bReload;

extern int posx;
extern int posy;

extern int idLvlCourant;
extern bool nextGob;
extern bool fakePos;
int GobLanguage=1;

float rounded(float value){
	
	int intvalue= (int)value;
	if(value-intvalue <=0.5)
		floor(value);
	else ceil(value);
	
	return value;
}

void OSystem_Android::initPath()
{
	
	if(GobLanguage==1){//EN

		debugdot("ENGLISH\n");

		//Gob 1 image with text
	       filenameLoading=EfilenameLoading;
	      
	     //  filenameGameoverbuttoncancel=EfilenameGameoverbuttoncancel;
	       

		

		//Gob2 image with text
	       
	       filenameLoading2=EfilenameLoading2;
	      filenameSaving2=EfilenameSaving2;
		//gob3 image with text
	       
	     
	       filenameLoading3=EfilenameLoading3;
	     filenameSaving3=EfilenameSaving3;

		//Localized text
		stringRestart=EstringRestart;
		stringResume=EstringResume;
		stringSettings=EstringSettings;
		stringQuit=EstringQuit;
		stringSave=EstringSave;
		stringLoad=EstringLoad;
		stringExtras=EstringExtras;
		stringBack=EstringBack;
		stringHint=EstringHint;
		stringMoveTo=EstringMoveTo;
		stringNews=EstringNews;
		stringTooClose=EstringTooClose;
		stringTitleGameOver=EstringTitleGameOver;
		stringTextGameOver=EstringTextGameOver;
		stringTitleEndLvl=EstringTitleEndLvl;
		stringCongratulation=EstringCongratulation;
		stringTextEndLvl=EstringTextEndLvl;
		stringYES=EstringYES;
		stringNO=EstringNO;
		stringGoal=EstringGoal;
	} else if(GobLanguage==2){//FR

		debugdot("FRENCH\n");

		//Gob 1 image with text
	       filenameLoading=FfilenameLoading;
	      
	      // filenameGameoverbuttoncancel=FfilenameGameoverbuttoncancel;
	     
		
		//Gob2 image with text
	       
	       
	       filenameLoading2=FfilenameLoading2;
		filenameSaving2=FfilenameSaving2;
	      

		//gob3 image with text
	       
	     
	       filenameLoading3=FfilenameLoading3;
		filenameSaving3=FfilenameSaving3;
	      

		//Localized text
		stringRestart=FstringRestart;
		stringResume=FstringResume;
		stringSettings=FstringSettings;
		stringQuit=FstringQuit;
		stringSave=FstringSave;
		stringLoad=FstringLoad;
		stringExtras=FstringExtras;
		stringBack=FstringBack;
		stringHint=FstringHint;
		stringMoveTo=FstringMoveTo;
		stringNews=FstringNews;
		stringTooClose=FstringTooClose;
		stringTitleGameOver=FstringTitleGameOver;
		stringTextGameOver=FstringTextGameOver;
		stringTitleEndLvl=FstringTitleEndLvl;
		stringCongratulation=FstringCongratulation;
		stringTextEndLvl=FstringTextEndLvl;
		stringYES=FstringYES;
		stringNO=FstringNO;
		stringGoal=FstringGoal;
	}
	else if(GobLanguage == 3) //RU - Not use for now. Need to change the font.
	{
		debugdot("RUSSIAN\n");

		//Gob 1 image with text
	    filenameLoading=EfilenameLoading;

		//Gob2 image with text
	    filenameLoading2=EfilenameLoading2;
		filenameSaving2=EfilenameSaving2;
	      
		//gob3 image with text
	    filenameLoading3=EfilenameLoading3;
		filenameSaving3=EfilenameSaving3;
	      
		//Localized text
		stringRestart 			= RUstringRestart;
		stringResume 			= RUstringResume;
		stringSettings 			= RUstringSettings;
		stringQuit 				= RUstringQuit;
		stringSave				= RUstringSave;
		stringLoad				= RUstringLoad;
		stringExtras			= RUstringExtras;
		stringBack				= RUstringBack;
		stringHint				= RUstringHint;
		stringMoveTo			= RUstringMoveTo;
		stringNews				= RUstringNews;
		stringTooClose			= RUstringTooClose;
		stringTitleGameOver		= RUstringTitleGameOver;
		stringTextGameOver		= RUstringTextGameOver;
		stringTitleEndLvl		= RUstringTitleEndLvl;
		stringCongratulation	= RUstringCongratulation;
		stringTextEndLvl		= RUstringTextEndLvl;
		stringYES				= RUstringYES;
		stringCongratulation	= RUstringNO;
		stringGoal				= RUstringGoal;
	}
	else if(GobLanguage == 4) //PL - Not use for now. Need to change the font.
	{
		debugdot("POLISH\n");

		//Gob 1 image with text
	    filenameLoading=EfilenameLoading;

		//Gob2 image with text
	    filenameLoading2=EfilenameLoading2;
		filenameSaving2=EfilenameSaving2;      

		//gob3 image with text
	    filenameLoading3=EfilenameLoading3;
		filenameSaving3=EfilenameSaving3;
	      
		//Localized text
		stringRestart 			= PLstringRestart;
		stringResume 			= PLstringResume;
		stringSettings 			= PLstringSettings;
		stringQuit 				= PLstringQuit;
		stringSave				= PLstringSave;
		stringLoad				= PLstringLoad;
		stringExtras			= PLstringExtras;
		stringBack				= PLstringBack;
		stringHint				= PLstringHint;
		stringMoveTo			= PLstringMoveTo;
		stringNews				= PLstringNews;
		stringTooClose			= PLstringTooClose;
		stringTitleGameOver		= PLstringTitleGameOver;
		stringTextGameOver		= PLstringTextGameOver;
		stringTitleEndLvl		= PLstringTitleEndLvl;
		stringCongratulation	= PLstringCongratulation;
		stringTextEndLvl		= PLstringTextEndLvl;
		stringYES				= PLstringYES;
		stringCongratulation	= PLstringNO;
		stringGoal				= PLstringGoal;
	}
}

void OSystem_Android::updateHotspot(){
	//debugdot("**Util:: UpdateHotspot bPause %d,  bNoUpdateHotspot=%d,bNoUpdateClic =%d",bPause,bNoUpdateHotspot,bNoUpdateClic);
	if( !bPause /*&& !bBagOn*/ && !bNoUpdateHotspot && !bNoUpdateClic){
		_HotspotObj_2.clear();
		//debugdot("NumberGobliiin = %d",numberGobliin);
		for( unsigned int i = 0; i < _HotspotObj_temp.size(); ++i )
		{
			if(_HotspotObj_temp[i]->id==32772){ // spot de secondCharact
					
				secondCharactLeft=_HotspotObj_temp[i]->left -scrollValue;
				secondCharactRight=_HotspotObj_temp[i]->right -scrollValue;
				secondCharactTop=_HotspotObj_temp[i]->top;
				secondCharactBottom=_HotspotObj_temp[i]->bottom;
				if(( secondCharactLeft > 0) &&  (secondCharactTop > 0) ){
					secondCharactEnable=true;
					Top=true;
					//debugdot("secondCharact est dans la place !!");
				}else if((secondCharactRight < 320) && (secondCharactBottom < 200)) {
					Top=false;
					secondCharactEnable=true;
				}else secondCharactEnable=false;
			}else
			if(_HotspotObj_temp[i]->id==32771){ // spot de firstCharact
				//debugdot("i=%d",i);
				//debugdot("left =%d , top = %d, right = %d , bottom = %d",spot.left,spot.top,spot.right,spot.bottom);

				firstCharactLeft=_HotspotObj_temp[i]->left-scrollValue;
				firstCharactRight=_HotspotObj_temp[i]->right-scrollValue;
				firstCharactTop=_HotspotObj_temp[i]->top;
				firstCharactBottom=_HotspotObj_temp[i]->bottom;
				if(( firstCharactLeft > 0) &&  (firstCharactTop > 0) ){
					firstCharactEnable=true;
					Top=true;
					//debugdot("firstCharact est dans la place !!");
				}else if( (firstCharactRight < 320) && (firstCharactBottom < 200)) {
					Top=false;
					firstCharactEnable=true;
				}
				else firstCharactEnable=false;
			}else
			_HotspotObj_2.push_back(*(_HotspotObj_temp[i]));
		}
	}

}

void OSystem_Android::displayHotspot(){
		
	if(currentGame==1)
		for( int i = 0; i < _HotspotObj.size(); ++i )
		{
			GLCALL(glPushMatrix());
			
			unsigned int centerhotspotX=(_HotspotObj[i]->left + (_HotspotObj[i]->right - _HotspotObj[i]->left)/2)*(game_screen.width())/320+game_screen.left;
			unsigned int centerhotspotY=(_HotspotObj[i]->top + (_HotspotObj[i]->bottom - _HotspotObj[i]->top)/2)*game_screen.height()/200;
			_hotspot_texture->setDrawRect(0-(_bmpSurfaceHotspot.w/2),0-(_bmpSurfaceHotspot.h/2),(_bmpSurfaceHotspot.w/2),(_bmpSurfaceHotspot.h/2));
			GLCALL(glTranslatef(centerhotspotX,centerhotspotY,0));
			GLCALL(glScalef((float)(game_screen.width())/320,(float)game_screen.height()/200,0));	
			_hotspot_texture->drawTextureRect();
			GLCALL(glPopMatrix());

		}
	if(currentGame==2)
		for( int i = 0; i < _HotspotObj_2.size(); ++i )
		{
			GLCALL(glPushMatrix());
			unsigned int centerhotspotX=(_HotspotObj_2[i].left + (_HotspotObj_2[i].right - _HotspotObj_2[i].left)/2)*(game_screen.width())/320+game_screen.left;
			unsigned int centerhotspotY=(_HotspotObj_2[i].top + (_HotspotObj_2[i].bottom - _HotspotObj_2[i].top)/2)*game_screen.height()/200;
			/*debugdot("bpause=%d",bPause);
			debugdot("Print Hotspot center = %d,%d", centerhotspotX,centerhotspotY);*/
			_hotspot_texture->setDrawRect(0-(_bmpSurfaceHotspot.w/2),0-(_bmpSurfaceHotspot.h/2),(_bmpSurfaceHotspot.w/2),(_bmpSurfaceHotspot.h/2));
			GLCALL(glTranslatef(centerhotspotX,centerhotspotY,0));
			GLCALL(glScalef((float)(game_screen.width())/320,(float)game_screen.height()/200,0));	
			_hotspot_texture->drawTextureRect();
			GLCALL(glPopMatrix());

		}
	if(currentGame==3){
		//updateHotspot();
		//debugdot("drawHotspot");
		for( int i = 0; i < _HotspotObj_2.size(); ++i )
		{
			//debugdot(" boucle : %d",i);
			
			if(_HotspotObj_2[i].left-scrollValue >0 && _HotspotObj_2[i].right-scrollValue<320){
				GLCALL(glPushMatrix());
					unsigned int centerhotspotX = ( (_HotspotObj_2[i].left-scrollValue) + ( (_HotspotObj_2[i].right-scrollValue) - (_HotspotObj_2[i].left-scrollValue) ) /2 ) * (game_screen.width())/320+game_screen.left;
					unsigned int centerhotspotY= ( (_HotspotObj_2[i].top-scrollY)  + ( (_HotspotObj_2[i].bottom-scrollY) - (_HotspotObj_2[i].top-scrollY))/2)*game_screen.height()/200;
					//debugdot("if : %d",i);
					/*debugdot("bpause=%d",bPause);
					debugdot("Print Hotspot center = %d,%d", centerhotspotX,centerhotspotY);*/
					_hotspot_texture->setDrawRect(0-(_bmpSurfaceHotspot.w/2),0-(_bmpSurfaceHotspot.h/2),(_bmpSurfaceHotspot.w/2),(_bmpSurfaceHotspot.h/2));
					GLCALL(glTranslatef(centerhotspotX,centerhotspotY,0));
					GLCALL(glScalef((float)(game_screen.width())/320,(float)game_screen.height()/200,0));	
					_hotspot_texture->drawTextureRect();
				GLCALL(glPopMatrix());
			}

		}
	}
	
	
}

void OSystem_Android::OnOffHotspot(){
	
	
	if(!_HotspotObj.empty() || bInGame)
	{
		if(currentGame!=1 && bPause){
			//test_textbutton.drawString(600,300,"clique ici et affiche les hotspots",70,false,false);
			//drawString(600,500,"clique ici et affiche les hotspots",70,false,false);
			//drawString(600,500,"SLOT",70,false,false);

		}
		
		if(showHotspot)
		{
			//debugdot("hotspot display");

			displayHotspot();
#ifdef TIMER_HOTSPOT 
			//debugdot("define  TIMER _ hotspot");
			_delayHotspot++;
			if(_delayHotspot>=250){
				_delayHotspot=0;
				showHotspot=false;
			}	
#endif
			//debugdot("hotspot displayed");
			//onOff.setSurface(&_bmpSurfaceOff);
			//debugdot("setSurface");
			//onOff.updateBuffer();
			//debugdot("updateBuffer()");
			

		}/*else {
			onOff.setSurface(&_bmpSurfaceOn);
			onOff.updateBuffer();
		
		}*/
			//debugdot("onoffbutton display");
			onOff.display();
			//debugdot("onoffbutton displayed");
			
			

	}else{
		//test_textbutton.setBoundToNull();
	 onOff.setBoundToNull();
	}
}

void OSystem_Android::MenuButton(){
	if(!_HotspotObj.empty() || bInGame){
		
		/*if(bPause){
			
			menuButton.setSurface(&_bmpSurfaceMenubuttonclose);
			menuButton.updateBuffer();
			
		}else {
			menuButton.setSurface(&_bmpSurfaceMenubuttonopen);
			menuButton.updateBuffer();
			
		}*/
		menuButton.display();
		
	
	}else 
		menuButton.setBoundToNull();
		
	
}





void OSystem_Android::SwapAction(){

	if(currentGame==1){
		
	
		if(!_HotspotObj.empty() && ! bReload)
		{
			bInGame=true;
			//debugdot("id = %d , idlvlCourant = %d",id,idLvlCourant);
			/*if(id!=idLvlCourant){
				if(idLvlCourant==1 || idLvlCourant==5){
					engrenage=17;main=18;pied=19;
				}
				if(idLvlCourant==2){
					  engrenage=19;main=20;pied=21;
				}
				if(idLvlCourant==3){
					  engrenage=18;main=19;pied=20;
				}
				if(idLvlCourant==4){
					  engrenage=15;main=16;pied=17;
				}
				if(idLvlCourant==6 || idLvlCourant==7 || idLvlCourant==18 || idLvlCourant==20 || idLvlCourant==21){
					  engrenage=13;main=14;pied=15;
				}
				if(idLvlCourant==8 || idLvlCourant==16 || idLvlCourant==19){
					  engrenage=14;main=15;pied=16;
				}
				if(idLvlCourant==9 || idLvlCourant==10 || idLvlCourant==11 || idLvlCourant==14 || idLvlCourant==15 || idLvlCourant==17){
					  engrenage=11;main=12;pied=13;
				}
				if(idLvlCourant==12){
					  engrenage=12;main=13;pied=0;
				}
				if(idLvlCourant==13 ){
					  engrenage=12;main=13;pied=14;
				}
				if(idLvlCourant==22 ){
					  engrenage=16;main=17;pied=18;
				}
				id=idLvlCourant;
				debugdot("!!!!!!!!!!! Reload action niveau !!!!!!!!!!!");
			}
			//debugdot("gobAction = %d ",gobAction);
		
			if(pied==gobAction) 
				action.setSurface(&_bmpSurfaceFeet);
			if(  engrenage==gobAction){ 
				switch (numGobliiin) {
					case 0 : action.setSurface(&_bmpSurfaceGear);
						 break;
					case 1 : action.setSurface(&_bmpSurfaceFist);
						 break;
					case 2 : action.setSurface(&_bmpSurfaceWand);break;
					default : debugdot("action :: error gob ");break;
				}
			}
			if(main==gobAction)
				 action.setSurface(&_bmpSurfaceHand);
			action.updateBuffer();*/
		}else {
			bInGame=false;
					
		}
	}

	if(currentGame==2|| currentGame==3){
		
		/*if (bInGame){
			
			if(bBagOn)
				action.setSurface(&_bmpSurfaceBagopen);
			else
				action.setSurface(&_bmpSurfaceBagclose);
		}
		action.updateBuffer();*/
	}
	if (!_HotspotObj.empty() || bInGame){
		action.display();
	}else {
		
		action.setBoundToNull();
	}
}

/*void OSystem_Android::drawString(){
	
	Font *font = _fonts[1];
	
	char numSlot[2];
	debugdot("sprintf");
	sprintf(numSlot, "%d", slotSave);
	char string[8]={'S','L','O','T',' '};
	debugdot("strcat");
	strcat(string,numSlot);
	debugdot("Draw SLOT %d",slotSave);
	font->drawString(string, 100, 100, getColor(_frontColor),getColor(_backColor), 1, *_spritesArray[_destSurface]);

}
*/

void OSystem_Android::switchGob(){
	
	
	if(!_HotspotObj.empty() || bInGame)
	{	
		
		if(currentGame==1){
			if(!nextGob){
				_oldPos=getEventManager()->getMousePos();
				oldPos=_oldPos;
			}
			
			
		
			
			/*switch (numGobliiin) {
						case 0 : switchgob.setSurface(&_bmpSurfacePicker);break;
						case 1 : switchgob.setSurface(&_bmpSurfaceFighter);break;
						case 2 : switchgob.setSurface(&_bmpSurfaceMage);break;
						default : debugdot("error gob");break;
					}*/
			
		}
		
		if(currentGame==2 ){
			if(!next && !SimuMoveTo){
				_oldPos=getEventManager()->getMousePos();
				oldPos=_oldPos;
				//_oldPosReel=Common::Point(posx,posy);				
			}
			
			/*switch (numGobliiin) {
						case 3 : switchgob.setSurface(&_bmpSurfaceFingus);break;
						case 1 : switchgob.setSurface(&_bmpSurfaceWinkle);break;
						case 2 : switchgob.setSurface(&_bmpSurfacePrince);break;
						default : ;break;
					}*/
			
		}
		if(currentGame==3){
			if(!next && !SimuMoveTo && !SimuJournal){
				_oldPos=getEventManager()->getMousePos();
				oldPos=_oldPos;
				//_oldPosReel=Common::Point(posx,posy);				
			}
		}
		
		//switchgob.updateBuffer();
		switchgob.display();
		
		
	}else switchgob.setBoundToNull();
}

void OSystem_Android::ShowTooCloseMessage(){
	//debugdot("Enter Too Close");
	if(WarningMessage){
		debugdot("Show TooClose Message");
		_waitShowWarning++;
		
	 	
		_message_texture->setDrawRect(boundMessage);
		_message_texture->drawTextureRect();
		drawString(game_screen.left+game_screen.width()/2,boundMessage.top+boundMessage.height()/2 , stringTooClose, 30*game_screen.height()/720);
		if(_waitShowWarning>=50){
			_waitShowWarning=0;	
			WarningMessage=false;
		}
	}


}

void OSystem_Android::Skip(){
	
	
	if(bShowSkipButton){
		skip.display();
	}else skip.setBoundToNull();
}

void OSystem_Android::loading(){
	//debugdot("**OSystem_Android : loading");
	if(bLoadingIntro){
		GLCALL(glPushMatrix());
			GLCALL(glTranslatef(LoadingCenterX,LoadingCenterY,0));
			_loading_texture->setDrawRect(boundLoading);
			_loading_texture->drawTextureRect();
		GLCALL(glPopMatrix());
	}
	
	if(bExit)
	{
		bPause = false;
		_waitExit++;
		GLCALL(glPushMatrix());
				GLCALL(glTranslatef(LoadingCenterX,LoadingCenterY,0));
				_loading_texture->setDrawRect(boundLoading);
				_loading_texture->drawTextureRect();
		GLCALL(glPopMatrix());
		
		if(_waitExit >= 80)
		{
			//_waitExit = 0;
			
			Common::Event e;

			if(_waitExit==80){
				e.type = Common::EVENT_LBUTTONDOWN;
				e.mouse.x =game_screen.width()/2+game_screen.left;
				e.mouse.y =game_screen.height();
				debugdot("simul clic down force quit");
				//clipMouse(e.mouse);

				lockMutex(_event_queue_lock);
				_event_queue.push(e);
				unlockMutex(_event_queue_lock);
				//g_engine->quitGame();
			}
			if(_waitExit==90){
				e.type = Common::EVENT_LBUTTONUP;
				e.mouse.x =game_screen.width()/2+game_screen.left;
				e.mouse.y =game_screen.height();
				debugdot("simul clic up force quit" );
				//clipMouse(e.mouse);
				
				lockMutex(_event_queue_lock);
				_event_queue.push(e);
				unlockMutex(_event_queue_lock);
				//g_engine->quitGame();
			}
			if(_waitExit==100){
				_waitExit=0;
				bExit = false;
			}
		}
		else
		{
			
			
			if(_waitExit==75)
			{
				debugdot("loading : bExit = %d ,i = %d",bExit,_waitExit);
				g_engine->quitGame();
			}
		}
	}
	//debugdot("loading = %d, simulation = %d , simu = %d",bLoading,bSimulation, bSimu);
	if(bSimulation || bLoading || bSimu){
		if(bMoveTo && currentGame==3 && bLoading)
				bMoveTo=false;
		if(currentGame==2 || currentGame==3){
			bPause=false;
			saveLoadView.enableDisplay(false);
		}
		
		GLCALL(glPushMatrix());
			//debugdot("loading : bsimulation = %d , bLoading = %d",bSimulation,bLoading);
			
			
			GLCALL(glTranslatef(LoadingCenterX,LoadingCenterY,0));
			
			_loading_texture->setDrawRect(boundLoading);
			_loading_texture->drawTextureRect();
		GLCALL(glPopMatrix());
	}

	if(bSaving){
		bPause=false;
		saveLoadView.enableDisplay(false);
		
		GLCALL(glPushMatrix());
			//debugdot("loading : bsimulation = %d , bLoading = %d",bSimulation,bLoading);
			
			
			GLCALL(glTranslatef(SavingCenterX,SavingCenterY,0));
			
			_saving_texture->setDrawRect(boundSaving);
			_saving_texture->drawTextureRect();
		GLCALL(glPopMatrix());
	}

	


	
	

	

}

unsigned int OSystem_Android::drawString(unsigned int x, unsigned int y, char* Str, float size,bool limited,bool bold,bool white){
	int posX=0;
	int posY=0;
	int xinit=x;
	int xMax=900;
	int word=0;
	int nbPixelAdd=0;
	
	float scaleX=size/65;// taille a afficher / taille de caractère
	float scaleY=size/65;// taille a afficher / taille de caractère
	float scaleXBold=scaleX+(float)(0.25*game_screen.width()/1280);
	
	if(white){
		_bmpFont=_bmpFont_white;
	}else
		_bmpFont=_bmpFont_black;
	//debugdot("la string est =%s!!!!",Str);
	

	for( unsigned int i = 0; Str[i]!=(char)0; i++ ){  // calcule de la taille pour centrage
		int XAdvance;
		if(bold)
			XAdvance = _bmpFont.getXAdvance(Str[i])*scaleXBold;
		else XAdvance = _bmpFont.getXAdvance(Str[i])*(scaleX);
		int height = _bmpFont.getHeight(Str[i])*scaleY;
		int offsetY = _bmpFont.getOffsetY(Str[i])*scaleY;
		posX+=XAdvance;
		if(height+offsetY>posY)
			posY=height+offsetY;
	}
	//debugdot("PosX = %d, x= %d",posX,x);
	int heightinit=posY;
	int xcalcul=x;
	bool bspace=true;
	bool endLine=true;
	if(!limited)
		x-=posX/2;
	y-=(size)/2;
	
	xinit=x;
	//debugdot("X= %d",x);
	for( unsigned int i = 0;Str[i]!=(char)0; i++ )
	{
		//xcalcul=x;
		
		if(limited&& endLine){
			posX=0;
			endLine=false;
			unsigned int mem=0;
			unsigned int word=0;
			if(Str[i]==' ')
				i++;
			for(unsigned int j=i;posX<=xMax;++j){
				unsigned int XAdvance;
				if(bold)
					XAdvance = _bmpFont.getXAdvance(Str[j])*scaleXBold;
				else XAdvance = _bmpFont.getXAdvance(Str[j])*scaleX;
				if(Str[j]==' '){
					word++;
					mem=posX;
				}
				posX+=XAdvance;
			}
			
			//debugdot("posX=%d, word=%d ",posX,word);
			unsigned int diffEndLine=xMax-mem; // nb pixel en trop
			//debugdot("diffEndLine= %d",diffEndLine);
			nbPixelAdd=diffEndLine/((word-1));
			//debugdot("nbPixel= %d",nbPixelAdd);
			posX=0;
		}
		//debugdot("Pos = %d ,Str[%d] = %c = %d",posX,i,Str[i],Str[i]);
		/*if(bspace && limited){
			for(unsigned j =i; Str[j]!=' ';j++){
				unsigned int XAdvance = _bmpFont_black.getXAdvance(Str[j])*scaleX;
				xcalcul+=XAdvance;
			}
			if(xcalcul>=xinit+1000){
				x=xinit;
				y=y+heightinit+5;
			}
			bspace=false;
		}
		if(Str[i]==' ') */
		int charX = _bmpFont.getPos(Str[i]).x;
		int charY = _bmpFont.getPos(Str[i]).y;
		float width = _bmpFont.getWidth(Str[i]);
		float height = _bmpFont.getHeight(Str[i]);
		float offsetX = (float)(_bmpFont.getOffsetX(Str[i])*scaleX);
		float offsetY = (float)(_bmpFont.getOffsetY(Str[i])*scaleY);
		int XAdvance = _bmpFont.getXAdvance(Str[i]);
//debugdot("offsetY+y+height*scaleY=%d",(int)(offsetY+y+height*scaleY));

		/*if(i==0 || i==1){
			debugdot("Str[%d]= %c,%d!",i,Str[i],Str[i]);
			debugdot("ScaleY = %2.2f",scaleY);
			debugdot("Height = %2.2f , width = %2.2f", height,width);
			debugdot("offsetX = %2.2f, offsetY = %2.2f", offsetX, offsetY);

		}*/

		/*if(black)
			_texte_texture->setTextureColorBlack();*/
		_texte_texture->allocBuffer(width,height);
		_texte_texture->updateBuffer(0,0,width,height,_bmpFont.getSurface()->pixels+charX*_bmpFont.getSurface()->format.bytesPerPixel+charY*_bmpFont.getSurface()->pitch,_bmpFont.getSurface()->pitch);

		offsetX=rounded(offsetX);
		offsetY=rounded(offsetY);
		
		height=(float)height*scaleY;
		height=rounded(height);
		
		if(bold)
			width=(float)width*scaleXBold;
		else width=(float)width*(scaleX);
		width=rounded(width);

		_texte_texture->setDrawRect(Common::Rect(x+offsetX,y+offsetY,(int)(x+offsetX+width),(int)(offsetY+y+height)));
		_texte_texture->drawTextureRect();
		if(Str[i]==' ' && limited){
			if(bold)
				x+=XAdvance*scaleXBold+nbPixelAdd;
			else x+=XAdvance*scaleX+nbPixelAdd;
		}else{
			if(bold)
				x+=XAdvance*scaleXBold;
			else x+=XAdvance*scaleX;
		}if(x>xinit+xMax && limited){
			//debugdot("x=%d xinit=%d",x,xinit);
			x=xinit;
			y=y+heightinit+5;
			endLine=true;
		}

	}
	return y+=heightinit+5;
	

}


void OSystem_Android::gameOver(){
	if(!bGameOverOn)
		return;
		
	_gameover_texture->setDrawRect(boundGameOver);
	_gameover_texture->drawTextureRect();

	_popup_texture->setDrawRect(boundPopup);
	_popup_texture->drawTextureRect();
	
	
	drawString((boundPopup.left+(boundPopup.width()*(float)377/640)),boundPopup.top+boundPopup.height()*66/400,stringTitleGameOver,40*game_screen.height()/720,false,true);
	drawString((boundPopup.left+(boundPopup.width()*(float)325/640)),boundPopup.top+boundPopup.height()*200/400,stringTextGameOver,30*game_screen.height()/720);
	
	/*_textepopup_texture->updateBuffer(0,0,_bmpSurfaceGameovertext.w,_bmpSurfaceGameovertext.h,_bmpSurfaceGameovertext.pixels,_bmpSurfaceGameovertext.pitch);
	_textepopup_texture->setDrawRect(boundPopup);
	_textepopup_texture->drawTextureRect();*/
	

	gameoverok.display();
	gameovercancel.display();

	drawString(CenterYES.x,CenterYES.y,stringYES,65*game_screen.height()/720,false,false,true);

	drawString(CenterNO.x,CenterNO.y,stringNO,65*game_screen.height()/720,false,false,true);	
			
			
}

void OSystem_Android::popupLvlEnd(){
	if(!bGoHotspot)
		return;
	//debugdot("draw popup");
	_popup_texture->setDrawRect(boundPopup);
	_popup_texture->drawTextureRect();
	
	drawString((boundPopup.left+(boundPopup.width()*(float)377/640)),boundPopup.top+boundPopup.height()*66/400,stringTitleEndLvl,40*game_screen.height()/720,false,true);
	drawString((boundPopup.left+(boundPopup.width()*(float)315/640)),boundPopup.top+boundPopup.height()*173/400,stringCongratulation,30*game_screen.height()/720);
	drawString((boundPopup.left+(boundPopup.width()*(float)325/640)),boundPopup.top+boundPopup.height()*220/400,stringTextEndLvl,30*game_screen.height()/720);

	/*_textepopup_texture->updateBuffer(0,0,_bmpSurfaceLevelEndText.w,_bmpSurfaceLevelEndText.h,_bmpSurfaceLevelEndText.pixels,_bmpSurfaceLevelEndText.pitch);
	_textepopup_texture->setDrawRect(boundPopup);
	_textepopup_texture->drawTextureRect();*/
	
	endlvlok.display();

	drawString(CenterOK.x,CenterOK.y,stringOK,65*game_screen.height()/720,false,false,true);

		

}

void OSystem_Android::ExtrasMenu()
{
	if(!bPause){
		hint.setBoundToNull();
		moveTo.setBoundToNull();
		journal.setBoundToNull();
		back.setBoundToNull();
		return;
	}
	
	_extra_texture->setDrawRect(boundMenExtra);
	_extra_texture->drawTextureRect();

	hint.drawString(stringHint,55*game_screen.height()/720);
	if(currentGame==2){
		moveTo.drawString(stringMoveTo,55*game_screen.height()/720);
	}else if(currentGame==3){
		journal.drawString(stringNews,55*game_screen.height()/720);
		moveTo.drawString(stringGoal,55*game_screen.height()/720);
	}
		
	back.drawString(stringBack,55*game_screen.height()/720);
}

void OSystem_Android::menu(){
	//debugdot(" Position Lettre A , x,y = %d,%d  w,h= %d,%d", _bmpFont.getPos(65).x,_bmpFont.getPos(65).y,_bmpFont.getWidth(65),_bmpFont.getHeight(65));
	//drawString(600, 500, "j'ecris une phrase beaucoup trop grande pour simplement tester ma fonction drawString qui devrait afficher cette string sur plusieur ligne, si ce n'est pas le cas, ma fonction n'est pas bonne.", 49,true);
	/*debugdot("hintView._hint.title=%s",hintView._hint.title);
	unsigned int y=drawString(900,100,hintView._hint.title,75,true);
	y=drawString(600,y,hintView._hint.hint1.question,50,true);
	y=drawString(600,y,hintView._hint.hint1.answer[0],25,true);*/
	if(!bPause || bExtras){
		resume.setBoundToNull();
		restart.setBoundToNull();
		save.setBoundToNull();
		hint.setBoundToNull();
		load.setBoundToNull();
		extras.setBoundToNull();
		settings.setBoundToNull();
		leave.setBoundToNull();
	 return;
	}
		
	_menu_texture->setDrawRect(boundMen);
	_menu_texture->drawTextureRect();		
				
			
	resume.drawString(stringResume,55*game_screen.height()/720);
	if(currentGame==1){
					
		restart.drawString(stringRestart,55*game_screen.height()/720);
		hint.drawString(stringHint,55*game_screen.height()/720);
		
		//_title_texture->setDrawRect(boundTitre);
		//_title_texture->drawTextureRect();
	}else
		if(currentGame==2 ||currentGame==3){
			save.drawString(stringSave,55*game_screen.height()/720);
			load.drawString(stringLoad,55*game_screen.height()/720);
			extras.drawString(stringExtras,55*game_screen.height()/720);
				
		}	
				
					
	settings.drawString(stringSettings,55*game_screen.height()/720);
	leave.drawString(stringQuit,55*game_screen.height()/720);
			
}

void OSystem_Android::Background(){
	if((!_HotspotObj.empty() || bInGame) && !saveLoadView.isEnable()){
		_bg_texture->setDrawRect(boundBG);
		_bg_texture->drawTextureRect();
		

	}


}

void OSystem_Android::Border(){
	if((!_HotspotObj.empty() || bInGame) && !saveLoadView.isEnable() && ! bGameOverOn ){
		_border_texture->setDrawRect(boundBorder);
		_border_texture->drawTextureRect();
	}
}

void OSystem_Android::loadImage(){
	initPath();
	//hintView.initPath();
	if(currentGame!=1)
		saveLoadView.initPath();

	

 	AbstractFSNode* _fileBitmap=_fsFactory->makeFileNodePath(filenameHotspot);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameHotspot);
	else {
		debugdot("lecture du fichier %s ",filenameHotspot);
		if(!_bmpHotspot.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameHotspot);
		else {
			_bmpSurfaceHotspot=*_bmpHotspot.surface();			
		}
	
	}
	
	_fileBitmap=_fsFactory->makeFileNodePath(filenameSkip);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameSkip);
	else {
		debugdot("lecture du fichier %s ",filenameSkip);
		if(!_pngSkip.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameSkip);
		else {
			_bmpSurfaceSkip=*_pngSkip.getSurface();	
			
		}
		
	}

	if(currentGame==1){

		_fileBitmap=_fsFactory->makeFileNodePath(filenameBG1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBG1);
		else {
			debugdot("lecture du fichier %s ",filenameBG1);
			if(!_pngBG.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBG1);
			else {
				_bmpSurfaceBG=*_pngBG.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameBorder1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBorder1);
		else {
			debugdot("lecture du fichier %s ",filenameBorder1);
			if(!_pngBorder.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBorder1);
			else {
				_bmpSurfaceBorder=*_pngBorder.getSurface();			
			}
		
		}
		
	
		

		

		
		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonHotspot1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonHotspot1);
		else {
			debugdot("lecture du fichier %s ",filenameButtonHotspot1);
			if(!_pngButtonHotspot.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonHotspot1);
			else {
				_bmpSurfaceButtonHotspot=*_pngButtonHotspot.getSurface();			
			}
		
		}


	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonAction1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonAction1);
		else {
			debugdot("lecture du fichier %s ",filenameButtonAction1);
			if(!_pngButtonAction.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonAction1);
			else {
				_bmpSurfaceButtonAction=*_pngButtonAction.getSurface();			
			}
		
		}

	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonGob1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonGob1);
		else {
			debugdot("lecture du fichier %s ",filenameButtonGob1);
			if(!_pngButtonGob.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonGob1);
			else {
				_bmpSurfaceButtonGob=*_pngButtonGob.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonMenu1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonMenu1);
		else {
			debugdot("lecture du fichier %s ",filenameButtonMenu1);
			if(!_pngButtonMenu.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonMenu1);
			else {
				_bmpSurfaceButtonMenu=*_pngButtonMenu.getSurface();			
			}
		
		}

	
		_fileBitmap=_fsFactory->makeFileNodePath(filenameGameover);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameGameover);
		else {
			debugdot("lecture du fichier %s ",filenameGameover);
			if(!_pngGameover.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameGameover);
			else {
				_bmpSurfaceGameover=*_pngGameover.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenamePopup);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenamePopup);
		else {
			debugdot("lecture du fichier %s ",filenamePopup);
			if(!_pngPopup.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenamePopup);
			else {
				_bmpSurfacePopup=*_pngPopup.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButton1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButton1);
		else {
			debugdot("lecture du fichier %s ",filenameButton1);
			if(!_pngButton.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButton1);
			else {
				_bmpSurfaceButton=*_pngButton.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonSmall1);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonSmall1);
		else {
			debugdot("lecture du fichier %s ",filenameButtonSmall1);
			if(!_pngButtonSmall.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonSmall1);
			else {
				_bmpSurfaceButtonSmall=*_pngButtonSmall.getSurface();			
			}
		
		}

		


		

		_fileBitmap=_fsFactory->makeFileNodePath(filenameLoading);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameLoading);
		else {
			debugdot("lecture du fichier %s ",filenameLoading);
		//		if(!_bmpLoading.loadStream(*(_fileBitmap->createReadStream())))
			if(!_pngLoading.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameLoading);
			else {
			//	_bmpSurfaceLoading=*_bmpLoading.surface();
				_bmpSurfaceLoading=*_pngLoading.getSurface();			
			}
		
		}

		


		_fileBitmap=_fsFactory->makeFileNodePath(filenameMenu);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameMenu);
		else {
			debugdot("lecture du fichier %s ",filenameMenu);
			if(!_pngMenu.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameMenu);
			else {
				_bmpSurfaceMenu=*_pngMenu.getSurface();			
			}
		
		}
		

		
	}

	if(currentGame==2){

		_fileBitmap=_fsFactory->makeFileNodePath(filenameSaving2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameSaving2);
		else {
			debugdot("lecture du fichier %s ",filenameSaving2);
		
			if(!_pngSaving.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameSaving2);
			else {
				_bmpSurfaceSaving=*_pngSaving.getSurface();			
			}
		
		}

			_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonHotspot2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonHotspot2);
		else {
			debugdot("lecture du fichier %s ",filenameButtonHotspot2);
			if(!_pngButtonHotspot.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonHotspot2);
			else {
				_bmpSurfaceButtonHotspot=*_pngButtonHotspot.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameBG2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBG2);
		else {
			debugdot("lecture du fichier %s ",filenameBG2);
			if(!_pngBG.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBG2);
			else {
				_bmpSurfaceBG=*_pngBG.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameBorder2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBorder2);
		else {
			debugdot("lecture du fichier %s ",filenameBorder2);
			if(!_pngBorder.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBorder2);
			else {
				_bmpSurfaceBorder=*_pngBorder.getSurface();			
			}
		
		}


	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonAction2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonAction2);
		else {
			debugdot("lecture du fichier %s ",filenameButtonAction2);
			if(!_pngButtonAction.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonAction2);
			else {
				_bmpSurfaceButtonAction=*_pngButtonAction.getSurface();			
			}
		
		}

	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonGob2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonGob2);
		else {
			debugdot("lecture du fichier %s ",filenameButtonGob2);
			if(!_pngButtonGob.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonGob2);
			else {
				_bmpSurfaceButtonGob=*_pngButtonGob.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonMenu2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonMenu2);
		else {
			debugdot("lecture du fichier %s ",filenameButtonMenu2);
			if(!_pngButtonMenu.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonMenu2);
			else {
				_bmpSurfaceButtonMenu=*_pngButtonMenu.getSurface();			
			}
		
		}

		

	

		

		_fileBitmap=_fsFactory->makeFileNodePath(filenameLoading2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameLoading2);
		else {
			debugdot("lecture du fichier %s ",filenameLoading2);
			if(!_pngLoading.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameLoading2);
			else {
				_bmpSurfaceLoading=*_pngLoading.getSurface();			
			}
		
		}

		


		_fileBitmap=_fsFactory->makeFileNodePath(filenameMenu2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameMenu2);
		else {
			debugdot("lecture du fichier %s ",filenameMenu2);
			if(!_pngMenu.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameMenu2);
			else {
				_bmpSurfaceMenu=*_pngMenu.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameMenuExtra2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameMenuExtra2);
		else {
			debugdot("lecture du fichier %s ",filenameMenuExtra2);
			if(!_pngMenuExtra.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameMenuExtra2);
			else {
				_bmpSurfaceMenuExtra=*_pngMenuExtra.getSurface();			
			}
		
		}
		
	}

	if(currentGame==3){

		_fileBitmap=_fsFactory->makeFileNodePath(filenameSaving3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameSaving3);
		else {
			debugdot("lecture du fichier %s ",filenameSaving3);
		
			if(!_pngSaving.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameSaving3);
			else {
				_bmpSurfaceSaving=*_pngSaving.getSurface();			
			}
		
		}

			_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonHotspot3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonHotspot3);
		else {
			debugdot("lecture du fichier %s ",filenameButtonHotspot3);
			if(!_pngButtonHotspot.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonHotspot3);
			else {
				_bmpSurfaceButtonHotspot=*_pngButtonHotspot.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameBG3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBG3);
		else {
			debugdot("lecture du fichier %s ",filenameBG3);
			if(!_pngBG.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBG3);
			else {
				_bmpSurfaceBG=*_pngBG.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameBorder3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBorder3);
		else {
			debugdot("lecture du fichier %s ",filenameBorder3);
			if(!_pngBorder.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBorder3);
			else {
				_bmpSurfaceBorder=*_pngBorder.getSurface();			
			}
		
		}
	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonAction3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonAction3);
		else {
			debugdot("lecture du fichier %s ",filenameButtonAction3);
			if(!_pngButtonAction.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonAction3);
			else {
				_bmpSurfaceButtonAction=*_pngButtonAction.getSurface();			
			}
		
		}

	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonGob3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonGob3);
		else {
			debugdot("lecture du fichier %s ",filenameButtonGob3);
			if(!_pngButtonGob.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonGob3);
			else {
				_bmpSurfaceButtonGob=*_pngButtonGob.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameButtonMenu3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonMenu3);
		else {
			debugdot("lecture du fichier %s ",filenameButtonMenu3);
			if(!_pngButtonMenu.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonMenu3);
			else {
				_bmpSurfaceButtonMenu=*_pngButtonMenu.getSurface();			
			}
		
		}

				




		_fileBitmap=_fsFactory->makeFileNodePath(filenameLoading3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameLoading3);
		else {
			debugdot("lecture du fichier %s ",filenameLoading3);
			if(!_pngLoading.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameLoading3);
			else {
				_bmpSurfaceLoading=*_pngLoading.getSurface();			
			}
		
		}

	

		_fileBitmap=_fsFactory->makeFileNodePath(filenameMenu3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameMenu3);
		else {
			debugdot("lecture du fichier %s ",filenameMenu3);
			if(!_pngMenu.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameMenu3);
			else {
				_bmpSurfaceMenu=*_pngMenu.getSurface();			
			}
		
		}

		_fileBitmap=_fsFactory->makeFileNodePath(filenameMenuExtra3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameMenuExtra3);
		else {
			debugdot("lecture du fichier %s ",filenameMenuExtra3);
			if(!_pngMenuExtra.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameMenuExtra3);
			else {
				_bmpSurfaceMenuExtra=*_pngMenuExtra.getSurface();			
			}
		
		}
		
	


	}




	
	
	

	

	//hintView.loadImage(_fsFactory);
	if(currentGame!=1)
		saveLoadView.loadImage(_fsFactory);
	//hintView.setBackMenuSurface(&_bmpSurfaceTitle);
			/*_hotspot_texture= new GLES8888Texture(); //_bmpSurface->format);
			_hotspot_texture->allocBuffer(64, 64); //(_bmpSurface->w, _bmpSurface->h);
			unsigned int *dst = new unsigned int[50*50];
			for(int i=0; i<50*50; i++)
				dst[i] = 0xFF0000FF;
			_hotspot_texture->setTexture(dst, 0, 0, 50, 50);*/
			//_bmp.setSurface(dst);
}


void OSystem_Android::initTexture(){

	LOGI("gameScreen = %d,%d %d,%d", game_screen.left,game_screen.right,game_screen.width(),game_screen.height());
	
	_texte_texture=new GLES8888Texture();
	_texte_texture->allocBuffer(_bmpFont_black.getSurface()->w,_bmpFont_black.getSurface()->h);

	//hintView.initTexture();
	if(currentGame!=1){
		saveLoadView.initTexture();
	}
	_hotspot_texture= new GLES8888Texture(); //_bmpSurfaceHotspot->format);
	_hotspot_texture->allocBuffer(_bmpSurfaceHotspot.w, _bmpSurfaceHotspot.h);

		/*unsigned int *dst = new unsigned int[50*50];
		for(int i=0; i<50*50; i++)
			dst[i] = 0xFF0000FF;
		//_hotspot_texture->setTexture(dst, 0, 0, 50, 50);*/
	_hotspot_texture->updateBuffer(0,0,_bmpSurfaceHotspot.w,_bmpSurfaceHotspot.h,_bmpSurfaceHotspot.pixels,_bmpSurfaceHotspot.pitch);
	//debugdot("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!onOff!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");

	_bg_texture= new GLES8888Texture();
	if(currentGame!=3){
		
		_bg_texture->allocBuffer(_bmpSurfaceBG.w, _bmpSurfaceBG.h);
		_bg_texture->updateBuffer(0,0,_bmpSurfaceBG.w,_bmpSurfaceBG.h,_bmpSurfaceBG.pixels,_bmpSurfaceBG.pitch);
		
	}else{
		unsigned int *dst = new unsigned int[10*10];
		for(int i=0; i<10*10; i++)
			dst[i] = 0xFF8C3C5A;
	 	_bg_texture->allocBuffer(10,10);
		_bg_texture->updateBuffer(0,0,10,10,dst,0);
	}
	boundBG=Common::Rect(0,0,game_screen.right+game_screen.left,game_screen.height());
	
	_border_texture= new GLES8888Texture(); //_bmpSurfaceHotspot->format);
	_border_texture->allocBuffer(_bmpSurfaceBorder.w, _bmpSurfaceBorder.h);
	_border_texture->updateBuffer(0,0,_bmpSurfaceBorder.w,_bmpSurfaceBorder.h,_bmpSurfaceBorder.pixels,_bmpSurfaceBorder.pitch);
	boundBorder=Common::Rect(game_screen.left-(14*(game_screen.right+game_screen.left)/1280),game_screen.top,game_screen.right+(14*(game_screen.right+game_screen.left)/1280),game_screen.bottom);
	
	onOff.setSurface(&_bmpSurfaceButtonHotspot);
	onOff.setCenter(game_screen.right+((game_screen.left+(14*(game_screen.right+game_screen.left)/1280))/2),game_screen.height()*3/8);
	onOff.setScale((float)(game_screen.left)/160+0.125,(float)(game_screen.left)/160+0.125);
	onOff.initTexture();

	debugdot("game_screen.left = %d , resultat=%f",game_screen.left, (float)(game_screen.left)/160);
	menuButton.setSurface(&_bmpSurfaceButtonMenu);
	menuButton.setCenter(game_screen.right+((game_screen.left+(14*(game_screen.right+game_screen.left)/1280))/2),game_screen.height()*1/8);
	menuButton.setScale((float)(game_screen.left)/160+0.125,(float)(game_screen.left)/160+0.125);
	menuButton.initTexture();

	action.setCenter(((game_screen.left-(14*(game_screen.right+game_screen.left)/1280))/2),game_screen.height()*3/8);
	action.setScale((float)(game_screen.left)/160+0.125,(float)(game_screen.left)/160+0.125);
	action.setSurface(&_bmpSurfaceButtonAction);
	action.initTexture();

	
	//debugdot("Scale = %2.3f, %2.3f",(float)(game_screen.right+game_screen.left)/1280,(float)game_screen.height()/720);
	switchgob.setCenter(((game_screen.left-(14*(game_screen.right+game_screen.left)/1280))/2),game_screen.height()*1/8);
	switchgob.setScale((float)(game_screen.left)/160+0.125,(float)(game_screen.left)/160+0.125);
	switchgob.setSurface(&_bmpSurfaceButtonGob);
	switchgob.initTexture();
	
	_menu_texture=new GLES8888Texture();
	_menu_texture->allocBuffer(_bmpSurfaceMenu.w,_bmpSurfaceMenu.h);
	_menu_texture->updateBuffer(0,0,_bmpSurfaceMenu.w,_bmpSurfaceMenu.h,_bmpSurfaceMenu.pixels,_bmpSurfaceMenu.pitch);

	MenuCenterX=game_screen.left+game_screen.width()/2;
	MenuCenterY=game_screen.height()/2;
	boundMen=Common::Rect(MenuCenterX-(_bmpSurfaceMenu.w/2)*(float)(game_screen.right+game_screen.left)/1280,MenuCenterY-(_bmpSurfaceMenu.h/2)*(float)game_screen.height()/720,MenuCenterX+(_bmpSurfaceMenu.w/2)*(float)(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h/2)*(float)game_screen.height()/720);
debugdot("menu");
	
	


	
	if(currentGame==1){
		
		
		
		restart.setFont(&_bmpFont_white);
		restart.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*6/17)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		restart.initTexture();

		resume.setFont(&_bmpFont_white);
		resume.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*3/17)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		resume.initTexture();

		hint.setFont(&_bmpFont_white);
		hint.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*9/17)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		hint.initTexture();

		settings.setFont(&_bmpFont_white);
		settings.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*12/17)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		settings.initTexture();

		leave.setFont(&_bmpFont_white);
		leave.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*15/17)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		leave.initTexture();

		back.setFont(&_bmpFont_white);
		back.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*15/17)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		back.initTexture();

		
		
		

		

		
		
		
		
		
	_gameover_texture=new GLES8888Texture();
	_gameover_texture->allocBuffer(_bmpSurfaceGameover.w,_bmpSurfaceGameover.h);
	_gameover_texture->updateBuffer(0,0,_bmpSurfaceGameover.w,_bmpSurfaceGameover.h,_bmpSurfaceGameover.pixels,_bmpSurfaceGameover.pitch);

	_popup_texture=new GLES8888Texture();
	_popup_texture->allocBuffer(_bmpSurfacePopup.w,_bmpSurfacePopup.h);
	_popup_texture->updateBuffer(0,0,_bmpSurfacePopup.w,_bmpSurfacePopup.h,_bmpSurfacePopup.pixels,_bmpSurfacePopup.pitch);
	

	

	
	gameOverCenterX=game_screen.left+game_screen.width()/2;
	gameOverCenterY=game_screen.height()/2;
	boundGameOver=Common::Rect(0,0,game_screen.right+game_screen.left+1,game_screen.bottom+1);

	
	popupCenterX=game_screen.left+game_screen.width()/2 ;
	popupCenterY=game_screen.height()/2;
	boundPopup=Common::Rect(popupCenterX-(_bmpSurfacePopup.w/2)*(float)(game_screen.right+game_screen.left)/1280,popupCenterY-(_bmpSurfacePopup.h/2)*(float)game_screen.height()/720,popupCenterX+(_bmpSurfacePopup.w/2)*(float)(game_screen.right+game_screen.left)/1280,popupCenterY+(_bmpSurfacePopup.h/2)*(float)game_screen.height()/720);

	CenterYES=Common::Point(popupCenterX+(_bmpSurfacePopup.w*205/640)*(game_screen.right+game_screen.left)/1280-(_bmpSurfacePopup.w/2)*(game_screen.right+game_screen.left)/1280,popupCenterY+(_bmpSurfacePopup.h*320/400)*game_screen.height()/720+(0-_bmpSurfacePopup.h/2)*game_screen.height()/720);

	gameoverok.setSurface(&_bmpSurfaceButtonSmall);
	gameoverok.setCenter(CenterYES.x,CenterYES.y);
	gameoverok.setScale((float)((game_screen.right+game_screen.left))/1280,(float)(game_screen.height())/720);
	gameoverok.initTexture();

	CenterNO=Common::Point(popupCenterX+(_bmpSurfacePopup.w*450/640)*(game_screen.right+game_screen.left)/1280-(_bmpSurfacePopup.w/2)*(game_screen.right+game_screen.left)/1280,popupCenterY+(_bmpSurfacePopup.h*320/400)*game_screen.height()/720+(0-_bmpSurfacePopup.h/2)*game_screen.height()/720);
	
	gameovercancel.setSurface(&_bmpSurfaceButtonSmall);
	gameovercancel.setCenter(CenterNO.x,CenterNO.y);
	gameovercancel.setScale((float)((game_screen.right+game_screen.left))/1280,(float)(game_screen.height())/720);
	gameovercancel.initTexture();

	CenterOK=Common::Point(popupCenterX+(_bmpSurfacePopup.w*328/640)*(game_screen.right+game_screen.left)/1280-(_bmpSurfacePopup.w/2)*(game_screen.right+game_screen.left)/1280,popupCenterY+(_bmpSurfacePopup.h*320/400)*game_screen.height()/720-(_bmpSurfacePopup.h/2)*game_screen.height()/720);
	
	endlvlok.setSurface(&_bmpSurfaceButton);
	endlvlok.setCenter(CenterOK.x,CenterOK.y);
	endlvlok.setScale((float)((game_screen.right+game_screen.left))/1280,(float)(game_screen.height())/720);
	endlvlok.initTexture();

	
	}


	if(currentGame==2 || currentGame==3){
		debugdot("currentGame= %d",currentGame);
	//initialiser les buttons pour saveLoad

		fond_message = new unsigned int[960*67];
		for(int i=0; i<960*67; i++)
			fond_message[i] = 0x78FFFFFF;
	

		_message_texture=new GLES8888Texture();
		_message_texture->allocBuffer(960,67);
		_message_texture->updateBuffer(0,0,960,67,fond_message,0);


		_saving_texture=new GLES8888Texture();
		_saving_texture->allocBuffer(_bmpSurfaceSaving.w,_bmpSurfaceSaving.h);

		_saving_texture->updateBuffer(0,0,_bmpSurfaceSaving.w,_bmpSurfaceSaving.h,_bmpSurfaceSaving.pixels,_bmpSurfaceSaving.pitch);
		SavingCenterX=game_screen.left+game_screen.width()/2;
		SavingCenterY=game_screen.height()/2;
		boundSaving=Common::Rect(0-SavingCenterX,0-SavingCenterY,SavingCenterX+1,SavingCenterY+1);


		
		boundMessage=Common::Rect(game_screen.left,game_screen.height()*53/320,game_screen.right,game_screen.height()*53/320+game_screen.height()*67/720);


		boundMenExtra=Common::Rect(MenuCenterX-(_bmpSurfaceMenuExtra.w/2)*(float)(game_screen.right+game_screen.left)/1280,MenuCenterY-(_bmpSurfaceMenuExtra.h/2)*(float)game_screen.height()/720,MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(float)(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h/2)*(float)game_screen.height()/720);
		
		_extra_texture=new GLES8888Texture();
		_extra_texture->allocBuffer(_bmpSurfaceMenuExtra.w,_bmpSurfaceMenuExtra.h);
		_extra_texture->updateBuffer(0,0,_bmpSurfaceMenuExtra.w,_bmpSurfaceMenuExtra.h,_bmpSurfaceMenuExtra.pixels,_bmpSurfaceMenuExtra.pitch);
		
		back.setFont(&_bmpFont_black);
		back.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*6.5/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		back.initTexture();

		moveTo.setFont(&_bmpFont_black);
		moveTo.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*3/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		moveTo.initTexture();

		hint.setFont(&_bmpFont_black);
		hint.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*1.25/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		hint.initTexture();


		
		
		if(currentGame==3){

		back.setFont(&_bmpFont_white);
		back.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*6.5/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		back.initTexture();

		moveTo.setFont(&_bmpFont_white);
		moveTo.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*3/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		moveTo.initTexture();

		hint.setFont(&_bmpFont_white);
		hint.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*1.25/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		hint.initTexture();
			
		journal.setFont(&_bmpFont_white);
		journal.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*4.75/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		journal.initTexture();


		resume.setFont(&_bmpFont_white);
		resume.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*2/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		resume.initTexture();

		extras.setFont(&_bmpFont_white);
		extras.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*10.25/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		extras.initTexture();

		settings.setFont(&_bmpFont_white);
		settings.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*13/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		settings.initTexture();

		leave.setFont(&_bmpFont_white);
		leave.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*15.75/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		leave.initTexture();
	

		save.setFont(&_bmpFont_white);
		save.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*4.75/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		save.initTexture();

		load.setFont(&_bmpFont_white);
		load.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*7.5/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		load.initTexture();

		
		}
	
		if(currentGame==2){
		
		back.setFont(&_bmpFont_black);
		back.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*6.5/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		back.initTexture();

		moveTo.setFont(&_bmpFont_black);
		moveTo.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*3/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		moveTo.initTexture();

		hint.setFont(&_bmpFont_black);
		hint.setCenter(MenuCenterX+(_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenuExtra.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenuExtra.h*1.25/8)*game_screen.height()/720+(0-_bmpSurfaceMenuExtra.h/2)*game_screen.height()/720);
		hint.initTexture();

		resume.setFont(&_bmpFont_black);
		resume.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*2/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		resume.initTexture();

		extras.setFont(&_bmpFont_black);
		extras.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*10.25/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		extras.initTexture();

		settings.setFont(&_bmpFont_black);
		settings.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*13/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		settings.initTexture();

		leave.setFont(&_bmpFont_black);
		leave.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*15.75/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		leave.initTexture();
	

		save.setFont(&_bmpFont_black);
		save.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*4.75/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		save.initTexture();


		load.setFont(&_bmpFont_black);
		load.setCenter(MenuCenterX+(_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280+(0-_bmpSurfaceMenu.w/2)*(game_screen.right+game_screen.left)/1280,MenuCenterY+(_bmpSurfaceMenu.h*7.5/18)*game_screen.height()/720+(0-_bmpSurfaceMenu.h/2)*game_screen.height()/720);
		load.initTexture();

			
		}

	
		
		
	}

	
	
	

	skip.setSurface(&_bmpSurfaceSkip);
	skip.setCenter(game_screen.right+((game_screen.left+(14*(game_screen.right+game_screen.left)/1280))/2),game_screen.height()*1/4);
	skip.setScale((float)(game_screen.left)/160,(float)(game_screen.left)/160);
	skip.initTexture();


	
	_loading_texture=new GLES8888Texture();
	_loading_texture->allocBuffer(_bmpSurfaceLoading.w,_bmpSurfaceLoading.h);

	
	
	
	
	

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


	


	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	debugdot("init texture :: game screen %d,%d",(game_screen.right+game_screen.left),game_screen.height());
	debugdot("init Texture ::Scale X =%f , Scale Y =%f",(float)((game_screen.right+game_screen.left))/480,(float)(game_screen.height())/320);


	
	
	
	//OffCenterX=(game_screen.left/2);
	//OffCenterY=(game_screen.height()*1/4);
	//boundOn=Common::Rect(0-_bmpSurfaceOff.w/2,0-_bmpSurfaceOff.h/2,(_bmpSurfaceOff.w/2),(_bmpSurfaceOff.h/2));
	//boundOff=Common::Rect(OffCenterX-(_bmpSurfaceOff.w/2)*game_screen.height()/200,OffCenterY-(_bmpSurfaceOff.h/2)*game_screen.height()/200,OffCenterX+(_bmpSurfaceOff.w/2)*game_screen.height()/200,OffCenterY+(_bmpSurfaceOff.h/2)*game_screen.height()/200);
	

	

	
	
	
	
	/*_menubutton_texture->updateBuffer(0,0,_bmpSurfaceMenubuttonopen.h,_bmpSurfaceMenubuttonopen.h,_bmpSurfaceMenubuttonopen.pixels,_bmpSurfaceMenubuttonopen.pitch);
	menubuttonCenterX=game_screen.right+game_screen.left/2;
	menubuttonCenterY=game_screen.height()*1/4;
	boundMenubut=Common::Rect(menubuttonCenterX-(_bmpSurfaceMenubuttonopen.w/2)*game_screen.height()/200,menubuttonCenterY-(_bmpSurfaceMenubuttonopen.h/2)*game_screen.height()/200,menubuttonCenterX+(_bmpSurfaceMenubuttonopen.w/2)*game_screen.height()/200,menubuttonCenterY+(_bmpSurfaceMenubuttonopen.h/2)*game_screen.height()/200);*/


	_loading_texture->updateBuffer(0,0,_bmpSurfaceLoading.w,_bmpSurfaceLoading.h,_bmpSurfaceLoading.pixels,_bmpSurfaceLoading.pitch);
	LoadingCenterX=game_screen.left+game_screen.width()/2;
	LoadingCenterY=game_screen.height()/2;
	boundLoading=Common::Rect(0-LoadingCenterX,0-LoadingCenterY,LoadingCenterX+1,LoadingCenterY+1);

	

	


	// Menu
	

	
	


	


	//game over
	
			
}

void OSystem_Android::updateFilter(bool filter){
	/*_loading_texture->setLinearFilter(filter);
	back.setFilter(filter);
	onOff.setFilter(filter);
	menuButton.setFilter(filter);
	action.setFilter(filter);
	skip.setFilter(filter);
	
	switchgob.setFilter(filter);
	leave.setFilter(filter);
	resume.setFilter(filter);
	if(currentGame==1){
			restart.setFilter(filter);
			endlvlok.setFilter(filter);
			gameovercancel.setFilter(filter);
			gameoverok.setFilter(filter);
	}else if (currentGame==2){
		save.setFilter(filter);
			load.setFilter(filter);
			moveTo.setFilter(filter);
			extras.setFilter(filter);
	}else if(currentGame==3){
		save.setFilter(filter);
			load.setFilter(filter);
			extras.setFilter(filter);
			journal.setFilter(filter);
			moveTo.setFilter(filter);
	
	}
	
	
	
	hint.setFilter(filter);
	settings.setFilter(filter);*/
}

#endif
