#ifndef DOTEMU_BITMAPFONT_H
#define DOTEMU_BITMAPFONT_H


#include "common/stream.h"
#include "common/rect.h"
#include "graphics/surface.h"
#include "graphics/decoders/bmp.h"
#include "graphics/decoders/png.h"
struct CharDescriptor
{
	//clean 16 bytes
	int x, y;
	int Width, Height;
	int XOffset, YOffset;
	int XAdvance;
	unsigned short Page;

	CharDescriptor() : x( 0 ), y( 0 ), Width( 0 ), Height( 0 ), XOffset( 0 ), YOffset( 0 ),
		XAdvance( 0 ), Page( 0 )
	{ }
};

struct Charset
{
	int LineHeight;
	int Base;
	int Width, Height;
	unsigned short Pages;
	CharDescriptor Chars[256];
};




class dotemuBmpFont{
private : 
	 Charset CharsetDesc;
	Graphics::Surface _bmpSurface;
	Graphics::PNGDecoder _png;
	

public :
	bool ParseFont(Common::SeekableReadStream* stream);
	void loadBmp(Common::SeekableReadStream* stream);
	char** Split(const char* tab, char cel);
	int getWidth(unsigned short IdAscii) { return CharsetDesc.Chars[IdAscii].Width; }
	int getHeight(unsigned short IdAscii) { return CharsetDesc.Chars[IdAscii].Height;}
	int getOffsetX(unsigned short IdAscii) { return CharsetDesc.Chars[IdAscii].XOffset;}
	int getOffsetY(unsigned short IdAscii) { return CharsetDesc.Chars[IdAscii].YOffset;}
	int getXAdvance(unsigned short IdAscii){ return CharsetDesc.Chars[IdAscii].XAdvance;}
	Common::Point getPos(unsigned short IdAscii) { return Common::Point(CharsetDesc.Chars[IdAscii].x,CharsetDesc.Chars[IdAscii].y);}
	Graphics::Surface* getSurface() { return &_bmpSurface; }
	 


};



#endif
