#include "saveloadview.h"
#include "backends/platform/android/jni.h"
#include "backends/platform/android/dotemubmpfont.h"

const char* filenameFlechedroite="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/flechedroite.png";
const char* filenameFlechegauche="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/flechegauche.png";
const char* filenameFondsaveload2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/fondsaveload.png";
const char* filenameBGbutton2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/button.png";
const char* filenameButtonSmall2="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/gob2/button_small.png";


const char* filenameSaveempty="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/icon_save_empty.png";
const char* filenameSaveicon="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/icon_save.png";
const char* filenameLoadempty="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/icon_load_empty.png";
const char* filenameLoadicon="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/icon_load.png";

const char* filenameFondsaveload3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/fondsaveload.png";
const char* filenameBGbutton3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/button.png";
const char* filenameButtonSmall3="/sdcard/Android/data/com.dotemu.gobliiins/files/Gob/gob3/button_small.png";

//Localized text
//EN
char* EstringLoadbutton="Load";
char* EstringSavebutton="Save";
char* EstringBackbutton="Back";
char* EstringSlotname="SLOT";
char* EstringEmpty="Empty";
//FR
char* FstringLoadbutton="Charger";
char* FstringSavebutton="Sauvegarder";
char* FstringBackbutton="Retour";
char* FstringSlotname="EMPLACEMENT";
char* FstringEmpty="Vide";

extern int currentGame;
extern Common::Rect game_screen;
extern unsigned int numSlot;
extern bool bSave;
extern bool bBagOn;
extern bool bResetAction;
extern int _mouseY;
extern int _mouseX;
extern int slotSave;
extern int bLoop2;
extern int loadLoop;
extern int loadEtat;
extern int saveLoop;
extern int saveEtat;
int bLoop3;
extern bool bLoading;
bool bSaving=false;
extern bool bLoaded;
int saveEtat;
int loadEtat;
extern int cpt;
extern dotemuBmpFont _bmpFont_black;

extern int GobLanguage;

extern float rounded(float value);

void SaveLoadView::initPath(){


	if(GobLanguage==1){ //EN
		
		//Localized text
		  stringLoadbutton=EstringLoadbutton;
		  stringSavebutton=EstringSavebutton;
		  stringBackbutton=EstringBackbutton;
		  stringSlotname=EstringSlotname;
		  stringEmpty=EstringEmpty;
		
	}else if(GobLanguage==2){
		

		//Localized text
		  stringLoadbutton=FstringLoadbutton;
		  stringSavebutton=FstringSavebutton;
		  stringBackbutton=FstringBackbutton;
		  stringSlotname=FstringSlotname;
		  stringEmpty=FstringEmpty;
	}

}

void SaveLoadView::loadImage(FilesystemFactory *fs){
	AbstractFSNode* _fileBitmap;

	_fileBitmap=fs->makeFileNodePath(filenameFlechedroite);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameFlechedroite);
	else {
		debugdot("lecture du fichier %s ",filenameFlechedroite);
		if(!_pngFlechedroite.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameFlechedroite);
		else {
			
			_bmpSurfaceFlechedroite=*_pngFlechedroite.getSurface();		
		}
		
	}

	_fileBitmap=fs->makeFileNodePath(filenameFlechegauche);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameFlechegauche);
	else {
		debugdot("lecture du fichier %s ",filenameFlechegauche);
		if(!_pngFlechegauche.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameFlechegauche);
		else {
			_bmpSurfaceFlechegauche=*_pngFlechegauche.getSurface();			
		}
		
	}

	_fileBitmap=fs->makeFileNodePath(filenameSaveempty);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameSaveempty);
	else {
		debugdot("lecture du fichier %s ",filenameSaveempty);
		if(!_pngSaveEmpty.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameSaveempty);
		else {
			_bmpSurfaceSaveEmpty=*_pngSaveEmpty.getSurface();	
				
		}
		
	}
	_fileBitmap=fs->makeFileNodePath(filenameSaveicon);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameSaveicon);
	else {
		debugdot("lecture du fichier %s ",filenameSaveicon);
		if(!_pngSaveIcon.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameSaveicon);
		else {
			_bmpSurfaceSaveIcon=*_pngSaveIcon.getSurface();	
				
		}
		
	}

	_fileBitmap=fs->makeFileNodePath(filenameLoadempty);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameLoadempty);
	else {
		debugdot("lecture du fichier %s ",filenameLoadempty);
		if(!_pngLoadEmpty.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameLoadempty);
		else {
			_bmpSurfaceLoadEmpty=*_pngLoadEmpty.getSurface();	
				
		}
		
	}
	_fileBitmap=fs->makeFileNodePath(filenameLoadicon);
	if(!_fileBitmap->exists())
		debugdot("erreur le fichier %s n'existe pas ", filenameLoadicon);
	else {
		debugdot("lecture du fichier %s ",filenameSaveicon);
		if(!_pngLoadIcon.loadStream(*(_fileBitmap->createReadStream())))
			debugdot("echec de la lecture du fichier %s",filenameLoadicon);
		else {
			_bmpSurfaceLoadIcon=*_pngLoadIcon.getSurface();	
				
		}
		
	}

	if(currentGame==2){
		

		_fileBitmap=fs->makeFileNodePath(filenameButtonSmall2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonSmall2);
		else {
			debugdot("lecture du fichier %s ",filenameButtonSmall2);
			if(!_pngButtonSmall.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonSmall2);
			else {
				_bmpSurfaceButtonSmall=*_pngButtonSmall.getSurface();			
			}
		
		}

		_fileBitmap=fs->makeFileNodePath(filenameBGbutton2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBGbutton2);
		else {
			debugdot("lecture du fichier %s ",filenameBGbutton2);
			if(!_pngButton.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBGbutton2);
			else {
				_bmpSurfaceButton=*_pngButton.getSurface();	
				
			}
		
		}

		

		

	

		_fileBitmap=fs->makeFileNodePath(filenameFondsaveload2);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameFondsaveload2);
		else {
			debugdot("lecture du fichier %s ",filenameFondsaveload2);
			if(!_pngFond.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameFondsaveload2);
			else {
				_bmpSurfaceFond=*_pngFond.getSurface();			
			}
		
		}

		
	}
	if(currentGame==3){
		

		_fileBitmap=fs->makeFileNodePath(filenameButtonSmall3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameButtonSmall3);
		else {
			debugdot("lecture du fichier %s ",filenameButtonSmall3);
			if(!_pngButtonSmall.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameButtonSmall3);
			else {
				_bmpSurfaceButtonSmall=*_pngButtonSmall.getSurface();			
			}
		
		}

		_fileBitmap=fs->makeFileNodePath(filenameBGbutton3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameBGbutton3);
		else {
			debugdot("lecture du fichier %s ",filenameBGbutton3);
			if(!_pngButton.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameBGbutton3);
			else {
				_bmpSurfaceButton=*_pngButton.getSurface();	
				
			}
		
		}

		

	
		

		_fileBitmap=fs->makeFileNodePath(filenameFondsaveload3);
		if(!_fileBitmap->exists())
			debugdot("erreur le fichier %s n'existe pas ", filenameFondsaveload3);
		else {
			debugdot("lecture du fichier %s ",filenameFondsaveload3);
			if(!_pngFond.loadStream(*(_fileBitmap->createReadStream())))
				debugdot("echec de la lecture du fichier %s",filenameFondsaveload3);
			else {
				_bmpSurfaceFond=*_pngFond.getSurface();			
			}
		
		}

		
	}

	delete _fileBitmap;


}

void SaveLoadView::initTexture(){
	
		_textureFond=new GLES8888Texture();
	debugdot("_bmpSurfaceFond = %d,%d",_bmpSurfaceFond.w,_bmpSurfaceFond.h);
		_textureFond->allocBuffer(_bmpSurfaceFond.w,_bmpSurfaceFond.h);
		_textureFond->updateBuffer(0,0,_bmpSurfaceFond.w,_bmpSurfaceFond.h,_bmpSurfaceFond.pixels,_bmpSurfaceFond.pitch);
		boundFond=Common::Rect(0,0,game_screen.left+game_screen.right,game_screen.height());


		
		_flechedroite.setCenter((game_screen.left+game_screen.right)*15/16,game_screen.height()/2);
		_flechedroite.setScale((float)(game_screen.right+game_screen.left)/1280,(float)game_screen.height()/720);
		_flechedroite.setSurface(&_bmpSurfaceFlechedroite);
		_flechedroite.initTexture();		
	
		_flechegauche.setCenter((game_screen.left+game_screen.right)*1/16,game_screen.height()/2);
		_flechegauche.setScale((float)(game_screen.right+game_screen.left)/1280,(float)game_screen.height()/720);
		_flechegauche.setSurface(&_bmpSurfaceFlechegauche);
		_flechegauche.initTexture();

		_backMenu.setCenter((game_screen.left+game_screen.right)*7.25/8,game_screen.height()*1/12);
		_backMenu.setScale((float)(game_screen.right+game_screen.left)/1280,(float)(game_screen.height())/720*0.75);
		_backMenu.setSurface(&_bmpSurfaceButtonSmall);
		_backMenu.initTexture();

		_saveLoad.setCenter((game_screen.left+game_screen.right)*15/25,game_screen.height()*7.5/12);
		_saveLoad.setScale((float)(game_screen.right+game_screen.left)/1280,(float)game_screen.height()/720);
		_saveLoad.setSurface(&_bmpSurfaceButton);
		_saveLoad.initTexture();

		_textureImgSlot=new GLES8888Texture();
		_textureImgSlot->allocBuffer(_bmpSurfaceSaveEmpty.w,_bmpSurfaceSaveEmpty.h);
		unsigned int imgSlotCenterX=(game_screen.left+game_screen.right)*8/25;
		unsigned int imgSlotCenterY=game_screen.height()*6.5/12;
		
		boundImgSlot=Common::Rect(imgSlotCenterX-(_bmpSurfaceSaveEmpty.w/2)*(float)game_screen.height()/300,
					imgSlotCenterY-(_bmpSurfaceSaveEmpty.h/2)*(float)game_screen.height()/300,
				imgSlotCenterX+(_bmpSurfaceSaveEmpty.w/2)*(float)game_screen.height()/300,
				imgSlotCenterY+(_bmpSurfaceSaveEmpty.h/2)*(float)game_screen.height()/300);

		
		_textureTexte=new GLES8888Texture();
		_textureTexte->allocBuffer(_bmpFont_black.getSurface()->w,_bmpFont_black.getSurface()->h);
	

}

bool SaveLoadView::check_interface(Common::Point p){
	if(bSaveMenu){
		if(saveEtat==-1 && loadEtat==-1){
			if(_backMenu.isClicked(p.x,p.y)){
				bSaveMenu=false;
				return true;
			}
			if(_flechedroite.isClicked(p.x,p.y)){
				if(currentGame==2){
					if(numSlot>=14)
						numSlot=0;
					else
						numSlot++;
				}else {
					if(numSlot>=6)
						numSlot=0;
					else
						numSlot++;
				}
				return true;
				
			}
			if(_flechegauche.isClicked(p.x,p.y)){
				if(currentGame==2){
					if(numSlot<=0)
						numSlot=14;
					else
						numSlot--;
				}else {
					if(numSlot<=0)
						numSlot=6;
					else
						numSlot--;
				}
				return true;			
			}
			if(_saveLoad.isClicked(p.x,p.y)){
				if(bSave){
					if(bBagOn){
						debugdot("Bag ouvert");
						bResetAction=true;
					}
					//saveEtat=0;
					bLoop2=0;
					cpt=0;
					bSaving=true;
					bLoaded=false;
					saveLoop=0;
					saveEtat=-1;
					_mouseY=0;_mouseX=20;
					//if(currentGame==2)
							slotSave=numSlot+1;
					//else slotSave=numSlot;	
				}
				else {
					if(!Slot[numSlot].empty){
						if(bBagOn){
							debugdot("Bag ouvert");
							bResetAction=true;
						}
						//loadEtat=0;
						bLoaded=false;
						bLoop3=0;
						cpt=0;
						loadLoop = 0;
						loadEtat = -1;
						_mouseY=0;_mouseX=20;
					//	if(currentGame==2)
							slotSave=numSlot+1;
					//	else slotSave=numSlot;
						bLoading=true;	
					}
				}
				
				return true;
			}
		}
		

	}
	return false;
}


void SaveLoadView::display() {
	if(bSaveMenu){
		
		debugdot("begin display savemenu");
		_textureFond->setDrawRect(boundFond);
		_textureFond->drawTextureRect();
		
		//debugdot("Slot[%d]=%s, Slot[%d].empty= %d ",numSlot,Slot[numSlot].dateLastSave,numSlot,Slot[numSlot].empty);
		char stringSlot[14];
		debugdot("sprintf %d : numSlot",numSlot);
		
		sprintf(stringSlot,"%s %d",stringSlotname,numSlot+1);
		debugdot("drawString");
		drawString((game_screen.left+game_screen.right)*15/25,game_screen.height()*5.25/12,stringSlot,(float)42*game_screen.height()/720);
		debugdot("if empty ");
		if(!Slot[numSlot].empty){
			/*TimeDate td;
			struct tm tm;
			char* timeDateStr;
			debugdot("check time");
			getTimeAndDate(td);
			debugdot("have time");
			convertTimeDateToTm(td,tm);
			timeDateStr=asctime( &tm );*/
			drawString((game_screen.left+game_screen.right)*15/25,game_screen.height()*6.25/12,Slot[numSlot].dateLastSave,(float)36*game_screen.height()/720);
			if(bSave)
				_textureImgSlot->updateBuffer(0,0,_bmpSurfaceSaveIcon.w,_bmpSurfaceSaveIcon.h,_bmpSurfaceSaveIcon.pixels,_bmpSurfaceSaveIcon.pitch);
			else
				_textureImgSlot->updateBuffer(0,0,_bmpSurfaceLoadIcon.w,_bmpSurfaceLoadIcon.h,_bmpSurfaceLoadIcon.pixels,_bmpSurfaceLoadIcon.pitch);
		}else{ 
			if(bSave)
				_textureImgSlot->updateBuffer(0,0,_bmpSurfaceSaveEmpty.w,_bmpSurfaceSaveEmpty.h,_bmpSurfaceSaveEmpty.pixels,_bmpSurfaceSaveEmpty.pitch);
			else 
				_textureImgSlot->updateBuffer(0,0,_bmpSurfaceLoadEmpty.w,_bmpSurfaceLoadEmpty.h,_bmpSurfaceLoadEmpty.pixels,_bmpSurfaceLoadEmpty.pitch);
			drawString((game_screen.left+game_screen.right)*15/25,game_screen.height()*6.25/12,stringEmpty,(float)36*game_screen.height()/720);
		}
		debugdot("drawString data");
		
		debugdot("if save");
		_saveLoad.display();
		if(bSave){
			
			drawString((game_screen.left+game_screen.right)*15/25,game_screen.height()*7.5/12,stringSavebutton,(float)50*game_screen.height()/720);
			drawString((game_screen.left+game_screen.right)/2,game_screen.height()*2.75/12,stringSavebutton,(float)100*game_screen.height()/720);
			
		}else{
			drawString((game_screen.left+game_screen.right)*15/25,game_screen.height()*7.5/12,stringLoadbutton,(float)50*game_screen.height()/720);
			drawString((game_screen.left+game_screen.right)/2,game_screen.height()*2.75/12,stringLoadbutton,(float)100*game_screen.height()/720);
		}
		
		_textureImgSlot->setDrawRect(boundImgSlot);
		_textureImgSlot->drawTextureRect();
		
		
		_flechedroite.display();
		_flechegauche.display();
		_backMenu.display();
		drawString((game_screen.left+game_screen.right)*7.25/8,game_screen.height()*1.0/12,stringBackbutton,(float)48*game_screen.height()/720);
		/*if(bSave)
			launchSave.display();
		else
			launcheLoad.display();*/
		
	}


	
	

}

unsigned int SaveLoadView::drawString(unsigned int x, unsigned int y, char* Str, float size,bool limited,bool black){
	int posX=0;
	int posY=0;
	int xinit=x;
	int xMax=900;
	int word=0;
	int nbPixelAdd=0;
	float scale=size/65;// taille a afficher / taille de caractère
	
	
	//debugdot("la string est =%s!!!!",Str);
	

	for( unsigned int i = 0; Str[i]!=(char)0; i++ ){  // calcule de la taille pour centrage
		
		int XAdvance = _bmpFont_black.getXAdvance(Str[i])*scale;
		int height = _bmpFont_black.getHeight(Str[i])*scale;
		int offsetY = _bmpFont_black.getOffsetY(Str[i])*scale;
		posX+=XAdvance;
		if(height+offsetY>posY)
			posY=height+offsetY;
	}
	//debugdot("PosX = %d, x= %d",posX,x);
	int heightinit=posY;
	int xcalcul=x;
	bool bspace=true;
	bool endLine=true;
	if(!limited)
		x-=posX/2;
	y-=(size)/2;
	
	xinit=x;
	//debugdot("X= %d",x);
	for( unsigned int i = 0;Str[i]!=(char)0; i++ )
	{
		//xcalcul=x;
		
		if(limited&& endLine){
			posX=0;
			endLine=false;
			unsigned int mem=0;
			unsigned int word=0;
			if(Str[i]==' ')
				i++;
			for(unsigned int j=i;posX<=xMax;++j){
				unsigned int XAdvance = _bmpFont_black.getXAdvance(Str[j])*scale;
				if(Str[j]==' '){
					word++;
					mem=posX;
				}
				posX+=XAdvance;
			}
			
			//debugdot("posX=%d, word=%d ",posX,word);
			unsigned int diffEndLine=xMax-mem; // nb pixel en trop
			//debugdot("diffEndLine= %d",diffEndLine);
			nbPixelAdd=diffEndLine/((word-1));
			//debugdot("nbPixel= %d",nbPixelAdd);
			posX=0;
		}
		//debugdot("Pos = %d ,Str[%d] = %c = %d",posX,i,Str[i],Str[i]);
		/*if(bspace && limited){
			for(unsigned j =i; Str[j]!=' ';j++){
				unsigned int XAdvance = _bmpFont_black.getXAdvance(Str[j])*scale;
				xcalcul+=XAdvance;
			}
			if(xcalcul>=xinit+1000){
				x=xinit;
				y=y+heightinit+5;
			}
			bspace=false;
		}
		if(Str[i]==' ') */
		int charX = _bmpFont_black.getPos(Str[i]).x;
		int charY = _bmpFont_black.getPos(Str[i]).y;
		float width = _bmpFont_black.getWidth(Str[i]);
		float height = _bmpFont_black.getHeight(Str[i]);
		float offsetX = (float)(_bmpFont_black.getOffsetX(Str[i])*scale);
		float offsetY = (float)(_bmpFont_black.getOffsetY(Str[i])*scale);
		int XAdvance = _bmpFont_black.getXAdvance(Str[i]);
		/*if(black)
			_texte_texture->setTextureColorBlack();*/
		_textureTexte->allocBuffer(width,height);
		_textureTexte->updateBuffer(0,0,width,height,_bmpFont_black.getSurface()->pixels+charX*_bmpFont_black.getSurface()->format.bytesPerPixel+charY*_bmpFont_black.getSurface()->pitch,_bmpFont_black.getSurface()->pitch);

		offsetX=rounded(offsetX);
		offsetY=rounded(offsetY);
		
		height=(float)height*scale;
		height=rounded(height);
		
		width=(float)width*scale;
		width=rounded(width);

		_textureTexte->setDrawRect(Common::Rect(x+offsetX,y+offsetY,(int)(x+offsetX+width),(int)(offsetY+y+height)));
		_textureTexte->drawTextureRect();
		if(Str[i]==' ' && limited)
			x+=XAdvance*scale+nbPixelAdd;
		else
			x+=XAdvance*scale;
		if(x>xinit+xMax && limited){
			//debugdot("x=%d xinit=%d",x,xinit);
			x=xinit;
			y=y+heightinit+5;
			endLine=true;
		}
		
	
	}
	return y+=heightinit+5;
	

}

void SaveLoadView::release(){
	
	if(_textureFond)
		_textureFond->release();
	if(_textureImgSlot)
		_textureImgSlot->release();
	if(_textureTexte)
		_textureTexte->release();
	_backMenu.release();
	_flechedroite.release();
	_flechegauche.release();
	_saveLoad.release();
}

void SaveLoadView::reinit(){
	
	if(_textureFond)
		_textureFond->reinit();
	if(_textureImgSlot)
		_textureImgSlot->reinit();
	if(_textureTexte)
		_textureTexte->reinit();
	_backMenu.reinit();
	_flechedroite.reinit();
	_flechegauche.reinit();
	_saveLoad.reinit();
}

