#ifndef _SAVELOADVIEW_H
#define _SAVELOADVIEW_H

#include "common/rect.h"
#include "graphics/surface.h"
#include "backends/platform/android/texture.h"
#include "backends/platform/android/button.h"
#include "backends/platform/android/textbutton.h"

#include "common/fs.h"
#include "backends/fs/fs-factory.h"
#include "graphics/decoders/bmp.h"
#include "graphics/decoders/png.h"
#include "common/stream.h"

struct slot{
	bool empty;
	char* dateLastSave;

	slot() : empty( true ), dateLastSave("Empty")
	{ }
};



class SaveLoadView {

private:
	Button _backMenu;
	Button _flechedroite;
	Button _flechegauche;
	Button _saveLoad;
	
	//TextButton _saveLoad;
	
	bool bSaveMenu;
	
	

	Common::Rect boundFond;
	Common::Rect boundTitle;
	Common::Rect boundImgSlot;
	
	
	
	Graphics::Surface _bmpSurfaceSaveEmpty;
	Graphics::Surface _bmpSurfaceSaveIcon;
	Graphics::Surface _bmpSurfaceLoadEmpty;
	Graphics::Surface _bmpSurfaceLoadIcon;
	Graphics::Surface _bmpSurfaceFond;


	Graphics::Surface _bmpSurfaceButton;
	Graphics::Surface _bmpSurfaceButtonSmall;
	

	Graphics::Surface _bmpSurfaceFlechedroite;
	Graphics::Surface _bmpSurfaceFlechegauche;
	
	
	Graphics::PNGDecoder _pngFlechedroite;
	Graphics::PNGDecoder _pngFlechegauche;
	Graphics::PNGDecoder _pngSaveEmpty;
	Graphics::PNGDecoder _pngSaveIcon;
	Graphics::PNGDecoder _pngLoadEmpty;
	Graphics::PNGDecoder _pngLoadIcon;
	Graphics::PNGDecoder _pngFond;
	Graphics::PNGDecoder _pngButton; 
	Graphics::PNGDecoder _pngButtonSmall;
	

	GLESBaseTexture *_textureFond;
	GLESBaseTexture *_textureImgSlot;
	GLESBaseTexture *_textureTexte;
	

	

//gob2 Image with text
char*  filenameSavetitle2;
char*  filenameLoadtitle2;
char*  filenameLoadbutton2;
char*  filenameSavebutton2;


//gob3 Image with text
char*  filenameSavetitle3;
char*  filenameLoadtitle3;
char*  filenameLoadbutton3;
char*  filenameSavebutton3;

//Localized text
char* stringLoadbutton;
char* stringSavebutton;
char* stringBackbutton;
char* stringSlotname;
char* stringEmpty;
	
	
public:	
	void initPath();
	slot Slot[15];
	void loadImage(FilesystemFactory *fs);
	void initTexture();
	bool check_interface(Common::Point p);
	void display() ;
	void enableDisplay(bool b){ bSaveMenu = b; }
	bool isEnable(){ return bSaveMenu;}
	unsigned int drawString(unsigned int x, unsigned int y, char* Str, float size,bool limited=0,bool black=0);
	void release();
	void reinit();
	

};

#endif
