


template<class T> class Conteneur {
protected:
    unsigned int nbEl;
public:
    unsigned int size() const { return nbEl;}
    bool empty() const { if(this->nbEl==0) return true; else return false; }
    virtual T& element(unsigned int i)=0;
    virtual const T& element(unsigned int i)const =0 ;
    virtual void push_back(const T& x)=0;
    virtual void pop_back()=0;
    virtual T& font();
    virtual const T& font() const;
    virtual T& back();
    virtual const T& back() const;
    virtual ~Conteneur();
    Conteneur(unsigned int n) : nbEl(n){}
    Conteneur() : nbEl(0){}
    virtual void clear();

};

template<class T> T& Conteneur<T>::font(){
    return element(0);
}

template<class T> T& Conteneur<T>::back(){
    return element(nbEl-1);
}

template<class T> const T& Conteneur<T>::font()const{
    return element(0);
}

template<class T> const T& Conteneur<T>::back()const{
    return element(nbEl-1);
}

template<class T> Conteneur<T>::~Conteneur(){}

template<class T> void Conteneur<T>::clear(){
    while(!empty()) pop_back();
}


template<class T> class Vector : public Conteneur<T>{
    T* tab;
    unsigned int capa;
public:
    Vector(unsigned int n, const T& init=T()): Conteneur<T>::Conteneur(n), capa(n), tab(0){ // =T() => appelle du constructeur sans argument de type T
            tab= new T[this->nbEl];
            for(unsigned int i=0;i<this->nbEl;i++)
                tab[i]=init;
        }
    ~Vector();
    Vector(const Vector<T>& v);
    Vector();
    Vector<T>& operator=(const Vector<T>& v);
    T& operator[](unsigned int i){return tab[i];}
    const T& operator[](unsigned int i) const { return tab[i];}
    T& element(unsigned int i);
    const T& element(unsigned int i) const ;
    void push_back(const T& x);
    void pop_back();
    void clear();
    void reserve(unsigned int n);


    class Iterator {
        friend class Vector<T>;
        T* current; // pointeur sur l'élément désigné par l'iterateur
        Iterator(T* t) : current(t){}
    public :
        T& operator*() const { return *current;}
        Iterator& operator++(){++current; return *this;}
        Iterator& operator++(int){Iterator old=*this; ++current; return old;}
        bool operator==(Iterator it) const { return current==it.current;}
        bool operator!=(Iterator it) const { return current!=it.current;}
        Iterator operator+(unsigned int n) const {return (current)+n;}
        Iterator():current(0){}


    };
    Iterator begin(){ return Iterator(tab);}
    Iterator end(){ return Iterator(tab+this->nbEl);}

};

template<class T> Vector<T>::~Vector(){
    delete[] tab;
}


template<class T> Vector<T>::Vector(const Vector<T>& v): Conteneur<T>::Conteneur(v.size()), capa(v.size()), tab(new T[v.size()]){
    for(unsigned int i=0; i<this->nbEl;i++) tab[i]=v.tab[i];
}
template<class T> Vector<T>::Vector(): Conteneur<T>::Conteneur(0), capa(0), tab(NULL){}

template<class T> void Vector<T>::reserve(unsigned int n){
    if(n<=capa) return;
    T* newTab= new T[n];
    for(unsigned int i=0;i<this->nbEl;i++) newTab[i]=tab[i];
    capa=n;T* old=tab; tab=newTab; delete[] old;
}

template<class T> Vector<T>& Vector<T>::operator=(const Vector<T>& v){
    if(this==&v) return *this;
    reserve(v.size()); this->nbEl;
    for(unsigned int i=0;i<v.size();i++) tab[i]=v.tab[i];
    return *this;
}

template<class T>  T& Vector<T>::element(unsigned int i){
      if (i>= this->nbEl) debugdot("out of range");
      return  tab[i];
}

template<class T>  const T& Vector<T>::element(unsigned int i) const {
      if (i>= this->nbEl) debugdot("i est trop grand..");
      return  tab[i];
}

template<class T> void Vector<T>::pop_back(){
    this->nbEl--;
}

template<class T> void Vector<T>::push_back(const T& x){
    if(this->nbEl==capa) reserve(capa+10);
    tab[this->nbEl++]=x;
}

template<class T> void Vector<T>::clear(){
    this->nbEl=0;
}
