package com.dotemu.gobliiins;

import java.util.Locale;

import com.dotemu.gobliiins.R;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Typeface;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.opengl.Visibility;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.util.TypedValue;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;


public class CreditsActivity extends Activity {
	
	private String Language;
	private Button buttonBack;
	private RelativeLayout globalLayout;
	private WebView webView;
	private ImageView buttonNext;
	private ImageView buttonPrev;
	private Button buttonScummvm;
	private Button buttonSource;
	private String idGame;
	private int credit=0;
	boolean continueMusic = false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_credits);
		
		Bundle b=getIntent().getExtras();
        idGame=b.getString("game");
        
        TextView viewTitle= (TextView) findViewById(R.id.titleCredits);  
        globalLayout = (RelativeLayout) findViewById(R.id.creditLayout);
        webView = (WebView) findViewById(R.id.creditWebview);
        buttonNext=(ImageView) findViewById(R.id.next);
        buttonPrev=(ImageView) findViewById(R.id.prev);
        buttonBack=(Button) findViewById(R.id.back);
        buttonSource=(Button) findViewById(R.id.source);
        buttonScummvm=(Button) findViewById(R.id.scummvm);
        
        webView.setBackgroundColor(Color.argb(0, 0, 0, 0));

        Typeface font8bitoperator = Typeface.createFromAsset(getAssets(), "fonts/8bitoperator.ttf");
       	viewTitle.setTypeface(font8bitoperator,Typeface.BOLD);
       	buttonBack.setTypeface(font8bitoperator);
       	Typeface fontcourier = Typeface.createFromAsset(getAssets(), "fonts/COURIER.TTF");
       	buttonSource.setTypeface(fontcourier,Typeface.BOLD_ITALIC);
       	buttonScummvm.setTypeface(fontcourier,Typeface.BOLD_ITALIC);
       	
        Language=Locale.getDefault().getLanguage();
	//	Log.i("dotemu","Language = "+ Language);
		
		if(!"fr".equals(Language) && !"en".equals(Language))
			Language="en";
		WebSettings webSettings = webView.getSettings();
		String sizeType=getSizeName(this);
        if("small".equals(sizeType)){
        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
        		 webSettings. setTextZoom(50);
    		 }else webSettings.setTextSize(WebSettings.TextSize.SMALLEST);
        	
        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,6);
        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,7);
        	buttonScummvm.setTextSize(TypedValue.COMPLEX_UNIT_DIP,7);
        	buttonSource.setTextSize(TypedValue.COMPLEX_UNIT_DIP,7);
        }else if("large".equals(sizeType)){
        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
        		 webSettings. setTextZoom(150);
    		 }else webSettings.setTextSize(WebSettings.TextSize.LARGER);
        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,17);
        	buttonScummvm.setTextSize(TypedValue.COMPLEX_UNIT_DIP,17);
        	buttonSource.setTextSize(TypedValue.COMPLEX_UNIT_DIP,17);
        }else if("xlarge".equals(sizeType)){
        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
        		 webSettings. setTextZoom(200);
    		 }else webSettings.setTextSize(WebSettings.TextSize.LARGEST);
        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
        	buttonScummvm.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
        	buttonSource.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
        }else{		//normal
        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
        		 webSettings. setTextZoom(85);
    		 }else webSettings.setTextSize(WebSettings.TextSize.SMALLER);
        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);
        	buttonScummvm.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);
        	buttonSource.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);
    	}
        webSettings.setDefaultTextEncodingName("utf-8");
        viewTitle.setText(R.string.credit_title);
        buttonScummvm.setText(R.string.button_scummvm);
        buttonSource.setText(R.string.button_source);
        viewTitle.setTextColor(Color.YELLOW);
        
        
        buttonBack.setText(R.string.button_back);
        
     
       //Log.i("dotemu","scaleImage");
        buttonNext.setImageResource(R.drawable.hint_suiv);
        buttonPrev.setImageResource(R.drawable.hint_prec);
        
        ScaleImage(buttonNext);
        ScaleImage(buttonPrev);
        
      
        loadHtml();
      
       
      
        
       // setMargin((float)2/31,(float)26/31,0,0,buttonBack);  
        setMargin((float)1.1/14,0,0,(float)12.35/14,viewTitle);  
        setMargin(0,0,(float)2/31,(float)1/31,buttonNext);
        setMargin((float)2/31,0,0,(float)1/31,buttonPrev);  
        setMargin((float)5/31,(float)22/31,0,0,buttonSource);  
        setMargin((float)19/31,(float)22/31,0,0,buttonScummvm);  
        setMargin((float)26/31,(float)1/31,(float)0.5/31,(float)27.25/31,buttonBack);
        
        
        buttonBack.setOnClickListener(new View.OnClickListener() {
       	 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				continueMusic = true;
				finish();
			}
		});
        
        buttonScummvm.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse("http://www.scummvm.org/"));
				startActivity(browserIntent);

				
			}
		});
        
        buttonSource.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse("http://www.dotemu.com/gpl"));
				startActivity(browserIntent);

				
			}
		});
        
        buttonPrev.setOnClickListener(new View.OnClickListener() {
          	 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				credit--;
				loadHtml();
				
			}
		});
        buttonNext.setOnClickListener(new View.OnClickListener() {
          	 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				credit++;
				loadHtml();
			}
		});
        
       
	
	}
	
	public void loadHtml(){
		switch(credit){
			case 0: buttonPrev.setVisibility(View.GONE);
					buttonNext.setVisibility(View.VISIBLE);
					loadPageOne();
					break;
			case 1: buttonPrev.setVisibility(View.VISIBLE);
					buttonNext.setVisibility(View.VISIBLE);
					loadPageTwo();
					break;
			case 2: buttonPrev.setVisibility(View.VISIBLE);
					buttonNext.setVisibility(View.GONE);
					loadPageThree();
					break;
			default : break;
		}
	}
	
	public void loadPageOne(){
		buttonScummvm.setVisibility(View.GONE);
    	buttonSource.setVisibility(View.GONE);
    	  setMargin((float)3/31,(float)7/31,(float)3/31,(float)3/31, webView);
		if("gob1".equals(idGame)){
       	// Log.i("dotemu","gob1");
       	
       	 buttonBack.setBackgroundResource(R.drawable.gob1_button_small);
       	 if("en".equals(Language)){
       		
       	    	
           	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/credits/en/credits.html");
           	 
    	        webView.setBackgroundColor(Color.TRANSPARENT);
    	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
	    			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
	    		 }
           	       		 
       	 }else {
       		 
       		
       	    	
           	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/credits/fr/credits_fr.html");
           	 
    	        webView.setBackgroundColor(Color.TRANSPARENT);
    	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
	    			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
	    		 }
           	            	 
       	 }
       	
       	 //buttonBack.setImageResource(R.drawable.credits_gob1_back);
       	 globalLayout.setBackgroundResource(R.drawable.credits_gob1_background);
       }
       if("gob2".equals(idGame)){
    	   buttonBack.setBackgroundResource(R.drawable.gob2_button_small);
       	if("en".equals(Language)){
      		
      	    	
          	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/credits/en/credits.html");
          	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
 			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
 		 }
          	       		 
      	 }else {
      		 
      		
      	    	
          	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/credits/fr/credits_fr.html");
          	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
 			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
 		 }
          	            	 
      	 }
      	
      	// buttonBack.setImageResource(R.drawable.credits_gob2_back);
      	 globalLayout.setBackgroundResource(R.drawable.credits_gob2_background);
       }
		if("gob3".equals(idGame)){
		//	 Log.i("dotemu","gob3");
			 buttonBack.setBackgroundResource(R.drawable.gob3_button_small);
			if("en".equals(Language)){
      		
      	    	
          	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/credits/en/credits.html");
          	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
 			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
 		 }
          	       		 
      	 }else {
      		 
      		
      	    	
          	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/credits/fr/credits_fr.html");
          	            	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
 			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
 		 }
      	 }
      	
      	// buttonBack.setImageResource(R.drawable.credits_gob3_back);
      	 globalLayout.setBackgroundResource(R.drawable.credits_gob3_background);
		}
	}
	
	public void loadPageTwo(){
		buttonScummvm.setVisibility(View.VISIBLE);
    	buttonSource.setVisibility(View.VISIBLE);
    	  setMargin((float)3/31,(float)7/31,(float)3/31,(float)10/31, webView);
		if("en".equals(Language)){
      		
  	    	
         	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/legal.html");
         	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
		 }
         	       		 
     	 }else {
     		 
     		
     	    	
         	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/legal_fr.html");
         	            	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
	       }
     	 }
		
	}
	
	public void loadPageThree(){
		
		buttonScummvm.setVisibility(View.GONE);
    	buttonSource.setVisibility(View.GONE);
    	    	
        	 webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/gpl.html");
        	 setMargin((float)3/31,(float)7/31,(float)3/31,(float)9/31, webView);              	 
	        webView.setBackgroundColor(Color.TRANSPARENT);
	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
	       }
	}

	
	public void setMargin(float coefbeginx,float coefbeginy,float coefendx,float coefendy,View view){
		Display display = getWindowManager().getDefaultDisplay();
		  int screen_width = display.getWidth();
		  int screen_height = display.getHeight();
		  float margbeginX=coefbeginx*screen_width;
		  float margendX=coefendx*screen_width;
		  float  margbeginY=coefbeginy*screen_height;
		  float  margendY=coefendy*screen_height;
	//	  Log.i("dotemu","!!!!!!!!!!X "+margbeginX+"Y"+margbeginY);
		  RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
		    params.setMargins((int)margbeginX,(int)margbeginY, (int)margendX,(int)margendY);
		    
		    view.setLayoutParams(params);
	}
	
	public void ScaleImage(ImageView view) {
		
    	
 	   Drawable drawing = view.getDrawable();
        if (drawing == null) {
            return; 
        }
        Bitmap bitmap = ((BitmapDrawable)drawing).getBitmap();

    	  
    	  int width = bitmap.getWidth();
    	  int height = bitmap.getHeight();
    	//  Log.i("dotemu","!!!!!!bitmap " + width + "," +height);
    	
    	  Display display = getWindowManager().getDefaultDisplay();
    	 
          
    	  int screen_width = display.getWidth();
    	  int screen_height = display.getHeight();
    	  
    	  float xScale = ((float) screen_width) / 1280 ; 
    	  float yScale = ((float) screen_height) / 720 ;
    	//  Log.i("dotemu","!!!!!!!Screen " + screen_width + "," +screen_height);
    	//  Log.i("dotemu","!!!!!!!Scale " + xScale + "," +yScale);
    	 
    	  int newWidth=(int) (width*xScale);
    	  int newHeight=(int) (height*yScale);
    //	Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	  //  Log.i("Test", "scaled height = " + Integer.toString(newHeight));
    	  /* Matrix matrix = new Matrix();

    	  	matrix.postScale(xScale, yScale);
	
	  
	    Bitmap scaledBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
	    width = scaledBitmap.getWidth(); 
	    height = scaledBitmap.getHeight(); 
	    BitmapDrawable result = new BitmapDrawable(scaledBitmap);
	    Log.i("Test", "scaled width = " + Integer.toString(width));
	    Log.i("Test", "scaled height = " + Integer.toString(height));

	   */
		Bitmap scaledBitmap=Bitmap.createScaledBitmap(bitmap, newWidth, newHeight, false);
		BitmapDrawable result = new BitmapDrawable(scaledBitmap);
		view.setImageDrawable(result);
	//	Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	  //  Log.i("Test", "scaled height = " + Integer.toString(newHeight));
	    RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
	    params.width = newWidth;
	    params.height = newHeight;
	    view.setLayoutParams(params);

	  //  Log.i("Test", "done");
 }
	private static String getSizeName(Context context) {
        int screenLayout = context.getResources().getConfiguration().screenLayout;
        screenLayout &= Configuration.SCREENLAYOUT_SIZE_MASK;

        switch (screenLayout) {
        case Configuration.SCREENLAYOUT_SIZE_SMALL:
            return "small";
        case Configuration.SCREENLAYOUT_SIZE_NORMAL:
            return "normal";
        case Configuration.SCREENLAYOUT_SIZE_LARGE:
            return "large";
        case 4: // Configuration.SCREENLAYOUT_SIZE_XLARGE is API >= 9
            return "xlarge";
        default:
            return "undefined";
        }
    }
	
	public void onPause(){
		super.onPause(); 

		if(!continueMusic)
			MusicManager.pause();
	}

	@Override
	public void onResume(){
		super.onResume(); 

		continueMusic = false;

		Bundle b=getIntent().getExtras();
		final String idGame=b.getString("game");

		if("gob1".equals(idGame))      
			MusicManager.start(this, MusicManager.MUSIC_GOB1);   
		else if("gob2".equals(idGame))
			MusicManager.start(this, MusicManager.MUSIC_GOB2);
		else if("gob3".equals(idGame))
			MusicManager.start(this, MusicManager.MUSIC_GOB3);
	}
	
	@Override
	public void onBackPressed() {
		super.onBackPressed();
		
		continueMusic = true;
	}
	
}
