package com.dotemu.gobliiins;

public interface GameInstallerProgressListener 
{
	// Called if no connection available
	public void onNoInternetError();
	
	// Called if not enough free space detected
	public void onNoFreeSpaceError(int mb);
	
	// Called if SD-Card error detected
	public void onSdCardError(String errorState);
	
	// Called when new package is processed
	public void onPackageBegin(String name, int size);
	
	// Called when current download is progressing
	public void onPackageDownload(int bytes);

	// Called when current package being verified (MD5 digest)
	public void onPackageVerify();
	
	// Called when new file inside GamePackage is unpacked
	public void onPackageUnpack(String file, int percent);
	
	// Called when an error occur
	public void onPackageError(String name, int errorNumber);
	
	// Called when current package is done
	public void onPackageDone(String name);
	
	// Called when install process is finished
	public void onInstallFinished(boolean bInstallOccured);
	
}
