package com.dotemu.gobliiins;

import java.io.File;
import java.util.zip.CRC32;

public class GamePackage 
{

	private String 	name;
	private String 	url;
	private String  file;
	private int		size;
	private String 	md5;
	private boolean bUnpack;
	private String  marker;
	private String fullPath;
	
	public GamePackage(String name, String url, String file, int size, String md5)
	{
		this.name = name;
		this.url  = url;
		this.file = file;
		this.size = size;
		this.md5  = md5;
		
		if(url.equals("APK")) {
			this.size = (int)new File(file).length();
		}
		
		CRC32 crc = new CRC32();
		crc.update(file.getBytes());
		crc.update(this.size);
		this.marker = new String("."+Long.toHexString(crc.getValue()));
		
		this.bUnpack = true;
	}
	
	public void setFullPath(String fullPath) {
		this.fullPath = fullPath;
	}
	
	public void setURL(String url) {
		this.url = url;
	}
	
	public void setUnpack(boolean bUnpack)
	{
		this.bUnpack = bUnpack;
	}
	
	public String getFullPath() {
		return fullPath;
	}
	
	public boolean getUnpack()
	{
		return this.bUnpack;
	}
	
	public String getName()
	{
		return this.name;
	}
	
	public String getUrl()
	{
		return this.url;
	}
	
	public String getFile()
	{
		return this.file;
	}

	public int getSize()
	{
		return this.size;
	}
	
	public String getMD5()
	{
		return this.md5;
	}
	
	public String getMarker()
	{
		return this.marker;
	}
	
}
