package com.dotemu.gobliiins;
import java.util.Locale;

import com.dotemu.gobliiins.R;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Typeface;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.util.TypedValue;
import android.view.Display;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class HelpViewActivity extends Activity {

	boolean continueMusic = false;
	
    private String idGame;
    private ImageView buttonSuiv;
    private ImageView buttonPrec;
    private TextView viewTitle;
    private ImageView viewSlot1;
    private ImageView viewSlot2;
    private ImageView viewSlot3;
    private RelativeLayout layoutSlot1;
    private RelativeLayout layoutSlot2;
    private RelativeLayout layoutSlot3;
    private Button buttonBack;
    private WebView WV;
    private TextView TVSlot1;
    private TextView TVSlot2;
    private TextView TVSlot3;
	private String Language;
	private int numHelpPage=1;
	    /** Called when the activity is first created. */
	    @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	     //   Log.i("dotemu","oncreate");
	        setContentView(R.layout.activity_help_view);
	        
	        Bundle b=getIntent().getExtras();
	       
	        idGame=b.getString("game");
	        
	        viewTitle= (TextView) findViewById(R.id.title_help);
	        
	        viewSlot1=(ImageView) findViewById(R.id.IV1_help);
	        viewSlot2=(ImageView) findViewById(R.id.IV2_help);
	        viewSlot3=(ImageView) findViewById(R.id.IV3_help);
	        layoutSlot1=(RelativeLayout) findViewById(R.id.layout1_help);
	        layoutSlot2=(RelativeLayout) findViewById(R.id.layout2_help);
	        layoutSlot3=(RelativeLayout) findViewById(R.id.layout3_help);
	        TVSlot1=(TextView) findViewById(R.id.textView1_help);
	        TVSlot2=(TextView) findViewById(R.id.textView2_help);
	        TVSlot3=(TextView) findViewById(R.id.textView3_help);
	        WV=(WebView) findViewById(R.id.webView_help);
	        RelativeLayout gobalLayout=(RelativeLayout) findViewById(R.id.layout_help);
	        buttonBack=(Button) findViewById(R.id.back_help);
	        WV.setBackgroundColor(Color.argb(0,0,0,0));
	        Typeface font = Typeface.createFromAsset(getAssets(), "fonts/8bitoperator.ttf");
	       	viewTitle.setTypeface(font,Typeface.BOLD);
	    	TVSlot1.setTypeface(font);
	    	TVSlot2.setTypeface(font);
	    	TVSlot3.setTypeface(font);
	    	buttonBack.setTypeface(font);
	    	
	        WebSettings webSettings = WV.getSettings();
			String sizeType=getSizeName(this);
	        if("small".equals(sizeType)){
	        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(50);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.SMALLEST);
	        	TVSlot1.setTextSize(TypedValue.COMPLEX_UNIT_DIP,6);
	        	TVSlot2.setTextSize(TypedValue.COMPLEX_UNIT_DIP,6);
	        	TVSlot3.setTextSize(TypedValue.COMPLEX_UNIT_DIP,6);
	        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,16);
	        	 buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,7);
	        }else if("large".equals(sizeType)){
	        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(150);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.LARGER);
	        	TVSlot1.setTextSize(TypedValue.COMPLEX_UNIT_DIP,14);
	        	TVSlot2.setTextSize(TypedValue.COMPLEX_UNIT_DIP,14);
	        	TVSlot3.setTextSize(TypedValue.COMPLEX_UNIT_DIP,14);
	        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
	        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,17);
	        }else if("xlarge".equals(sizeType)){
	        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(200);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.LARGEST);
	        	TVSlot1.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
	        	TVSlot2.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
	        	TVSlot3.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
	        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
	        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
	        }else{		//normal
	        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(100);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.NORMAL);
	        	TVSlot1.setTextSize(TypedValue.COMPLEX_UNIT_DIP,9);
	        	TVSlot2.setTextSize(TypedValue.COMPLEX_UNIT_DIP,9);
	        	TVSlot3.setTextSize(TypedValue.COMPLEX_UNIT_DIP,9);
	        	viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
	        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);
	    	}
	        webSettings.setDefaultTextEncodingName("utf-8");
	        buttonSuiv= (ImageView) findViewById(R.id.help_suiv);
	        buttonPrec=(ImageView) findViewById(R.id.help_prec);
	        
	      	      
	        Language=Locale.getDefault().getLanguage();
			//Log.i("dotemu","Language = "+ Language);
			
			if(!"fr".equals(Language))
				Language="en";
	       
			 buttonBack.setText(R.string.button_back);
	       if("gob1".equals(idGame)){
	        	 //Log.i("dotemu","gob1");
	        	 buttonBack.setBackgroundResource(R.drawable.gob1_button_small);
	        	 gobalLayout.setBackgroundResource(R.drawable.gob1helpbackground);
	        	buttonSuiv.setImageResource(R.drawable.hint_suiv);
	         	buttonPrec.setImageResource(R.drawable.hint_prec);
	         	setMargin(0,0,(float)7.75/12,0,viewSlot1);		       
		        setMargin(0,0,(float)5.5/12,0,viewSlot2);		       
		       // setMargin(0,0,(float)9/12,0,viewSlot3);
		        //Log.i("dotemu","Margin TV");
		        setMargin((float)3/12,0,0,0,TVSlot1);
		        setMargin((float)3/12,0,0,0,TVSlot2);
		      //  setMargin((float)2/12,0,0,0,TVSlot3);
		        //Log.i("dotemu","Margin Layout");
		        setMargin((float)0/12,(float)3.25/12,(float)1.75/12,(float)4.5/12,layoutSlot1);
		        setMargin((float)0/12,(float)6.25/12,(float)4/12,(float)1.5/12,layoutSlot2);
		      //  setMargin((float)0/12,(float)9.5/12,(float)1.5/12,(float)0.5/12,layoutSlot3);
	         	setMargin((float)1.5/12,(float)3/12,(float)3/12,(float)2/12,WV);
	        	
	        }
	        if("gob2".equals(idGame)){
	        	 //Log.i("dotemu","gob2");
	        	 buttonBack.setBackgroundResource(R.drawable.gob2_button_small);
	        	 buttonSuiv.setImageResource(R.drawable.hint_suiv);
	         	buttonPrec.setImageResource(R.drawable.hint_prec);
	         	gobalLayout.setBackgroundResource(R.drawable.gob2helpbackground);
	         	setMargin(0,0,(float)7.75/12,0,viewSlot1);		       
		        setMargin(0,0,(float)7.75/12,0,viewSlot2);		       
		       // setMargin(0,0,(float)9/12,0,viewSlot3);
		        //Log.i("dotemu","Margin TV");
		        setMargin((float)3/12,0,0,0,TVSlot1);
		        setMargin((float)3/12,0,0,0,TVSlot2);
		      //  setMargin((float)2/12,0,0,0,TVSlot3);
		        //Log.i("dotemu","Margin Layout");
		        setMargin((float)0/12,(float)3.25/12,(float)1.75/12,(float)6/12,layoutSlot1);
		        setMargin((float)0/12,(float)5.25/12,(float)1.75/12,(float)4/12,layoutSlot2);
		      //  setMargin((float)0/12,(float)9.5/12,(float)1.5/12,(float)0.5/12,layoutSlot3);
	         	setMargin((float)1.5/12,(float)3/12,(float)1.75/12,(float)4/12,WV);
	        	
	        }
	        
	 		if("gob3".equals(idGame)){
	 			 //Log.i("dotemu","gob3");
	 			buttonBack.setBackgroundResource(R.drawable.gob3_button_small);
	 			buttonSuiv.setImageResource(R.drawable.hint_suiv);
             	buttonPrec.setImageResource(R.drawable.hint_prec);
             	gobalLayout.setBackgroundResource(R.drawable.gob3helpbackground);
             	setMargin(0,0,(float)7.75/12,0,viewSlot1);		       
		        setMargin(0,0,(float)7.75/12,0,viewSlot2);		       
		      //  setMargin(0,0,(float)9/12,0,viewSlot3);
		        //Log.i("dotemu","Margin TV");
		        setMargin((float)3/12,0,0,0,TVSlot1);
		        setMargin((float)3/12,0,0,0,TVSlot2);
		        setMargin((float)3/12,0,0,0,TVSlot3);
		        //Log.i("dotemu","Margin Layout");
		        setMargin((float)0/12,(float)3/12,(float)1.75/12,(float)6/12,layoutSlot1);
		        setMargin((float)0/12,(float)5/12,(float)1.75/12,(float)4/12,layoutSlot2);
		        setMargin((float)0/12,(float)7/12,(float)6.15/12,(float)1/12,layoutSlot3);
             	setMargin((float)1.5/12,(float)3/12,(float)1.75/12,(float)4/12,WV);
	        	
	        }
	 		setMargin(0,(float)2.1/12,0,0,viewTitle);
	 		viewTitle.setTextColor(Color.BLACK);
	       //Log.i("dotemu","scaleImage");
	      
	       
	      
	        ScaleImage(buttonSuiv);
	        ScaleImage(buttonPrec);
	       
	      
	        //Log.i("dotemu","setMargin");
	        
	  
	        setMargin((float)26/31,(float)1/31,(float)0.5/31,(float)27.25/31,buttonBack);
		        setMargin((float)0.65/20,0,0,0,buttonPrec);
		        setMargin(0,0,(float)0.65/20,0,buttonSuiv);
		       
		        
		    
		        	TVSlot1.setTextColor(Color.BLACK);
		        	TVSlot2.setTextColor(Color.BLACK);
		        	TVSlot3.setTextColor(Color.BLACK);
		        
				
				//Log.i("dotemu","setbackground null");
				TVSlot1.setBackgroundColor(Color.argb(0, 0, 0, 0));
				TVSlot2.setBackgroundColor(Color.argb(0, 0, 0, 0));
				TVSlot3.setBackgroundColor(Color.argb(0, 0, 0, 0));
				//Log.i("dotemu","Scale && Margin");
				
		       
		        
		        
				  buttonBack.setOnClickListener(new View.OnClickListener() {
				       	 
						@Override
						public void onClick(View v) {
							// TODO Auto-generated method stub
							continueMusic=true;
							finish();
						}
					});       
	       
              
       
        
       buttonSuiv.setOnClickListener(new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			
				numHelpPage++;
			
			loadPage();
		}
	});
       
       buttonPrec.setOnClickListener(new View.OnClickListener() {
   		
   		@Override
   		public void onClick(View v) {
   			
				numHelpPage--;
			
			loadPage();
   		}
   	});
	    
	    
       

        //webView.addJavascriptInterface(new JavaScriptInterface(this), "MyAndroid");
       // webView.loadUrl("http://code.google.com/android");
      loadPage();
      
        //SystemClock.sleep(1000);
        //webView.loadUrl("javascript:getValue()");
    }
	    
	    
	    public void loadPage(){
	    	
	    	  
				switch( numHelpPage )
				{
					case 1: 
						loadPageOne();
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 2:
						loadPageTwo();
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break; 
					case 3: 
						loadPageThree();
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						
						break;
					case 4:
						loadPageFour();
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
					/*	if("gob3".equals(idGame) || "gob2".equals(idGame)){
							buttonSuiv.setVisibility(View.GONE);
						}*/
						break;
					case 5:
						loadPageFive();
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 6: 
						loadPageSix();			
					if("gob3".equals(idGame) || "gob2".equals(idGame)){
						buttonSuiv.setVisibility(View.GONE);
					}else
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						break;
					case 7:
						loadPageSeven();
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						break;
					case 8: 
						loadPageHeight();
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						break;
					default:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.GONE);
				}
	    }
	    
	    public void loadPageOne(){ // General 
	    	//Log.e("dotemu","Page 1!!! "+Language);
	    	if("gob1".equals(idGame)){	
	    		viewTitle.setText(R.string.help_title_gob1_general);
		    	if("en".equals(Language)){
		    		
		    		WV.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/help/en/help_general.html");
		    		WV.setBackgroundColor(Color.TRANSPARENT);
		    		 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
		    			 WV.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
		    		 }
		    	}else{
		    		 WV.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/help/fr/help_general_fr.html");
		    		 WV.setBackgroundColor(Color.TRANSPARENT);
		    		 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
		    			 WV.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
		    		 }
		    		
		    	}
	    	}else if("gob2".equals(idGame)){	
	    		viewTitle.setText(R.string.help_title_gob2_general);
			    	if("en".equals(Language)){
			    		
			    		WV.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/help/en/help_general.html");
			    		 WV.setBackgroundColor(Color.TRANSPARENT);
			    		 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			    			 WV.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
			    		 }
			    	}else{
			    		 WV.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/help/fr/help_general_fr.html");
			    		 WV.setBackgroundColor(Color.TRANSPARENT);
			    		 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			    			 WV.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
			    		 }
			    		
			    	}
		    	}else if("gob3".equals(idGame)){	
		    		viewTitle.setText(R.string.help_title_gob3_general);
			    	if("en".equals(Language)){
			    		
			    		WV.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/help/en/help_general.html");
			    		 WV.setBackgroundColor(Color.TRANSPARENT);
			    		 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			    			 WV.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
			    		 }
			    	}else{
			    		 WV.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/help/fr/help_general_fr.html");
			    		 WV.setBackgroundColor(Color.TRANSPARENT);
			    		 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			    			 WV.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
			    		 }
			    		
			    	}
		    	}
	    
	    	
	    	
	        
	        
	        TVSlot1.setVisibility(View.GONE);
	        TVSlot2.setVisibility(View.GONE);
	        TVSlot3.setVisibility(View.GONE);
	        
	        layoutSlot1.setVisibility(View.GONE);
	        layoutSlot2.setVisibility(View.GONE);
	        layoutSlot3.setVisibility(View.GONE);
	        
	        viewSlot1.setVisibility(View.GONE);
	        viewSlot2.setVisibility(View.GONE);
	        viewSlot3.setVisibility(View.GONE);
	        WV.setVisibility(View.VISIBLE);
	        
	       
	    }
	    
		public void loadPageTwo(){ //  Gob
			
			//Log.e("dotemu","Page 2!!! "+Language);
			TVSlot1.setVisibility(View.VISIBLE);
			TVSlot2.setVisibility(View.VISIBLE);
			//TVSlot3.setVisibility(View.VISIBLE);
			
			layoutSlot1.setVisibility(View.VISIBLE);
			layoutSlot2.setVisibility(View.VISIBLE);
			//layoutSlot3.setVisibility(View.VISIBLE);
			
			viewSlot1.setVisibility(View.VISIBLE);
			viewSlot2.setVisibility(View.VISIBLE);
			//viewSlot3.setVisibility(View.VISIBLE);
			WV.setVisibility(View.GONE);
			
			if("gob1".equals(idGame)){	
				viewSlot1.setImageResource(R.drawable.gobliiins1);				
				viewSlot2.setImageResource(R.drawable.gobliiins2);				
				//viewSlot3.setImageResource(R.drawable.gobliiins3);
				viewTitle.setText(R.string.help_title_gob1_gobliiins);
				TVSlot1.setText(R.string.help_texte_picker);
				TVSlot2.setText(R.string.help_texte_fighter);
		    	
	    	}else if("gob2".equals(idGame)){
	    		viewTitle.setText(R.string.help_title_gob2_interface);
    			viewSlot2.setImageResource(R.drawable.gob2_action);
    			viewSlot1.setImageResource(R.drawable.gob2_switchgob);
    			TVSlot1.setText(R.string.help_texte_switchgob);
				TVSlot2.setText(R.string.help_texte_action);
		    	
		    }else if("gob3".equals(idGame)){	
	    		
    			viewSlot2.setImageResource(R.drawable.gob3_action);
    			viewSlot1.setImageResource(R.drawable.gob3_switchgob);	
    			viewTitle.setText(R.string.help_title_gob3_interface);
    			TVSlot1.setText(R.string.help_texte_switchgob_gob3);
				TVSlot2.setText(R.string.help_texte_action);
		    	
	    	}
			
			ScaleImage(viewSlot1);
	        ScaleImage(viewSlot2); 
	        ScaleImage(viewSlot3);
			
 	     
 	        
			
			
	        
		}
		
		public void loadPageThree(){ //Action
			//Log.e("dotemu","Page 3!!! "+Language);
			
			
	       
			
			
			if("gob1".equals(idGame)){	
				TVSlot2.setVisibility(View.GONE);
				layoutSlot2.setVisibility(View.GONE);
				viewSlot2.setVisibility(View.GONE);
				viewSlot1.setImageResource(R.drawable.gobliiins3);		 			
				viewTitle.setText(R.string.help_title_gob1_gobliiins);
				TVSlot1.setText(R.string.help_texte_mage);
				
	    	}else if("gob2".equals(idGame)){
	    		setMargin((float)3/12,0,0,0,TVSlot1);
		        setMargin((float)3/12,0,0,0,TVSlot2);
		       
	    		viewSlot1.setVisibility(View.VISIBLE);
				viewSlot2.setVisibility(View.VISIBLE);
    			viewSlot1.setImageResource(R.drawable.gob2_hotspot);
    			viewSlot2.setImageResource(R.drawable.gob2_menu);
    			viewTitle.setText(R.string.help_title_gob2_interface);
    			TVSlot1.setText(R.string.help_texte_hotspot);
				TVSlot2.setText(R.string.help_texte_menu);
		    	
		    }else if("gob3".equals(idGame)){
		    	setMargin((float)3/12,0,0,0,TVSlot1);
		        setMargin((float)3/12,0,0,0,TVSlot2);
		        setMargin((float)0/12,(float)3/12,(float)1.75/12,(float)6/12,layoutSlot1);
		        setMargin((float)0/12,(float)5/12,(float)1.75/12,(float)4/12,layoutSlot2);
		    	viewSlot1.setVisibility(View.VISIBLE);
				viewSlot2.setVisibility(View.VISIBLE);
				
	    		viewSlot1.setImageResource(R.drawable.gob3_hotspot);
    			viewSlot2.setImageResource(R.drawable.gob3_menu);
    			viewTitle.setText(R.string.help_title_gob2_interface);
    			TVSlot1.setText(R.string.help_texte_hotspot);
				TVSlot2.setText(R.string.help_texte_menu);
		    	
	    	} 
			
			ScaleImage(viewSlot1);
	        ScaleImage(viewSlot2); 
	        ScaleImage(viewSlot3);
 	        
		}
		
		public void loadPageFour(){ // inventaire
			TVSlot2.setVisibility(View.VISIBLE);
			layoutSlot2.setVisibility(View.VISIBLE);
			viewSlot2.setVisibility(View.VISIBLE);
			//Log.e("dotemu","Page 4!!!  "+Language);
			
			if("gob1".equals(idGame)){
				viewTitle.setText(R.string.help_title_gob1_interface);
				viewSlot1.setImageResource(R.drawable.gob1_switchgob);				
				viewSlot2.setImageResource(R.drawable.gob1_action);
				TVSlot1.setText(R.string.help_texte_switchgob);
				TVSlot2.setText(R.string.help_texte_action_gob1);
				ScaleImage(viewSlot1); 
		        ScaleImage(viewSlot2); 
		    	
			}else{
				setMargin((float)1.75/12,0,0,0,TVSlot1);
		        setMargin((float)1.75/12,0,0,0,TVSlot2);
		        setMargin((float)1.75/12,0,0,0,TVSlot3);
				viewTitle.setText(R.string.help_title_gob_save);
				viewSlot1.setVisibility(View.GONE);
				viewSlot2.setVisibility(View.GONE);
				TVSlot1.setText(R.string.help_texte_save1);
				TVSlot2.setText(R.string.help_texte_save2);
			}
				
				
				
				
	
		       
		       
		       
	        
		}
		
		public void loadPageFive(){ // MoveTo
			//Log.e("dotemu","Page 5!!!  "+Language);
			/*TVSlot3.setVisibility(View.VISIBLE);
			layoutSlot3.setVisibility(View.VISIBLE);
			viewSlot3.setVisibility(View.VISIBLE);*/
			if("gob1".equals(idGame)){
				viewSlot1.setVisibility(View.VISIBLE);
				TVSlot2.setVisibility(View.VISIBLE);
				layoutSlot2.setVisibility(View.VISIBLE);
				viewSlot2.setVisibility(View.VISIBLE);
				setMargin((float)3/12,0,0,0,TVSlot1);
				viewSlot1.setImageResource(R.drawable.gob1_hotspot);			
				viewSlot2.setImageResource(R.drawable.gob1_menu);			
			//	viewSlot3.setImageResource(R.drawable.gob1_switchgob);
				viewTitle.setText(R.string.help_title_gob1_interface);
				TVSlot1.setText(R.string.help_texte_hotspot);
				TVSlot2.setText(R.string.help_texte_menu_gob1);
				ScaleImage(viewSlot1);
		        ScaleImage(viewSlot2); 
			}else { 
				setMargin((float)1.75/12,0,0,0,TVSlot1);
		        setMargin((float)1.75/12,0,0,0,TVSlot2);
		        setMargin((float)1.75/12,0,0,0,TVSlot3);
		        if("gob3".equals(idGame)){
		        	setMargin((float)0/12,(float)3/12,(float)1.75/12,(float)6/12,layoutSlot1);
			        setMargin((float)0/12,(float)5/12,(float)1.75/12,(float)4/12,layoutSlot2);
		        }
				TVSlot3.setVisibility(View.GONE);
				layoutSlot3.setVisibility(View.GONE);
				
				viewSlot1.setVisibility(View.GONE);
				viewSlot2.setVisibility(View.GONE);
				viewTitle.setText(R.string.help_title_gob_load);
				
				TVSlot1.setText(R.string.help_texte_load1);
				TVSlot2.setText(R.string.help_texte_load2);
				
			}
		    	
			
	       
			
			
	       
	     
	        
			
		}
		
		public void loadPageSix(){ // News
			//Log.e("dotemu","Page 6!!!  "+Language);
			if("gob1".equals(idGame)){
				viewSlot1.setVisibility(View.GONE);
				TVSlot2.setVisibility(View.GONE);
				layoutSlot2.setVisibility(View.GONE);
				viewSlot2.setVisibility(View.GONE);
				setMargin((float)1.75/12,0,0,0,TVSlot1);
		       
				viewTitle.setText(R.string.help_title_gob_save);
				TVSlot1.setText(R.string.help_texte_save_gob1);
			
				
			}else { 
					if("gob2".equals(idGame)){
			
			
				setMargin((float)1.75/12,0,0,0,TVSlot1);
		        setMargin((float)1.75/12,0,0,0,TVSlot2);
		        setMargin((float)1.75/12,0,0,0,TVSlot3);
				viewSlot1.setVisibility(View.GONE);
				viewSlot2.setVisibility(View.GONE);
				viewTitle.setText(R.string.help_title_gob2_extras);
				TVSlot1.setText(R.string.help_texte_astuces);
				TVSlot2.setText(R.string.help_texte_voyager);
		    	
				}else if("gob3".equals(idGame)){
					setMargin((float)1.75/12,0,0,0,TVSlot1);
			        setMargin((float)1.75/12,0,0,0,TVSlot2);
			        setMargin((float)1.75/12,0,0,0,TVSlot3);
			        setMargin((float)0/12,(float)3/12,(float)1.5/12,(float)6/12,layoutSlot1);
			        setMargin((float)0/12,(float)5/12,(float)1.5/12,(float)4/12,layoutSlot2);
					TVSlot3.setVisibility(View.VISIBLE);
					layoutSlot3.setVisibility(View.VISIBLE);
					viewSlot3.setVisibility(View.GONE);
					viewSlot2.setVisibility(View.GONE);
					viewSlot1.setVisibility(View.GONE);
					viewTitle.setText(R.string.help_title_gob3_extras);		
				//
			    		TVSlot1.setText(R.string.help_texte_astuces);			 		 			
				 	    TVSlot3.setText(R.string.help_texte_mapmonde);
				 	    TVSlot2.setText(R.string.help_texte_journal);
			    		
			    
				}
			}
			
			
	        	
			
			
	       // ScaleImage(viewSlot2); 
	    
	        
	        

		}
		
		public void loadPageSeven(){
			viewSlot1.setVisibility(View.GONE);
			TVSlot2.setVisibility(View.GONE);
			layoutSlot2.setVisibility(View.GONE);
			viewSlot2.setVisibility(View.GONE);
			setMargin((float)1.75/12,0,0,0,TVSlot1);
			
			viewTitle.setText(R.string.help_title_gob_load);
			TVSlot1.setText(R.string.help_texte_load_gob1);
			
		}
		
		public void loadPageHeight(){
			TVSlot3.setVisibility(View.GONE);
			layoutSlot3.setVisibility(View.GONE);
			viewSlot3.setVisibility(View.GONE);
			viewSlot1.setVisibility(View.GONE);
			TVSlot2.setVisibility(View.GONE);
			layoutSlot2.setVisibility(View.GONE);
			viewSlot2.setVisibility(View.GONE);
			viewTitle.setText(R.string.help_title_gob1_astuces);
			TVSlot1.setText(R.string.help_texte_astuces_gob1);
		}
		
	         
	          
	        
	  
	    public void ScaleImage(ImageView view) {
    		
	    	
	    	   Drawable drawing = view.getDrawable();
	           if (drawing == null) {
	               return; 
	           }
	           Bitmap bitmap = ((BitmapDrawable)drawing).getBitmap();

	       	  
	       	  int width = bitmap.getWidth();
	       	  int height = bitmap.getHeight();
	       	 // Log.i("dotemu","!!!!!!bitmap " + width + "," +height);
	       	
	       	  Display display = getWindowManager().getDefaultDisplay();
	       	 
	             
	       	  int screen_width = display.getWidth();
	       	  int screen_height = display.getHeight();
	       	  
	       	  float xScale = ((float) screen_width) / 1280 ; //pour la matrice qui double le scale
	       	  float yScale = ((float) screen_height) / 720 ;
	       	 // Log.i("dotemu","!!!!!!!Screen " + screen_width + "," +screen_height);
	       	 // Log.i("dotemu","!!!!!!!Scale " + xScale + "," +yScale);
	       	 
	       	  int newWidth=(int) (width*xScale);
	       	  int newHeight=(int) (height*yScale);
	       //	Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	   	   // Log.i("Test", "scaled height = " + Integer.toString(newHeight));
	       	  /* Matrix matrix = new Matrix();

	       	  	matrix.postScale(xScale, yScale);
		
	   	  
	   	    Bitmap scaledBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
	   	    width = scaledBitmap.getWidth(); 
	   	    height = scaledBitmap.getHeight(); 
	   	    BitmapDrawable result = new BitmapDrawable(scaledBitmap);
	   	    Log.i("Test", "scaled width = " + Integer.toString(width));
	   	    Log.i("Test", "scaled height = " + Integer.toString(height));

	   	   */
	   		Bitmap scaledBitmap=Bitmap.createScaledBitmap(bitmap, newWidth, newHeight, false);
	   		BitmapDrawable result = new BitmapDrawable(scaledBitmap);
	   		view.setImageDrawable(result);
	   		//Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	   	  //  Log.i("Test", "scaled height = " + Integer.toString(newHeight));
	   	    RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
	   	    params.width = newWidth;
	   	    params.height = newHeight;
	   	    view.setLayoutParams(params);

	   	   // Log.i("Test", "done");
	    }
	    private static String getSizeName(Context context) {
	        int screenLayout = context.getResources().getConfiguration().screenLayout;
	        screenLayout &= Configuration.SCREENLAYOUT_SIZE_MASK;

	        switch (screenLayout) {
	       
	        case Configuration.SCREENLAYOUT_SIZE_SMALL:
	            return "small";
	        case Configuration.SCREENLAYOUT_SIZE_NORMAL:
	            return "normal";
	        case Configuration.SCREENLAYOUT_SIZE_LARGE:
	            return "large";
	        case 4: // Configuration.SCREENLAYOUT_SIZE_XLARGE is API >= 9
	            return "xlarge";
	        default:
	            return "undefined";
	        }
	    }
	    
	    

	public void setMargin(float coefbeginx,float coefbeginy,float coefendx,float coefendy,View view){
		Display display = getWindowManager().getDefaultDisplay();
		  int screen_width = display.getWidth();
		  int screen_height = display.getHeight();
		  float margbeginX=coefbeginx*screen_width;
		  float margendX=coefendx*screen_width;
		  float  margbeginY=coefbeginy*screen_height;
		  float  margendY=coefendy*screen_height;
		 // Log.i("dotemu","!!!!!!!!!!X "+margbeginX+"Y"+margbeginY);
		  RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
		    params.setMargins((int)margbeginX,(int)margbeginY, (int)margendX,(int)margendY);
		    
		    view.setLayoutParams(params);
	}

	public void onPause(){
		super.onPause(); 

		if(!continueMusic)
			MusicManager.pause();
	}

	@Override
	public void onResume(){
		super.onResume(); 

		continueMusic = false;

		Bundle b=getIntent().getExtras();
		final String idGame=b.getString("game");

		if("gob1".equals(idGame))      
			MusicManager.start(this, MusicManager.MUSIC_GOB1);   
		else if("gob2".equals(idGame))
			MusicManager.start(this, MusicManager.MUSIC_GOB2);
		else if("gob3".equals(idGame))
			MusicManager.start(this, MusicManager.MUSIC_GOB3);
	}
	
	@Override
	public void onBackPressed() {
		super.onBackPressed();
		
		continueMusic = true;
	}
}
