package com.dotemu.gobliiins;
import java.util.Locale;

import com.dotemu.gobliiins.R;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.MemoryInfo;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Typeface;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.util.TypedValue;
import android.view.Display;
import android.view.View;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebStorage;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class HintViewActivity extends Activity {

    private WebView webView;
    private int idLvl;
    private String idGame;
    private ImageView buttonSuiv;
    private ImageView buttonPrec;
    private Button buttonHint1;
    private Button buttonHint2;
    private Button buttonHint3;
    private Button buttonBack;
    private boolean loaded=false;
    private int hint=1;
	 private String Language;
	    /** Called when the activity is first created. */
	    @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        //Log.i("dotemu","oncreate");
	        setContentView(R.layout.hint_view_activty);
	        //Log.i("dotemu","getExtra");
	        Bundle b=getIntent().getExtras();

	        //Log.i("dotemu","getidlvl");
	        idLvl=b.getInt("idLvl");
	        //Log.i("dotemu","getGame");
	        idGame=b.getString("game");
	        //Log.i("dotemu","Init");
	        
	        ImageView viewTitle= (ImageView) findViewById(R.id.title_hint);
	         buttonHint1 = (Button) findViewById(R.id.hint1);
	         buttonHint2 = (Button)findViewById(R.id.hint2);
	         buttonHint3 = (Button)findViewById(R.id.hint3);
	        buttonSuiv= (ImageView) findViewById(R.id.hint_suiv);
	        buttonPrec=(ImageView) findViewById(R.id.hint_prec);
	        buttonBack=(Button) findViewById(R.id.back_hint);
	      
	        
	       webView = (WebView) findViewById(R.id.webview_hint);
	        
	        RelativeLayout globalLayout=(RelativeLayout) findViewById(R.id.layout_hint);
	        
	        Typeface font = Typeface.createFromAsset(getAssets(), "fonts/8bitoperator.ttf");
	       	buttonHint1.setTypeface(font);
	       	buttonHint2.setTypeface(font);
	       	buttonHint3.setTypeface(font);
	       	buttonBack.setTypeface(font);
	       	
	        webView.setBackgroundColor(Color.TRANSPARENT);
	         if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
		 }
	      
	        Language=Locale.getDefault().getLanguage();
			//Log.i("dotemu","Language = "+ Language);
			
			if(!"fr".equals(Language) && !"en".equals(Language))
				Language="en";
	       
			WebSettings webSettings = webView.getSettings();
			String sizeType=getSizeName(this);
	        if("small".equals(sizeType)){
	        	 if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(50);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.SMALLEST);
	        	//Log.i("HintView","small screen");
	        	 buttonHint1.setTextSize(TypedValue.COMPLEX_UNIT_DIP,8);
	 	        buttonHint2.setTextSize(TypedValue.COMPLEX_UNIT_DIP,8);
	 	        buttonHint3.setTextSize(TypedValue.COMPLEX_UNIT_DIP,8);
	 	       buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,7);
	        }else if("large".equals(sizeType)){
	        	//Log.i("HintView","large screen");
	        	 buttonHint1.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 22);
	 	        buttonHint2.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 22);
	 	        buttonHint3.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 22);
	 	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(150);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.LARGER);
	        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,17);
	        }else if("xlarge".equals(sizeType)){
	        	//Log.i("HintView","xlarge screen");
	        	 buttonHint1.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 36);
	 	        buttonHint2.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 36);
	 	        buttonHint3.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 36);
	 	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(200);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.LARGEST);
	        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
	        }else{		//normal
	        	//Log.i("HintView","normal screen");
	        	 buttonHint1.setTextSize(TypedValue.COMPLEX_UNIT_DIP,14 );
	 	        buttonHint2.setTextSize(TypedValue.COMPLEX_UNIT_DIP,14 );
	 	        buttonHint3.setTextSize(TypedValue.COMPLEX_UNIT_DIP,14 );
	 	       if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
	        		 webSettings. setTextZoom(100);
	    		 }else webSettings.setTextSize(WebSettings.TextSize.NORMAL);
	        	buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);
	    	}
	        webSettings.setDefaultTextEncodingName("utf-8");
	        
	        webView.getSettings().setCacheMode(WebSettings.LOAD_NO_CACHE);
	        buttonBack.setText(R.string.button_back);
	        if("en".equals(Language)){
    		 	
    		 	
    		 	buttonHint1.setText("Hint 1");
    		 	
    		 	buttonHint2.setText("Hint 2");
    		 	
    		 	buttonHint3.setText("Hint 3");
 
    		 
    	 }else{
    		
    		 
    		 	buttonHint1.setText("Astuce 1");
    		 	
    		 	buttonHint2.setText("Astuce 2");
    		 	
    		 	buttonHint3.setText("Astuce 3");
             
             
    	 }
	        if("gob1".equals(idGame)){
	        	 //Log.i("dotemu","gob1");
	        	buttonHint1.setBackgroundResource(R.drawable.gob1_bgbutton);
	        	buttonHint2.setBackgroundResource(R.drawable.gob1_bgbutton);
	        	buttonHint3.setBackgroundResource(R.drawable.gob1_bgbutton);
	        	 buttonSuiv.setVisibility(View.GONE);
	      		 buttonPrec.setVisibility(View.GONE);
	      		buttonBack.setBackgroundResource(R.drawable.gob1_button_small);
	        	globalLayout.setBackgroundResource(R.drawable.credits_gob1_background);
	        	if(idLvl==14){
	        		buttonHint3.setVisibility(View.GONE);
	        		
	        	}
	        }
	        if("gob2".equals(idGame)){
	        	 //Log.i("dotemu","gob2");
	        	
	        	 buttonBack.setBackgroundResource(R.drawable.gob2_button_small);
	        	 	buttonHint1.setBackgroundResource(R.drawable.gob2_bgbutton);
		        	buttonHint2.setBackgroundResource(R.drawable.gob2_bgbutton);
		        	buttonHint3.setBackgroundResource(R.drawable.gob2_bgbutton);
	        		buttonSuiv.setImageResource(R.drawable.hint_suiv);
	             	buttonPrec.setImageResource(R.drawable.hint_prec);
	        	globalLayout.setBackgroundResource(R.drawable.credits_gob2_background);
	        }
	        
	 		if("gob3".equals(idGame)){
	 			 //Log.i("dotemu","gob3");
	 			
	 			buttonBack.setBackgroundResource(R.drawable.gob3_button_small);
	 			buttonHint1.setBackgroundResource(R.drawable.gob3_bgbutton);
	        	buttonHint2.setBackgroundResource(R.drawable.gob3_bgbutton);
	        	buttonHint3.setBackgroundResource(R.drawable.gob3_bgbutton);
	 			buttonSuiv.setImageResource(R.drawable.hint_suiv);
             	buttonPrec.setImageResource(R.drawable.hint_prec);
	        	
	        	globalLayout.setBackgroundResource(R.drawable.credits_gob3_background);
	        }
	     
	       //Log.i("dotemu","scaleImage");
	        
	        
	        ScaleImage(viewTitle);
	      
	        ScaleImage(buttonSuiv);
	        ScaleImage(buttonPrec);
	       
	      
	        //Log.i("dotemu","setMargin");
	        
	  
	        setMargin((float)26/31,(float)1/31,(float)0.5/31,(float)27.25/31,buttonBack);
	        	
		        setMargin((float)4/20,(float)13/20,(float)12/20,(float)5/20,buttonHint3);
		        setMargin((float)4/20,(float)9/20,(float)12/20,(float)9/20,buttonHint2);
		        setMargin((float)4/20,(float)5/20,(float)12/20,(float)13/20,buttonHint1);
		        setMargin((float)10/20,(float)18/20,0,0,buttonPrec);
		        setMargin((float)17/20,(float)18/20,0,0,buttonSuiv);
		        setMargin((float)10/20,(float)2.8/20,(float)1.5/20,(float)2.3/20,webView);  
	        
        // Try WebView
      
        webView.setWebChromeClient(new WebChromeClient());

       webView.getSettings().setJavaScriptEnabled(true);
        
       
       buttonBack.setOnClickListener(new View.OnClickListener() {
	       	 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				finish();
			}
		});
	
        
       buttonSuiv.setOnClickListener(new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			if(loaded){
				//clear();
				idLvl++;
				loadHtml();
			}
		}
	});
       
       buttonPrec.setOnClickListener(new View.OnClickListener() {
   		
   		@Override
   		public void onClick(View v) {
   			if(loaded){
   			//	clear();
	   			idLvl--;
	   			loadHtml();
   			}
   		}
   	});
	    
	    
	   
	
	    
       
            	/*webView.loadUrl("javascript:(function() { " +  
                        "document.getElementsByTagName('body')[0].style.color = 'red'; " +  
                        "})()");  */
            
                    /*	webView.loadUrl("javascript:(function() { " +  
                                "document.getElementById('question').style.color='black';"+"}) ()");
                    	webView.loadUrl("javascript:(function() { " +  
                                "document.getElementById('answer').style.color='black';"+"}) ()");*/
         
	    webView.setWebViewClient(new WebViewClient(){
            @Override
            public void onPageFinished(WebView view, String url){
            	
            		updateHint();
            	 
            	// clear();
            	// System.gc();
            	 loaded=true;
               
            	
            }
            
	    });
	    buttonHint1.setOnClickListener(new View.OnClickListener() {
	       	 
			@Override
			public void onClick(View v) {
				if(loaded){
					
					loaded=false;
					hint=1;
				//	clear();
					webView.loadUrl ("about: blank");
					loadHtml();
					// updateHint();					 
				}
			}
		});
	    buttonHint2.setOnClickListener(new View.OnClickListener() {
	       	 
			@Override
			public void onClick(View v) {
				if(loaded){
					
					loaded=false;
					hint=2;
					//webView.loadUrl ("about: blank");
				//	clear();
					webView.reload();
					//updateHint();
					
				}
			}
		});
	    buttonHint3.setOnClickListener(new View.OnClickListener() {
	       	 
			@Override
			public void onClick(View v) {
				if(loaded){
					
					hint=3;
					loaded=false;
					//clear();
					//webView.loadUrl ("about: blank");
					webView.reload();
					//updateHint();
				}
            	
			}
		});
            		
	            	
	            
	           	
	            
            	
         
       

        //webView.addJavascriptInterface(new JavaScriptInterface(this), "MyAndroid");
       // webView.loadUrl("http://code.google.com/android");
      loadHtml();
      
        //SystemClock.sleep(1000);
        //webView.loadUrl("javascript:getValue()");
    }
	    
	    public void clear(){
	    //	webView . loadUrl ( "about:blank" ); 
	    webView.clearAnimation();
        webView.clearDisappearingChildren();
        webView.clearCache(true);
      	webView.destroyDrawingCache();
      	webView.clearFormData();
      	webView.clearHistory();
      	webView.clearMatches();
      	webView.freeMemory();
      	//webView.removeView(webView);
      //WebStorage.getInstance().deleteAllData();
        
      	getApplicationContext().deleteDatabase("webview.db");
      	getApplicationContext().deleteDatabase("webviewCache.db");
      	
	    }
	    public void updateHint(){
	    	
	    	
	    	switch(hint){
	    	case 1:
	    		//Log.i("dotemu","hint 1 !!!!!");
	    		webView.loadUrl("javascript:(function() { " +  
	    				"document.getElementById('hint2').style.display='none';"+"}) ()");
	    		webView.loadUrl("javascript:(function() { " +  
	    				"document.getElementById('hint3').style.display='none';"+"}) ()");
	    		webView.loadUrl("javascript:(function() { " +  
	    				"document.getElementById('hint1').style.display='block';"+"}) ()");
		        webView.setBackgroundColor(Color.TRANSPARENT);
		        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
	    			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
	    		 }
	    		break;
	    	
	    	case 2:
	    		//Log.i("dotemu","hint 2 !!!!!");
        		webView.loadUrl("javascript:(function() { " +  
        				"document.getElementById('hint1').style.display='none';"+"}) ()");
        		webView.loadUrl("javascript:(function() { " +  
        				"document.getElementById('hint3').style.display='none';"+"}) ()");
        		webView.loadUrl("javascript:(function() { " +  
        				"document.getElementById('hint2').style.display='block';"+"}) ()");
    	        webView.setBackgroundColor(Color.TRANSPARENT);
    	           if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
   			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
   		 }
	    		break;
	    	case 3:
	    		//Log.i("dotemu","hint 3 !!!!!");
        		webView.loadUrl("javascript:(function() { " +  
        				"document.getElementById('hint1').style.display='none';"+"}) ()");
        		webView.loadUrl("javascript:(function() { " +  
        				"document.getElementById('hint2').style.display='none';"+"}) ()");
        		webView.loadUrl("javascript:(function() { " +  
        				"document.getElementById('hint3').style.display='block';"+"}) ()");
    	        webView.setBackgroundColor(Color.TRANSPARENT);
    	           if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
   			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
   		 }
        		break;
	    	}
	    }
	    
	    public void loadHtml(){
	    	
	    	  if("gob1".equals(idGame)){
	          	if("en".equals(Language))
	          		webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/hints/en/"+idLvl+".html");
	          	else webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/hints/fr/"+idLvl+"_fr.html");
	          	
		        webView.setBackgroundColor(Color.TRANSPARENT);
		           if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
   			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
   		 }
	          }
	          
	          if("gob3".equals(idGame)){
	          	if("en".equals(Language))
	          		webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/hints/en/"+idLvl+".html");
	          	else webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/hints/fr/"+idLvl+"_fr.html");
	          	
		        webView.setBackgroundColor(Color.TRANSPARENT);
		           if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
   			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
   		 }
				switch( idLvl )
				{
					case 41: 
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 42:
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break; 
					case 51: 
						
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 52:
						
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 53:
						
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 71: 
									
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 72:
								
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 73:
						
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 81: 
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 82:
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 91: 
							
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 92:
						
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 93:
						
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 101: 
							
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 102:
						
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 103:
						
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 111: 
							
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;
					case 112:
						
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;
					case 113:
						
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 114:
						
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 121:
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;	
					case 122:
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 131:
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;	
					case 132:
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					case 141:
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);
						
						break;	
					case 142:
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;		
					case 171:
						buttonSuiv.setVisibility(View.VISIBLE);
						buttonPrec.setVisibility(View.GONE);;
						
						break;	
					case 172:
						buttonSuiv.setVisibility(View.GONE);
						buttonPrec.setVisibility(View.VISIBLE);
						
						break;	
					default:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.GONE);
				}
	         }
	         
	          if("gob2".equals(idGame)){
		          	if("en".equals(Language))
		          		webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/hints/en/"+idLvl+".html");
		          	else webView.loadUrl("file:///sdcard/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/hints/fr/"+idLvl+"_fr.html");
		          	
			        webView.setBackgroundColor(Color.TRANSPARENT);
			        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
		    			 webView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
		    		 }
		        
		          switch( idLvl )
		      	{
		      		case 110: //WORLD 1
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 111:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break; 
		      		case 120:
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 121:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break; 	
		      		case 280: //WORLD 2
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 281:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break; 	
		      		case 300: //WORLD 3
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 301:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break; 		
		      		case 420: //WORLD 4
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 421:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break; 			
		      		case 430: //WORLD 4
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 431:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break; 	
		      		case 550: //WORLD 5
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 551:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break;
		      		case 560:
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;	
		      		case 561:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break;			
		      		case 680: //WORLD 6
		      			//idLvl = 680;	
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      		case 681:
		      			//idLvl = 681;
		      			buttonSuiv.setVisibility(View.VISIBLE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break;		
		      		case 682:
		      			//idLvl = 682;
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.VISIBLE);
		      			
		      			break;		
		      		case 710: //WORLD 7
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;		
		      		default:
		      			buttonSuiv.setVisibility(View.GONE);
		      			buttonPrec.setVisibility(View.GONE);
		      			
		      			break;
		      	 }	
	          }
	      	
	    }
	   
	    public void ScaleImage(ImageView view) {
    		
	    	
	    	   Drawable drawing = view.getDrawable();
	           if (drawing == null) {
	               return; 
	           }
	           Bitmap bitmap = ((BitmapDrawable)drawing).getBitmap();

	       	  
	       	  int width = bitmap.getWidth();
	       	  int height = bitmap.getHeight();
	       	  //Log.i("dotemu","!!!!!!bitmap " + width + "," +height);
	       	
	       	  Display display = getWindowManager().getDefaultDisplay();
	       	 
	             
	       	  int screen_width = display.getWidth();
	       	  int screen_height = display.getHeight();
	       	  
	       	  float xScale = ((float) screen_width) / 1280 ; //pour la matrice qui double le scale
	       	  float yScale = ((float) screen_height) / 720 ;
	       	  //Log.i("dotemu","!!!!!!!Screen " + screen_width + "," +screen_height);
	       	  //Log.i("dotemu","!!!!!!!Scale " + xScale + "," +yScale);
	       	 
	       	  int newWidth=(int) (width*xScale);
	       	  int newHeight=(int) (height*yScale);
	       	//Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	   	    //Log.i("Test", "scaled height = " + Integer.toString(newHeight));
	       	  /* Matrix matrix = new Matrix();

	       	  	matrix.postScale(xScale, yScale);
		
	   	  
	   	    Bitmap scaledBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
	   	    width = scaledBitmap.getWidth(); 
	   	    height = scaledBitmap.getHeight(); 
	   	    BitmapDrawable result = new BitmapDrawable(scaledBitmap);
	   	    Log.i("Test", "scaled width = " + Integer.toString(width));
	   	    Log.i("Test", "scaled height = " + Integer.toString(height));

	   	   */
	   		Bitmap scaledBitmap=Bitmap.createScaledBitmap(bitmap, newWidth, newHeight, false);
	   		BitmapDrawable result = new BitmapDrawable(scaledBitmap);
	   		view.setImageDrawable(result);
	   		//Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	   	    //Log.i("Test", "scaled height = " + Integer.toString(newHeight));
	   	    RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
	   	    params.width = newWidth;
	   	    params.height = newHeight;
	   	    view.setLayoutParams(params);

	   	    //Log.i("Test", "done");
	    }
	    private static String getSizeName(Context context) {
	        int screenLayout = context.getResources().getConfiguration().screenLayout;
	        screenLayout &= Configuration.SCREENLAYOUT_SIZE_MASK;

	        switch (screenLayout) {
	       
	        case Configuration.SCREENLAYOUT_SIZE_SMALL:
	            return "small";
	        case Configuration.SCREENLAYOUT_SIZE_NORMAL:
	            return "normal";
	        case Configuration.SCREENLAYOUT_SIZE_LARGE:
	            return "large";
	        case 4: // Configuration.SCREENLAYOUT_SIZE_XLARGE is API >= 9
	            return "xlarge";
	        default:
	            return "undefined";
	        }
	    }
	    
	    

	public void setMargin(float coefbeginx,float coefbeginy,float coefendx,float coefendy,View view){
		Display display = getWindowManager().getDefaultDisplay();
		  int screen_width = display.getWidth();
		  int screen_height = display.getHeight();
		  float margbeginX=coefbeginx*screen_width;
		  float margendX=coefendx*screen_width;
		  float  margbeginY=coefbeginy*screen_height;
		  float  margendY=coefendy*screen_height;
		  //Log.i("dotemu","!!!!!!!!!!X "+margbeginX+"Y"+margbeginY);
		  RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
		    params.setMargins((int)margbeginX,(int)margbeginY, (int)margendX,(int)margendY);
		    
		    view.setLayoutParams(params);
	}
}
