package com.dotemu.gobliiins;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Locale;

import com.dotemu.gobliiins.R;

import android.R.bool;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Point;
import android.graphics.Typeface;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;
import android.util.TypedValue;
import android.view.Display;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;


public class MainMenuActivity extends Activity {

	 private String Language;
	 private boolean continueMusic = false;
	 static int p_music = 256;
	 private SharedPreferences ratingPrefs;

	 
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //Log.i("dotemu","oncreate");
        setContentView(R.layout.activity_main_menu);
        
        ratingPrefs = getSharedPreferences("ratingPrefs", Context.MODE_PRIVATE);

       
        Bundle b=getIntent().getExtras();
        final String idGame=b.getString("game");
        final Button buttonNew = (Button) findViewById(R.id.news);
       
        final Button buttonLoad 		= (Button)findViewById(R.id.load);
        final Button buttonCredit 		= (Button)findViewById(R.id.credits);
        final Button buttonSettings 	= (Button)findViewById(R.id.settings);
        final Button buttonHelp 		= (Button)findViewById(R.id.help);
        final ImageView buttonBack 		= (ImageView)findViewById(R.id.back);
        final ImageView buttonMoreGames = (ImageView)findViewById(R.id.moregames);
    
        Typeface font = Typeface.createFromAsset(getAssets(), "fonts/ARCADECLASSIC.TTF");
       	buttonLoad.setTypeface(font,Typeface.ITALIC);
       	buttonNew.setTypeface(font,Typeface.ITALIC);
       	buttonCredit.setTypeface(font,Typeface.ITALIC);
       	buttonSettings.setTypeface(font,Typeface.ITALIC);
       	buttonHelp.setTypeface(font,Typeface.ITALIC);
       /* FullsizeTextButton button = (FullsizeTextButton) findViewById(R.id.button);
        button.setText("Héhéhéhé");
        
        setMargin((float)6/12,(float)6/12,0,(float)5/12,button);*/
        String sizeType=getSizeName(this);
        
        if(Locale.getDefault().getLanguage().equals("ru"))
        {
            if("small".equals(sizeType)){
            	
            	//Log.i("HintView","small screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26);
            }else if("large".equals(sizeType)){
            	//Log.i("HintView","large screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,39);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,39);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,39);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,39);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,39);
            	
            }else if("xlarge".equals(sizeType)){
            	//Log.i("HintView","xlarge screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,56);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,56);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,56);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,56);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,56);	
            }else{		//normal
            	//Log.i("HintView","normal screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,23);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,23);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,23);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,23);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,23);
        	}
        }
        else
        {
            if("small".equals(sizeType)){
            	
            	//Log.i("HintView","small screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
            }else if("large".equals(sizeType)){
            	//Log.i("HintView","large screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,49);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,49);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,49);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,49);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,49);
            	
            }else if("xlarge".equals(sizeType)){
            	//Log.i("HintView","xlarge screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,66);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,66);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,66);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,66);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,66);	
            }else{		//normal
            	//Log.i("HintView","normal screen");
            	buttonNew.setTextSize(TypedValue.COMPLEX_UNIT_DIP,33);
     	        buttonLoad.setTextSize(TypedValue.COMPLEX_UNIT_DIP,33);
     	        buttonCredit.setTextSize(TypedValue.COMPLEX_UNIT_DIP,33);
     	        buttonSettings.setTextSize(TypedValue.COMPLEX_UNIT_DIP,33);
     	       buttonHelp.setTextSize(TypedValue.COMPLEX_UNIT_DIP,33);
        	}	
        }

        
        RelativeLayout  globalLayout = (RelativeLayout) findViewById(R.id.main_menu_layout);
        
        Language=Locale.getDefault().getLanguage();
		//Log.i("dotemu","Language = "+ Language);
		
		buttonNew.setText(R.string.ppal_nouveau);
		 
     	buttonLoad.setText(R.string.ppal_load);
     	
     	buttonCredit.setText(R.string.ppal_credits);
     
     	buttonSettings.setText(R.string.ppal_option);
     
     	buttonHelp.setText(R.string.ppal_help);
        
     	buttonNew.setTextColor(Color.YELLOW);
		 
     	buttonLoad.setTextColor(Color.RED);
     	
     	buttonCredit.setTextColor(Color.RED);
     
     	buttonSettings.setTextColor(Color.RED);
     
     	buttonHelp.setTextColor(Color.RED);
     	
    	
    	//Read text from file
    	String NOTES ="settings.dat";
    	File file = new File(Environment.getExternalStorageDirectory()+"/Android/data/com.dotemu.gobliiins/files/Gob/", NOTES);	 
    	
    	try {
			
			if(file.exists()){
				file.createNewFile();
            	BufferedReader br = new BufferedReader(new FileReader(file));
                String line;
                
	            line=br.readLine();
	            p_music= Integer.parseInt(line);
	                          //Log.d("MainMenuActivity","p_music="+p_music);
        		br.close();
			}
        	
    	} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
        if("gob1".equals(idGame))
        { 
        	globalLayout.setBackgroundResource(R.drawable.main_menu_gob1_background);
        	
        	buttonBack.setImageResource(R.drawable.gob1_btn_back_carr);
        }
        if("gob2".equals(idGame))
        {
        	globalLayout.setBackgroundResource(R.drawable.main_menu_gob2_background);
        	
        	buttonBack.setImageResource(R.drawable.gob2_btn_back_carr);
        }
 		if("gob3".equals(idGame))
 		{
 			 //Log.i("dotemu","gob3");
 			    	
 			 globalLayout.setBackgroundResource(R.drawable.main_menu_gob3_background);
 			 
 			buttonBack.setImageResource(R.drawable.gob3_btn_back_carr);
 		}
     
       //Log.i("dotemu","scaleImage");
        ScaleImage(buttonBack);
        
        //Log.i("dotemu","setMargin");
        
        RelativeLayout layoutDroite = (RelativeLayout) findViewById(R.id.BlocDroit);
        setMargin((float)20/31,(float)9/18,(float)2/31,(float)1/18,layoutDroite);
       
        setMargin(0,(float)0	,0 ,(float)6/18,	buttonNew);  
        setMargin(0,(float)2/18	,0 ,(float)4/18, 	buttonLoad);
        setMargin(0,(float)4/18	,0 ,(float)2/18, 	buttonHelp);
        setMargin(0,(float)6/18	,0 ,(float)0,		buttonSettings);
        
        setMargin((float)0.5/18,(float)0.5/18,0,0,buttonBack);
        setMargin((float)0.5/18,(float)6/18,0,(float)1/18,buttonCredit);
        
        buttonNew.setOnTouchListener(new View.OnTouchListener() {
			
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				buttonNew.setTextColor(Color.YELLOW);
				 
		     	buttonLoad.setTextColor(Color.RED);
		     	
		     	buttonCredit.setTextColor(Color.RED);
		     
		     	buttonSettings.setTextColor(Color.RED);
		     
		     	buttonHelp.setTextColor(Color.RED);
		     	return false;
			}
		});
		 buttonLoad.setOnTouchListener(new View.OnTouchListener() {
				
				@Override
				public boolean onTouch(View v, MotionEvent event) {
					buttonNew.setTextColor(Color.RED);
					 
			     	buttonLoad.setTextColor(Color.YELLOW);
			     	
			     	buttonCredit.setTextColor(Color.RED);
			     
			     	buttonSettings.setTextColor(Color.RED);
			     
			     	buttonHelp.setTextColor(Color.RED);
			     	return false;
				}
			});
			 buttonSettings.setOnTouchListener(new View.OnTouchListener() {
					
					@Override
					public boolean onTouch(View v, MotionEvent event) {
						buttonNew.setTextColor(Color.RED);
						 
				     	buttonLoad.setTextColor(Color.RED);
				     	
				     	buttonCredit.setTextColor(Color.RED);
				     
				     	buttonSettings.setTextColor(Color.YELLOW);
				     
				     	buttonHelp.setTextColor(Color.RED);
				     	return false;
					}
				});
				 buttonHelp.setOnTouchListener(new View.OnTouchListener() {
						
						@Override
						public boolean onTouch(View v, MotionEvent event) {
							buttonNew.setTextColor(Color.RED);
							 
					     	buttonLoad.setTextColor(Color.RED);
					     	
					     	buttonCredit.setTextColor(Color.RED);
					     
					     	buttonSettings.setTextColor(Color.RED);
					     
					     	buttonHelp.setTextColor(Color.YELLOW);
					     	return false;
						}
					});
					 buttonCredit.setOnTouchListener(new View.OnTouchListener() {
							
							@Override
							public boolean onTouch(View v, MotionEvent event) {
								buttonNew.setTextColor(Color.RED);
								 
						     	buttonLoad.setTextColor(Color.RED);
						     	
						     	buttonCredit.setTextColor(Color.YELLOW);
						     
						     	buttonSettings.setTextColor(Color.RED);
						     
						     	buttonHelp.setTextColor(Color.RED);
								return false;
							}
						});
        
        buttonNew.setOnClickListener(new View.OnClickListener() 
        {	
			@Override
			public void onClick(View v) 
			{	
				
				if("gob1".equals(idGame)){
					String NOTES ="save.dat";
	            	File file = new File(Environment.getExternalStorageDirectory()+"/Android/data/com.dotemu.gobliiins/files/Gob/Gob1/", NOTES);    	 
	            	
	            	try {
						file.createNewFile();
						FileWriter filewriter = new FileWriter(file,false);
						filewriter.write("1");
						filewriter.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				if("gob2".equals(idGame)){
					String NOTES ="save.dat";
	            	File file = new File(Environment.getExternalStorageDirectory()+"/Android/data/com.dotemu.gobliiins/files/Gob/Gob2/", NOTES);
	            	 
	            	
	            	try {
						
						//Log.e("dotemu)","file exist?");
						if(file.exists()){
							file.createNewFile();	
							StringBuilder text = new StringBuilder();
							BufferedReader br = new BufferedReader(new FileReader(file));
							String line="";
							
							//Log.e("dotemu)","read+write file gob2");
							
							br.readLine();
							while ((line = br.readLine()) != null) {
								 text.append(line);
								 text.append("\r\n");
							}
							//Log.e("dotemu)",text.toString());
							
							br.close();
							
							FileWriter filewriter = new FileWriter(file,false);					
							filewriter.write("20\r\n");
							filewriter.write(text.toString());
							filewriter.close();
							
						}
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				if("gob3".equals(idGame)){
					String NOTES ="save.dat";
	            	File file = new File(Environment.getExternalStorageDirectory()+"/Android/data/com.dotemu.gobliiins/files/Gob/Gob3/", NOTES);            	 
	            	
	            	try {
						
						//Log.e("dotemu)","file exist?");
						if(file.exists()){
							file.createNewFile();	
							StringBuilder text = new StringBuilder();
							BufferedReader br = new BufferedReader(new FileReader(file));
							String line="";
							
							//Log.e("dotemu)","read+write file gob3");
							
							br.readLine();
							while ((line = br.readLine()) != null) {
								 text.append(line);
								 text.append("\r\n");
							}
							
							//Log.e("dotemu)",text.toString());
							br.close();
							
							FileWriter filewriter = new FileWriter(file,false);					
							filewriter.write("20\r\n");
							filewriter.write(text.toString());
							filewriter.close();
							
						}
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				
				ratingPrefs.edit().putInt("nbPlayed", ratingPrefs.getInt("nbPlayed", 0) + 1).commit();
				
				Intent t = new Intent(MainMenuActivity.this, Unpacker.class);
				t.putExtra("game",idGame);
				startActivity(t);
			}
		});
        
        buttonLoad.setOnClickListener(new View.OnClickListener() {
        	 
			@Override
			public void onClick(View v) {
				
				
				//continueMusic = true;
				
				ratingPrefs.edit().putInt("nbPlayed", ratingPrefs.getInt("nbPlayed", 0) + 1).commit();
				
				// TODO Auto-generated method stub
				Intent t = new Intent(MainMenuActivity.this, Unpacker.class);
				t.putExtra("game",idGame);
				startActivity(t);
			}
		});
        
        buttonSettings.setOnClickListener(new View.OnClickListener() {
        	
        	
        	@Override
			public void onClick(View v) {
        		
        		int music=256;
        		int sfx=256;
        		boolean checked=false;
        		continueMusic = true;
            	//Read text from file
            	String NOTES ="settings.dat";
            	File file = new File(Environment.getExternalStorageDirectory()+"/Android/data/com.dotemu.gobliiins/files/Gob/", NOTES);
            	 
            	
            	try {
					
					if(file.exists()){
						file.createNewFile();
		            	BufferedReader br = new BufferedReader(new FileReader(file));
		                String line;
		                 
			            line=br.readLine();
			            music= Integer.parseInt(line);
			            line=br.readLine();
			            sfx= Integer.parseInt(line);
			            line=br.readLine();
			            checked= Boolean.parseBoolean(line);
		                
	            		br.close();
					}
	            	
            	} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				// TODO Auto-generated method stub
				Intent t = new Intent(MainMenuActivity.this,SettingsMenuActivity.class);
				t.putExtra("game",idGame);
				t.putExtra("menu_sound", music);
				t.putExtra("sfx_sound",sfx);
				t.putExtra("Checked",checked);
				t.putExtra("in_game", false);
				startActivity(t);
			}
		});
        
        
        buttonCredit.setOnClickListener(new View.OnClickListener() {
        	 
			@Override
			public void onClick(View v) {
				
				continueMusic = true;
				
				// TODO Auto-generated method stub
				Intent t = new Intent(MainMenuActivity.this,CreditsActivity.class);
				t.putExtra("game",idGame);
				
				startActivity(t);
			}
		});
        
        
        buttonHelp.setOnClickListener(new View.OnClickListener() {
        	 
			@Override
			public void onClick(View v) {
				
				continueMusic = true;
				
				// TODO Auto-generated method stub
				Intent t = new Intent(MainMenuActivity.this,HelpViewActivity.class);
				t.putExtra("game",idGame);
				
				startActivity(t);
			}
		});
        
        buttonBack.setOnClickListener(new View.OnClickListener() {
       	 
			@Override
			public void onClick(View v) {
				//Log.e("dotemu)","Button back click");
				finish();
			}
		});	
        

        Log.e("TAG", "ratingPrefs.getInt = " + ratingPrefs.getInt("nbPlayed", 0)%10);
        
        {
            if( (ratingPrefs.getInt("nbPlayed", 0)%10) == 2 )
            	RateApp();
        }
    }
    
    @Override
    public void onDestroy(){
    	//Log.d("dotemu", "onStop");
    	 setResult(RESULT_OK, getIntent() );
     	finish();
     	
     	MusicManager.release();
     	
     	super.onDestroy(); 
    }

	public void onPause(){
		super.onPause(); 

		if(!continueMusic)
			MusicManager.pause();
	}
	
	

	@Override
	public void onResume(){
		super.onResume(); 
		//Log.i("MainMenuActivity","onResume, p_music="+p_music);
		continueMusic = false;

		Bundle b=getIntent().getExtras();
		final String idGame=b.getString("game");

		if("gob1".equals(idGame))      
			MusicManager.start(this, MusicManager.MUSIC_GOB1);   
		else if("gob2".equals(idGame))
			MusicManager.start(this, MusicManager.MUSIC_GOB2);
		else if("gob3".equals(idGame))
			MusicManager.start(this, MusicManager.MUSIC_GOB3);
		
		MusicManager.setVolume((float)p_music/256);  
	}
    
    private static String getSizeName(Context context) {
        int screenLayout = context.getResources().getConfiguration().screenLayout;
        screenLayout &= Configuration.SCREENLAYOUT_SIZE_MASK;

        switch (screenLayout) {
       
        case Configuration.SCREENLAYOUT_SIZE_SMALL:
            return "small";
        case Configuration.SCREENLAYOUT_SIZE_NORMAL:
            return "normal";
        case Configuration.SCREENLAYOUT_SIZE_LARGE:
            return "large";
        case 4: // Configuration.SCREENLAYOUT_SIZE_XLARGE is API >= 9
            return "xlarge";
        default:
            return "undefined";
        }
    }
    
    public void ScaleImage(ImageView view) {
    		
    	
    	   Drawable drawing = view.getDrawable();
           if (drawing == null) {
               return; 
           }
           Bitmap bitmap = ((BitmapDrawable)drawing).getBitmap();

       	  
       	  int width = bitmap.getWidth();
       	  int height = bitmap.getHeight();
       	  //Log.i("dotemu","!!!!!!bitmap " + width + "," +height);
       	
       	  Display display = getWindowManager().getDefaultDisplay();
       	  Point size = new Point();
       	  display.getSize(size);
             
       	  int screen_width = size.x;
       	  int screen_height = size.y;
       	  
       	  float xScale = ((float) screen_width) / 1280 ; //pour la matrice qui double le scale
       	  float yScale = ((float) screen_height) / 720 ;
       	  //Log.i("dotemu","!!!!!!!Screen " + screen_width + "," +screen_height);
       	  //Log.i("dotemu","!!!!!!!Scale " + xScale + "," +yScale);
       	 
       	  int newWidth=(int) (width*xScale);
       	  int newHeight=(int) (height*yScale);
       	//Log.i("Test", "scaled width = " + Integer.toString(newWidth));
   	    //Log.i("Test", "scaled height = " + Integer.toString(newHeight));
       	  /* Matrix matrix = new Matrix();

       	  	matrix.postScale(xScale, yScale);
	
   	  
   	    Bitmap scaledBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
   	    width = scaledBitmap.getWidth(); 
   	    height = scaledBitmap.getHeight(); 
   	    BitmapDrawable result = new BitmapDrawable(scaledBitmap);
   	    Log.i("Test", "scaled width = " + Integer.toString(width));
   	    Log.i("Test", "scaled height = " + Integer.toString(height));

   	   */
   		Bitmap scaledBitmap=Bitmap.createScaledBitmap(bitmap, newWidth, newHeight, false);
   		BitmapDrawable result = new BitmapDrawable(this.getResources(), scaledBitmap);
   		view.setImageDrawable(result);
   		//Log.i("Test", "scaled width = " + Integer.toString(newWidth));
   	    //Log.i("Test", "scaled height = " + Integer.toString(newHeight));
   	    RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
   	    params.width = newWidth;
   	    params.height = newHeight;
   	    view.setLayoutParams(params);

   	    //Log.i("Test", "done");
    }
    


    public void setMargin(float coefbeginx,float coefbeginy,float coefendx,float coefendy,View view){
    	Display display = getWindowManager().getDefaultDisplay();
    	Point size = new Point();
    	display.getSize(size);
    	int screen_width = size.x; //display.getWidth();
    	int screen_height = size.y; //display.getHeight();
    	float margbeginX=coefbeginx*screen_width;
    	float margendX=coefendx*screen_width;
    	float  margbeginY=coefbeginy*screen_height;
    	float  margendY=coefendy*screen_height;
    	//Log.i("dotemu","!!!!!!!!!!X "+margbeginX+"Y"+margbeginY);
    	RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
    	params.setMargins((int)margbeginX,(int)margbeginY, (int)margendX,(int)margendY);

    	view.setLayoutParams(params);
    }


    /**
     * ------- Rating -------
     */
    

    public void RateApp() 
    {
    	boolean showRating = ratingPrefs.getBoolean("showRating", true);

    	if(!showRating) return;

    	AlertDialog.Builder builder = new AlertDialog.Builder(MainMenuActivity.this);
    	builder.setTitle(getString(R.string.android_rate_popup1_title))
    	.setItems(new String[] {getString(R.string.android_rate_popup1_btn1),
    			getString(R.string.android_rate_popup1_btn2),
    			getString(R.string.android_rate_popup1_btn3),
    			getString(R.string.android_rate_popup1_btn4)}, new DialogInterface.OnClickListener() {
    		public void onClick(DialogInterface dialog, int which) {
    			// The 'which' argument contains the index position
    			// of the selected item
    			switch(which)
    			{
    			// Positive answer
    			case 0:
    			case 1: 
    				AlertDialog.Builder builder2 = new AlertDialog.Builder(MainMenuActivity.this);
    				builder2.setTitle(getString(R.string.android_rate_popup2_title))
    				.setPositiveButton(getString(R.string.rate_popup_btn1), new DialogInterface.OnClickListener() {
    					public void onClick(DialogInterface dialog, int id)
    					{
    						ratingPrefs.edit().putBoolean("showRating", false).commit();
    						startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("market://details?id=" + getApplicationContext().getPackageName())));
    					}
    				})
    				.setNeutralButton(getString(R.string.rate_popup_btn2), new DialogInterface.OnClickListener() {
    					public void onClick(DialogInterface dialog, int id) {
    						ratingPrefs.edit().putBoolean("showRating", true).commit();
    					}
    				})
    				.setNegativeButton(getString(R.string.rate_popup_btn3), new DialogInterface.OnClickListener() {
    					public void onClick(DialogInterface dialog, int id) {
    						ratingPrefs.edit().putBoolean("showRating", false).commit();
    					}
    				});

    				builder2.show();
    				break;

    				// Negative answer
    			case 2:
    			case 3:
    				ratingPrefs.edit().putBoolean("showRating", false).commit();
    				break;
    			}
    		}
    	})
    	.setNegativeButton(getString(R.string.android_rate_popup1_cancel), new DialogInterface.OnClickListener() {
    		public void onClick(DialogInterface dialog, int id) {
    		}

    	});
    	builder.show();
    }


}





