
package com.dotemu.gobliiins;
import com.dotemu.gobliiins.R;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.ColorStateList;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.util.TypedValue;
import android.view.Display;
import android.view.View;
import android.webkit.WebSettings;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class SelectGameActivity extends Activity {
	 /** Called when the activity is first created. */
	private int numGob=1;
	private ImageView gob1;
    private ImageView gob2;
    private ImageView gob3;
    
    public static SelectGameActivity instance;
    //Licensing key
    public static String LICENSING_KEY;
	
	// Flurry Key
	public static String FLURRY_KEY;
	
	// Bluetooth settings
	public static String GAME_ANDROID_UUID;
	
	// ScoreLoop boolean
	public static boolean USE_SL = false;
	public static boolean USE_GOOGLE_PLAY_GAME_SERVICES = false;
	public static boolean USE_AMAZON_GAMECIRCLE = false;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.select_game_activity);
        instance=this;
        
        
        
        gob1 = (ImageView)findViewById(R.id.gobliiins);
        gob2 = (ImageView)findViewById(R.id.gobliins2);
        gob3 = (ImageView)findViewById(R.id.goblins3);
        ImageView title=(ImageView) findViewById(R.id.gobliiins_title);
        ImageView prec = (ImageView)findViewById(R.id.gauche);
        ImageView suiv = (ImageView)findViewById(R.id.droite);
        TextView copyright=(TextView) findViewById(R.id.copyright);
        
        copyright.setText("Gobliiins, Gobliins 2, Goblins 3 COPYRIGHT POLLENE. Ported on Android by DotEmu.");
        copyright.setTextColor(Color.WHITE);
        ScaleImage(gob1);
        ScaleImage(title);
        ScaleImage(gob2);
        ScaleImage(gob3);
        //Log.i("scale","scale fleche");
        ScaleImage(prec);
        ScaleImage(suiv);
        
        String sizeType=getSizeName(this);
        if("small".equals(sizeType)){
        	copyright.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 2);
	    }else if("large".equals(sizeType)){
	    	copyright.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 13);
	    }else if("xlarge".equals(sizeType)){
	    	copyright.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 17);
	    }else{		//normal
	    	copyright.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 8);
	   	}
       
        setMargin(0,(float)3.40/15,0,0,gob1);  
        setMargin(0,(float)3.40/15,0,0,gob2);
        setMargin(0,(float)3.40/15,0,0,gob3);
        setMargin(0,(float)0.5/15,0,0,title);
        setMargin((float)0.85/4,(float)7.5/15,0,0,prec);
        setMargin((float)3/4,(float)7.5/15,0,0,suiv);
        
        updateGameVisible();
        gob1.setOnClickListener(new View.OnClickListener() {
 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				launchGob();
				
			}
		});
       
        gob2.setOnClickListener(new View.OnClickListener() {
 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				launchGob();
			}
		});
        
        gob3.setOnClickListener(new View.OnClickListener() {
 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				launchGob();
			}
		});
        
        prec.setOnClickListener(new View.OnClickListener() {
        	 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				if(numGob<=1)
					numGob=3;
				else numGob--;
				updateGameVisible();
			}
		});
        suiv.setOnClickListener(new View.OnClickListener() {
       	 
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				if(numGob>=3)
					numGob=1;
				else numGob++;
				updateGameVisible();
			}
		});        
    }
    
    public void ScaleImage(ImageView view) {
		
    	
 	   Drawable drawing = view.getDrawable();
        if (drawing == null) {
        	Log.e("dotemu","Draw==NULL");
            return; 
        }
        Bitmap bitmap = ((BitmapDrawable)drawing).getBitmap();

    	  
    	  int width = bitmap.getWidth();
    	  int height = bitmap.getHeight();
    	//  Log.i("dotemu","!!!!!!bitmap " + width + "," +height);
    	
    	  Display display = getWindowManager().getDefaultDisplay();
          
    	  int screen_width = display.getWidth();
    	  int screen_height = display.getHeight();
    	  
    	  float xScale = ((float) screen_width) / 1280 ; //pour la matrice qui double le scale
    	  float yScale = ((float) screen_height) / 720 ;
    	//  Log.i("dotemu","!!!!!!!Screen " + screen_width + "," +screen_height);
    	//  Log.i("dotemu","!!!!!!!Scale " + xScale + "," +yScale);
    	 
    	  int newWidth=(int) (width*xScale);
    	  int newHeight=(int) (height*yScale);
    	//Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	  //  Log.i("Test", "scaled height = " + Integer.toString(newHeight));
    	  /* Matrix matrix = new Matrix();

    	  	matrix.postScale(xScale, yScale);
	
	  
	    Bitmap scaledBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
	    width = scaledBitmap.getWidth(); 
	    height = scaledBitmap.getHeight(); 
	    BitmapDrawable result = new BitmapDrawable(scaledBitmap);
	    Log.i("Test", "scaled width = " + Integer.toString(width));
	    Log.i("Test", "scaled height = " + Integer.toString(height));

	   */
		Bitmap scaledBitmap=Bitmap.createScaledBitmap(bitmap, newWidth, newHeight, false);
		BitmapDrawable result = new BitmapDrawable(scaledBitmap);
		view.setImageDrawable(result);
	//	Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	 //   Log.i("Test", "scaled height = " + Integer.toString(newHeight));
	    RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
	    params.width = newWidth;
	    params.height = newHeight;
	    view.setLayoutParams(params);

	  //  Log.i("Test", "done");
 }
    public void launchGob(){
    	Intent t = new Intent(SelectGameActivity.this, MainMenuActivity.class);
    	//Log.i("dotemu","numGob = "+ numGob);
    	if(numGob==1)
    		t.putExtra("game","gob1");
    	else if(numGob==2)
    		t.putExtra("game","gob2");
    	else //numGob==3
    		t.putExtra("game","gob3");
		startActivity(t);
    }
    
    public void updateGameVisible(){
    	//Log.i("dotemu","numGob = "+ numGob);
    	if(numGob==1){
    		gob1.setVisibility(View.VISIBLE);
    		gob2.setVisibility(View.GONE);
    		gob3.setVisibility(View.GONE);
    	}else if(numGob==2){
    		gob1.setVisibility(View.GONE);
    		gob2.setVisibility(View.VISIBLE);
    		gob3.setVisibility(View.GONE);
    	}else{ //numGob==3
    		gob1.setVisibility(View.GONE);
    		gob2.setVisibility(View.GONE);
    		gob3.setVisibility(View.VISIBLE);
    	}
    	
    }
 
 

    public void setMargin(float coefbeginx,float coefbeginy,float coefendx,float coefendy,View view){
    	Display display = getWindowManager().getDefaultDisplay();
		int screen_width = display.getWidth();
		int screen_height = display.getHeight();
		float margbeginX=coefbeginx*screen_width;
		float margendX=coefendx*screen_width;
		float  margbeginY=coefbeginy*screen_height;
		float  margendY=coefendy*screen_height;
	//	Log.i("dotemu","!!!!!!!!!!X "+margbeginX+"Y"+margbeginY);
		RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
	    params.setMargins((int)margbeginX,(int)margbeginY, (int)margendX,(int)margendY);
	    
	    view.setLayoutParams(params);
	}
    
    public void onStop(){
     	super.onStop(); 
     	
     	//stopService(new Intent(this, BGAudioService.class));
    }
    
    private static String getSizeName(Context context) {
        int screenLayout = context.getResources().getConfiguration().screenLayout;
        screenLayout &= Configuration.SCREENLAYOUT_SIZE_MASK;

        switch (screenLayout) {
       
        case Configuration.SCREENLAYOUT_SIZE_SMALL:
            return "small";
        case Configuration.SCREENLAYOUT_SIZE_NORMAL:
            return "normal";
        case Configuration.SCREENLAYOUT_SIZE_LARGE:
            return "large";
        case 4: // Configuration.SCREENLAYOUT_SIZE_XLARGE is API >= 9
            return "xlarge";
        default:
            return "undefined";
        }
    }
}




 