package com.dotemu.gobliiins;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Locale;
import java.util.zip.Checksum;

import com.dotemu.gobliiins.R;

import android.R.color;
import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Point;
import android.graphics.Typeface;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;
import android.util.TypedValue;
import android.view.Display;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;


public class SettingsMenuActivity extends Activity {

	int music=256;
	int sfx=256;
	int old_music;
	boolean checked=false;
	boolean continueMusic = false;
	boolean inGame = false;
	private Button buttonBack;
	private String Language;
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_settings_menu);
	//	Log.i("dotemu","onCreate settingsActivity");
		Bundle b=getIntent().getExtras();
		TextView viewMusic = (TextView) findViewById(R.id.music);
		TextView viewTitle= (TextView) findViewById(R.id.title);
		TextView viewSfx = (TextView) findViewById(R.id.sfx);
		Button buttonSave = (Button)findViewById(R.id.save);
		SeekBar barMusic=(SeekBar)findViewById(R.id.seekbar_music);
		SeekBar barSfx=(SeekBar)findViewById(R.id.seekbar_sfx);
		final CheckBox checkBoxFilter=(CheckBox) findViewById(R.id.chkFiltre);
		RelativeLayout  globalLayout = (RelativeLayout) findViewById(R.id.layout_general);
		buttonBack=(Button) findViewById(R.id.back_setting);
		
		 Typeface font = Typeface.createFromAsset(getAssets(), "fonts/8bitoperator.ttf");
	       	viewMusic.setTypeface(font,Typeface.ITALIC);
	       	viewTitle.setTypeface(font,Typeface.BOLD);
	       	viewSfx.setTypeface(font,Typeface.ITALIC);
	       	buttonSave.setTypeface(font,Typeface.ITALIC);
	       	buttonBack.setTypeface(font);
	       	checkBoxFilter.setTypeface(font);
		Language=Locale.getDefault().getLanguage();
		//Log.i("dotemu","Language = "+ Language);

		if(!"fr".equals(Language) && !"en".equals(Language))
			Language="en";

		final String idGame=b.getString("game");
		music=b.getInt("menu_sound");
		sfx=b.getInt("sfx_sound");
		checked=b.getBoolean("Checked");
		inGame = b.getBoolean("in_game");
		
		old_music=music;

		if( inGame )
		{
			continueMusic = false;
		}
		
		String sizeType=getSizeName(this);
		if("small".equals(sizeType)){

		//	Log.i("HintView","small screen");
			viewMusic.setTextSize(TypedValue.COMPLEX_UNIT_DIP,12);
			viewSfx.setTextSize(TypedValue.COMPLEX_UNIT_DIP,12);
			buttonSave.setTextSize(TypedValue.COMPLEX_UNIT_DIP,8);
			checkBoxFilter.setTextSize(TypedValue.COMPLEX_UNIT_DIP,6);
			viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,16);
			buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);
		}else if("large".equals(sizeType)){
		//	Log.i("HintView","large screen");
			viewMusic.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 20);
			viewSfx.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 20);
			buttonSave.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 20);
			checkBoxFilter.setTextSize(TypedValue.COMPLEX_UNIT_DIP,12);
			viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
			buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,17);

		}else if("xlarge".equals(sizeType)){
		//	Log.i("HintView","xlarge screen");
			viewMusic.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 32);
			viewSfx.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 32);
			buttonSave.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 28);
			checkBoxFilter.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);
			viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36);
			buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,24);


		}else{		//normal
		//	Log.i("HintView","normal screen");
			viewMusic.setTextSize(TypedValue.COMPLEX_UNIT_DIP,16 );
			viewSfx.setTextSize(TypedValue.COMPLEX_UNIT_DIP,16 );
			buttonSave.setTextSize(TypedValue.COMPLEX_UNIT_DIP,12 );
			checkBoxFilter.setTextSize(TypedValue.COMPLEX_UNIT_DIP,12);
			viewTitle.setTextSize(TypedValue.COMPLEX_UNIT_DIP,18);
			buttonBack.setTextSize(TypedValue.COMPLEX_UNIT_DIP,10);

		}
		buttonBack.setText(R.string.button_back);
		viewTitle.setTextColor(Color.YELLOW);


		viewMusic.setText(R.string.setting_texte_musique);
		viewSfx.setText(R.string.setting_texte_sfx);

		viewTitle.setText(R.string.setting_title);
		buttonSave.setText(R.string.setting_texte_sauvegarder);
		checkBoxFilter.setText(R.string.setting_texte_filtre);


		checkBoxFilter.setTextColor(Color.WHITE);
		if("gob1".equals(idGame)){
			buttonSave.setBackgroundResource(R.drawable.gob1_bgbutton);
			globalLayout.setBackgroundResource(R.drawable.gob1settingsbackground);
			buttonBack.setBackgroundResource(R.drawable.gob1_button_small);

		}else
			if("gob2".equals(idGame)){
				buttonSave.setBackgroundResource(R.drawable.gob2_bgbutton);
				globalLayout.setBackgroundResource(R.drawable.gob2settingsbackground);
				buttonBack.setBackgroundResource(R.drawable.gob2_button_small);

			}else
				if("gob3".equals(idGame)){
					buttonSave.setBackgroundResource(R.drawable.gob3_bgbutton);
					globalLayout.setBackgroundResource(R.drawable.gob3settingsbackground);
					buttonBack.setBackgroundResource(R.drawable.gob3_button_small);

				}
		/* SeekBar Barmusic=(SeekBar)findViewById(R.id.seekbarsmusic);
        SeekBar Barsfx=(SeekBar)findViewById(R.id.seekbarsfx);*/
		
		barMusic.setProgress(music);
		barSfx.setProgress(sfx);
		checkBoxFilter.setChecked(checked);
		//  ScaleImage(viewMusic);
		// ScaleImage(viewTitle);
		//ScaleImage(viewSfx);
		//ScaleImage(buttonSave);
		RelativeLayout layoutMusic = (RelativeLayout) findViewById(R.id.layoutMusic);
		setMargin((float)1.6/14,(float)8.75/12,(float)2/14,(float)2.5/12,layoutMusic);
		RelativeLayout layoutSfx = (RelativeLayout) findViewById(R.id.layoutSfx);
		setMargin((float)1.6/14,(float)9.6/12,(float)2/14,(float)0.4/12,layoutSfx);
		setMargin(0,0,0,0,viewMusic);
		setMargin(0,0,0,0,viewSfx);
		setMargin((float)6/14,0,0,0,barMusic);
		setMargin((float)6/14,0,0,0,barSfx);
		setMargin((float)1.6/14,0,0,(float)12.75/14,viewTitle);
		setMargin((float)1.6/14,(float)12.5/14,(float)9.2/14,0,buttonSave);
		setMargin((float)26/31,(float)0.5/31,(float)0.5/31,(float)27.75/31,buttonBack);
		setMargin((float)9/14,(float)10.5/12,(float)2/12,(float)0.12/12,checkBoxFilter);

		  buttonBack.setOnClickListener(new View.OnClickListener() {
		       	 
				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
					continueMusic = true;
					finish();
				}
			});
		
		barMusic.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {}

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				music=seekBar.getProgress();
				//Log.i("dotemu","MUSIC CHANGE!!!  " + music );
				MusicManager.setVolume((float)music/256);
			}
		});
		barSfx.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {}

			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				sfx=seekBar.getProgress();
			//	Log.i("dotemu","SFX CHANGE!!!");

			}
		});
		//   ScaleImageButton(btn);
		buttonSave.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				String NOTES ="settings.dat";
				File file = new File(Environment.getExternalStorageDirectory()+"/Android/data/com.dotemu.gobliiins/files/Gob/", NOTES);

				checked=checkBoxFilter.isChecked();
				try {
					file.createNewFile();
					FileWriter filewriter = new FileWriter(file,false);
					filewriter.write(Integer.toString(music)+"\n");
					filewriter.write(Integer.toString(sfx)+"\n");
					filewriter.write(Boolean.toString(checked));
					filewriter.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				Intent stats = new Intent();
				MainMenuActivity.p_music=music;
				stats.putExtra("music", music);
				stats.putExtra("sfx", sfx);
				stats.putExtra("Checked", checked);
			//	Log.e("dotemu","music = "+music+" sfx = "+sfx);
				setResult(RESULT_OK, stats );
				finish();
			}
		});

	}



	@Override
	public void onDestroy(){
	//	Log.d("dotemu", "onStop");
		setResult(RESULT_OK, getIntent() );
		
		finish();
		super.onDestroy();
	}

	private static String getSizeName(Context context) {
		int screenLayout = context.getResources().getConfiguration().screenLayout;
		screenLayout &= Configuration.SCREENLAYOUT_SIZE_MASK;

		switch (screenLayout) {

		case Configuration.SCREENLAYOUT_SIZE_SMALL:
			return "small";
		case Configuration.SCREENLAYOUT_SIZE_NORMAL:
			return "normal";
		case Configuration.SCREENLAYOUT_SIZE_LARGE:
			return "large";
		case 4: // Configuration.SCREENLAYOUT_SIZE_XLARGE is API >= 9
			return "xlarge";
		default:
			return "undefined";
		}
	}

	public void onPause(){
		super.onPause(); 

		if(!continueMusic && !inGame)
			MusicManager.pause();
	}

	@Override
	public void onResume(){
		super.onResume(); 

		if(!inGame)
		{
			continueMusic = false;

			Bundle b=getIntent().getExtras();
			final String idGame=b.getString("game");

			if("gob1".equals(idGame))      
				MusicManager.start(this, MusicManager.MUSIC_GOB1);   
			else if("gob2".equals(idGame))
				MusicManager.start(this, MusicManager.MUSIC_GOB2);
			else if("gob3".equals(idGame))
				MusicManager.start(this, MusicManager.MUSIC_GOB3);
		}
	}

	public void ScaleImage(ImageView view) {


		Drawable drawing = view.getDrawable();
		if (drawing == null) {
			return; 
		}
		Bitmap bitmap = ((BitmapDrawable)drawing).getBitmap();


		int width = bitmap.getWidth();
		int height = bitmap.getHeight();
//		Log.i("dotemu","!!!!!!bitmap " + width + "," +height);

		Display display = getWindowManager().getDefaultDisplay();


		int screen_width = display.getWidth();
		int screen_height = display.getHeight();

		float xScale = ((float) screen_width) / 480 ; //pour la matrice qui double le scale
		float yScale = ((float) screen_height) / 320 ;
	//	Log.i("dotemu","!!!!!!!Screen " + screen_width + "," +screen_height);
	//	Log.i("dotemu","!!!!!!!Scale " + xScale + "," +yScale);

		int newWidth=(int) (width*xScale);
		int newHeight=(int) (height*yScale);
	//	Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	//	Log.i("Test", "scaled height = " + Integer.toString(newHeight));
		/* Matrix matrix = new Matrix();

       	  	matrix.postScale(xScale, yScale);


   	    Bitmap scaledBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
   	    width = scaledBitmap.getWidth(); 
   	    height = scaledBitmap.getHeight(); 
   	    BitmapDrawable result = new BitmapDrawable(scaledBitmap);
   	    Log.i("Test", "scaled width = " + Integer.toString(width));
   	    Log.i("Test", "scaled height = " + Integer.toString(height));

		 */
		Bitmap scaledBitmap=Bitmap.createScaledBitmap(bitmap, newWidth, newHeight, false);
		BitmapDrawable result = new BitmapDrawable(scaledBitmap);
		view.setImageDrawable(result);
	//	Log.i("Test", "scaled width = " + Integer.toString(newWidth));
	//	Log.i("Test", "scaled height = " + Integer.toString(newHeight));
		RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
		params.width = newWidth;
		params.height = newHeight;
		view.setLayoutParams(params);

	//	Log.i("Test", "done");
	}



	public void setMargin(float coefbeginx,float coefbeginy,float coefendx,float coefendy,View view){
		Display display = getWindowManager().getDefaultDisplay();
		int screen_width = display.getWidth();
		int screen_height = display.getHeight();
		float margbeginX=coefbeginx*screen_width;
		float margendX=coefendx*screen_width;
		float  margbeginY=coefbeginy*screen_height;
		float  margendY=coefendy*screen_height;
	//	Log.i("dotemu","!!!!!!!!!!X "+margbeginX+"Y"+margbeginY);
		RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) view.getLayoutParams(); 
		params.setMargins((int)margbeginX,(int)margbeginY, (int)margendX,(int)margendY);

		view.setLayoutParams(params);
	}

	@Override
	public void onBackPressed() {
		super.onBackPressed();
		MusicManager.setVolume((float)old_music/256);
		if(!inGame)
			continueMusic = true;
	}


}





