package com.dotemu.gobliiins;

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.*;

import android.util.Log;

public class StringsLoader {
	private NodeList strings = null;
	
	public StringsLoader(String xml) {
		Document doc = null;
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        try {
            DocumentBuilder db = dbf.newDocumentBuilder();
 
            InputSource is = new InputSource();
                is.setCharacterStream(new FileReader(xml));
                doc = db.parse(is); 
 
            } catch (ParserConfigurationException e) {
                Log.e("StringsLoader Error: ", e.getMessage());
                return;
            } catch (SAXException e) {
                Log.e("StringsLoader Error: ", e.getMessage());
                return;
            } catch (IOException e) {
                Log.e("StringsLoader Error: ", e.getMessage());
                return;
            }
            
            strings = doc.getElementsByTagName("string");
    }
	
	public String getString(String str) {
		if(strings != null) {
			for(int i = 0; i < strings.getLength(); i++) {
				Node n = strings.item(i);
				Node name = n.getAttributes().getNamedItem("name");
				
				if(name != null) {
					if(name.getNodeValue().equals(str)) {
						if(n.getChildNodes().getLength() > 0) return n.getChildNodes().item(0).getNodeValue();
					}
				}
			}
		}
		
		return "Error loading ";
	}
}
