package com.dotemu.googleLicensing;

import com.dotemu.gobliiins.SelectGameActivity;

import android.R;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.util.Log;


//import com.dotemu.android.DotEmuActivity;
import com.dotemu.googleLicensing.AESObfuscator;
import com.dotemu.googleLicensing.APKExpansionPolicy;
import com.dotemu.googleLicensing.GoogleLicenseChecker;
import com.dotemu.googleLicensing.LicenseCheckerCallback;
import com.dotemu.googleLicensing.Policy;

public class GoogleLicensing {

	private static final byte[] SALT = new byte[] {
	     45, 6, -120, -60, 13, -67, -78, -43, 14, 54,
	     97, -18, 58, -28, -86, -35, 89, -110, 64, 35
	     };
	
	public final static String PL_TAG = "PlayLicensing";
	public final static boolean PL_DEBUG = true;
	
	public static final boolean enableGoogleLVL = false;
	
	private static String deviceId = BluetoothAdapter.getDefaultAdapter().getAddress();
	
	private static APKExpansionPolicy apkPolicy;
	private static APKLicenseCallback apkCB;

	public static void doCheck() {
		Log.i("GoogleLicensing","doCheck enter function" );
		if(SelectGameActivity.instance == null){Log.i("GoogleLicensing","doCheck, instance selectgameActivity==Null" ); return;}
		Log.i("GoogleLicensing","doCheck going to check" );
		GoogleLicenseChecker checker = new GoogleLicenseChecker(SelectGameActivity.instance.getApplicationContext(), new APKExpansionPolicy(SelectGameActivity.instance, new AESObfuscator(SALT, SelectGameActivity.instance.getPackageName(), deviceId)), SelectGameActivity.LICENSING_KEY);
		
		checker.checkAccess(new MyLicenseCheckerCallback(SelectGameActivity.instance));
	}
	
	// fetch APK expansion file URLs from Google Play
	public static void FetchApkPolicy(Context context) {
		if(apkPolicy == null) {
			apkPolicy = new APKExpansionPolicy(context, new AESObfuscator(SALT, context.getPackageName(), deviceId));
			//apkPolicy.resetPolicy();
			
			GoogleLicenseChecker checker = new GoogleLicenseChecker(context, apkPolicy, SelectGameActivity.LICENSING_KEY);
			apkCB = new APKLicenseCallback(context);
			checker.checkAccess(apkCB);
		}
	}
	
	// retrieve policy containing APK expansion file URLs
	public static APKExpansionPolicy GetApkPolicy() {
		synchronized(apkCB) {
			while(!apkCB.done) try { apkCB.wait(); } catch (InterruptedException e) { }
		}
		
		return apkPolicy;
	}
	
	public static void displayError(Context context) {
		new AlertDialog.Builder(context)
		.setMessage("Could not verify license status with Google Play service")
		.setNeutralButton(R.string.ok, new OnClickListener() { public void onClick(DialogInterface dialog, int which) { System.exit(0); } })
		.setCancelable(false)
		.setTitle("Error")
		.show();
	}
	
	private static class MyLicenseCheckerCallback implements LicenseCheckerCallback {
		private Context context;
		
		public MyLicenseCheckerCallback(Context context) { this.context = context; }
		
		public void allow(int reason) {
			if (PL_DEBUG) {
				Log.i(PL_TAG, String.format("application licensed (%d)", reason));
			}
 }
		public void dontAllow(int reason) { 
			if (PL_DEBUG) {
				Log.e(PL_TAG, String.format("application not licensed (%d)", reason));
			} 
			
			if (reason == Policy.NOT_LICENSED){ Log.i("Dotemu","Policy.NOT_LICENSED"); displayError(context);}
 }
		public void applicationError(int errorCode) { 
			if (PL_DEBUG) {
				Log.e(PL_TAG, String.format("application error (%d)", errorCode));
			}
			Log.i("Dotemu","ApplicationError");
			displayError(context);
 }
	}
	
	private static class APKLicenseCallback implements LicenseCheckerCallback {
		public boolean done;
		private Context context;
		
		public APKLicenseCallback(Context context) { this.context = context; }
		
		public synchronized void allow(int reason) { Log.i("APKLicenseCallBack","allow");notifyAll(); done = true; }
		public synchronized void dontAllow(int reason) { notifyAll(); displayError(context); done = true; }
		public synchronized void applicationError(int errorCode) { notifyAll(); displayError(context); done = true; }
	}
}
